//
//  GLView.h
//  ShaderExamples
//
//  Created by Brad Larson on 11/13/2010.
//

#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES2/gl.h>
#import <OpenGLES/ES2/glext.h>


@interface GLView : UIView 
{
	GLint backingWidth, backingHeight;
	EAGLContext *context;
	GLuint viewRenderbuffer, viewFramebuffer, depthRenderbuffer, msaaFramebuffer, msaaRenderbuffer, msaaDepthbuffer;

	GLuint offscreenRenderTexture;
	GLuint offscreenRenderbuffer, offscreenFramebuffer, offscreenDepthBuffer;
}

@property(readonly) GLuint offscreenRenderTexture, offscreenFramebuffer;

// OpenGL drawing

- (BOOL)createFramebuffers;
- (BOOL)presentFramebuffer;
- (void)switchToDisplayFramebuffer;
- (void)destroyFramebuffer;

@end
