/*

File: teapot.h
Abstract: Contains data necessary for rendering the teapot model.

Version: 2.1

Disclaimer: IMPORTANT:  This Apple software is supplied to you by Apple Inc.
("Apple") in consideration of your agreement to the following terms, and your
use, installation, modification or redistribution of this Apple software
constitutes acceptance of these terms.  If you do not agree with these terms,
please do not use, install, modify or redistribute this Apple software.

In consideration of your agreement to abide by the following terms, and subject
to these terms, Apple grants you a personal, non-exclusive license, under
Apple's copyrights in this original Apple software (the "Apple Software"), to
use, reproduce, modify and redistribute the Apple Software, with or without
modifications, in source and/or binary forms; provided that if you redistribute
the Apple Software in its entirety and without modifications, you must retain
this notice and the following text and disclaimers in all such redistributions
of the Apple Software.
Neither the name, trademarks, service marks or logos of Apple Inc. may be used
to endorse or promote products derived from the Apple Software without specific
prior written permission from Apple.  Except as expressly stated in this notice,
no other rights or licenses, express or implied, are granted by Apple herein,
including but not limited to any patent rights that may be infringed by your
derivative works or by other works in which the Apple Software may be
incorporated.

The Apple Software is provided by Apple on an "AS IS" basis.  APPLE MAKES NO
WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE, REGARDING THE APPLE SOFTWARE OR ITS USE AND OPERATION ALONE OR IN
COMBINATION WITH YOUR PRODUCTS.

IN NO EVENT SHALL APPLE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION, MODIFICATION AND/OR
DISTRIBUTION OF THE APPLE SOFTWARE, HOWEVER CAUSED AND WHETHER UNDER THEORY OF
CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF
APPLE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Copyright (C) 2009 Apple Inc. All Rights Reserved.

*/


#ifndef TEAPOT_H
#define TEAPOT_H

const int num_teapot_indices = 2781;
const int num_teapot_vertices = 1364;
const int num_teapot_normals = 1364;

float teapot_vertices [] = {
                            0.0663056, 0.117825, 2.10688e-008,
                            0.0672, 0.1152, 2.05994e-008,
                            0.0639726, 0.117825, 0.0178043,
                            0.0648356, 0.1152, 0.0180445,
                            0.0573666, 0.117825, 0.0336931,
                            0.0581404, 0.1152, 0.0341476,
                            0.0470769, 0.117825, 0.0470769,
                            0.047712, 0.1152, 0.047712,
                            0.033693, 0.117825, 0.0573666,
                            0.0341476, 0.1152, 0.0581404,
                            0.0178043, 0.117825, 0.0639726,
                            0.0180444, 0.1152, 0.0648356,
                            0, 0.117825, 0.0663056,
                            0, 0.1152, 0.0672,
                            0.0664444, 0.1194, 2.13504e-008,
                            0.0641066, 0.1194, 0.0178416,
                            0.0574868, 0.1194, 0.0337636,
                            0.0471755, 0.1194, 0.0471756,
                            0.0337636, 0.1194, 0.0574868,
                            0.0178416, 0.1194, 0.0641066,
                            0, 0.1194, 0.0664444,
                            0.06735, 0.119925, 2.14443e-008,
                            0.0649803, 0.119925, 0.0180847,
                            0.0582702, 0.119925, 0.0342238,
                            0.0478185, 0.119925, 0.0478185,
                            0.0342238, 0.119925, 0.0582702,
                            0.0180847, 0.119925, 0.0649803,
                            0, 0.119925, 0.06735,
                            0.0687556, 0.1194, 2.13504e-008,
                            0.0663364, 0.1194, 0.0184622,
                            0.0594863, 0.1194, 0.034938,
                            0.0488164, 0.1194, 0.0488164,
                            0.034938, 0.1194, 0.0594863,
                            0.0184621, 0.1194, 0.0663364,
                            0, 0.1194, 0.0687556,
                            0.0703944, 0.117825, 2.10688e-008,
                            0.0679176, 0.117825, 0.0189022,
                            0.0609042, 0.117825, 0.0357708,
                            0.0499801, 0.117825, 0.0499801,
                            0.0357708, 0.117825, 0.0609042,
                            0.0189022, 0.117825, 0.0679176,
                            0, 0.117825, 0.0703944,
                            0.072, 0.1152, 2.05994e-008,
                            0.0694667, 0.1152, 0.0193333,
                            0.0622933, 0.1152, 0.0365867,
                            0.05112, 0.1152, 0.05112,
                            0.0365867, 0.1152, 0.0622933,
                            0.0193333, 0.1152, 0.0694667,
                            0, 0.1152, 0.072,
                            -0.0178043, 0.117825, 0.0639726,
                            -0.0180444, 0.1152, 0.0648356,
                            -0.033693, 0.117825, 0.0573666,
                            -0.0341476, 0.1152, 0.0581404,
                            -0.0470769, 0.117825, 0.0470769,
                            -0.047712, 0.1152, 0.047712,
                            -0.0573666, 0.117825, 0.033693,
                            -0.0581404, 0.1152, 0.0341476,
                            -0.0639726, 0.117825, 0.0178043,
                            -0.0648356, 0.1152, 0.0180445,
                            -0.0663056, 0.117825, 2.10688e-008,
                            -0.0672, 0.1152, 2.05994e-008,
                            -0.0178416, 0.1194, 0.0641066,
                            -0.0337636, 0.1194, 0.0574867,
                            -0.0471756, 0.1194, 0.0471756,
                            -0.0574867, 0.1194, 0.0337636,
                            -0.0641066, 0.1194, 0.0178416,
                            -0.0664444, 0.1194, 2.13504e-008,
                            -0.0180847, 0.119925, 0.0649803,
                            -0.0342238, 0.119925, 0.0582702,
                            -0.0478185, 0.119925, 0.0478185,
                            -0.0582702, 0.119925, 0.0342238,
                            -0.0649803, 0.119925, 0.0180847,
                            -0.06735, 0.119925, 2.14443e-008,
                            0, 0.1194, 0.0687556,
                            -0.0184621, 0.1194, 0.0663364,
                            -0.034938, 0.1194, 0.0594863,
                            -0.0488164, 0.1194, 0.0488164,
                            -0.0594863, 0.1194, 0.034938,
                            -0.0663364, 0.1194, 0.0184621,
                            -0.0687556, 0.1194, 2.13504e-008,
                            0, 0.117825, 0.0703944,
                            -0.0189022, 0.117825, 0.0679176,
                            -0.0357708, 0.117825, 0.0609042,
                            -0.0499801, 0.117825, 0.0499801,
                            -0.0609042, 0.117825, 0.0357708,
                            -0.0679176, 0.117825, 0.0189022,
                            -0.0703944, 0.117825, 2.10688e-008,
                            -0.0193333, 0.1152, 0.0694667,
                            -0.0365867, 0.1152, 0.0622933,
                            -0.05112, 0.1152, 0.05112,
                            -0.0622933, 0.1152, 0.0365867,
                            -0.0694667, 0.1152, 0.0193333,
                            -0.072, 0.1152, 2.05994e-008,
                            -0.0663055, 0.117825, 2.10688e-008,
                            -0.0639726, 0.117825, -0.0178043,
                            -0.0648356, 0.1152, -0.0180444,
                            -0.0573666, 0.117825, -0.033693,
                            -0.0581404, 0.1152, -0.0341475,
                            -0.0470769, 0.117825, -0.0470769,
                            -0.047712, 0.1152, -0.047712,
                            -0.033693, 0.117825, -0.0573666,
                            -0.0341476, 0.1152, -0.0581404,
                            -0.0178043, 0.117825, -0.0639726,
                            -0.0180444, 0.1152, -0.0648356,
                            0, 0.117825, -0.0663055,
                            0, 0.1152, -0.0672,
                            -0.0664444, 0.1194, 2.13504e-008,
                            -0.0641066, 0.1194, -0.0178416,
                            -0.0574867, 0.1194, -0.0337636,
                            -0.0471756, 0.1194, -0.0471756,
                            -0.0337636, 0.1194, -0.0574868,
                            -0.0178416, 0.1194, -0.0641066,
                            0, 0.1194, -0.0664444,
                            -0.0649803, 0.119925, -0.0180847,
                            -0.0582702, 0.119925, -0.0342238,
                            -0.0478185, 0.119925, -0.0478185,
                            -0.0342238, 0.119925, -0.0582702,
                            -0.0180847, 0.119925, -0.0649803,
                            0, 0.119925, -0.06735,
                            -0.0663364, 0.1194, -0.0184621,
                            -0.0594863, 0.1194, -0.034938,
                            -0.0488164, 0.1194, -0.0488164,
                            -0.034938, 0.1194, -0.0594863,
                            -0.0184621, 0.1194, -0.0663364,
                            0, 0.1194, -0.0687556,
                            -0.0703944, 0.117825, 2.10688e-008,
                            -0.0679176, 0.117825, -0.0189022,
                            -0.0609042, 0.117825, -0.0357708,
                            -0.0499801, 0.117825, -0.0499801,
                            -0.0357708, 0.117825, -0.0609042,
                            -0.0189022, 0.117825, -0.0679176,
                            0, 0.117825, -0.0703944,
                            -0.0694667, 0.1152, -0.0193333,
                            -0.0622933, 0.1152, -0.0365867,
                            -0.05112, 0.1152, -0.05112,
                            -0.0365867, 0.1152, -0.0622933,
                            -0.0193333, 0.1152, -0.0694667,
                            0, 0.1152, -0.072,
                            0.0178043, 0.117825, -0.0639726,
                            0.0180444, 0.1152, -0.0648356,
                            0.033693, 0.117825, -0.0573666,
                            0.0341476, 0.1152, -0.0581404,
                            0.0470769, 0.117825, -0.0470769,
                            0.047712, 0.1152, -0.047712,
                            0.0573666, 0.117825, -0.033693,
                            0.0581404, 0.1152, -0.0341475,
                            0.0639726, 0.117825, -0.0178043,
                            0.0648356, 0.1152, -0.0180444,
                            0.0663055, 0.117825, 2.10688e-008,
                            0.0178416, 0.1194, -0.0641066,
                            0.0337636, 0.1194, -0.0574867,
                            0.0471756, 0.1194, -0.0471756,
                            0.0574868, 0.1194, -0.0337636,
                            0.0641066, 0.1194, -0.0178415,
                            0.0664444, 0.1194, 2.13504e-008,
                            0.0180847, 0.119925, -0.0649803,
                            0.0342238, 0.119925, -0.0582702,
                            0.0478185, 0.119925, -0.0478185,
                            0.0582702, 0.119925, -0.0342238,
                            0.0649803, 0.119925, -0.0180847,
                            0.0184621, 0.1194, -0.0663364,
                            0.034938, 0.1194, -0.0594863,
                            0.0488164, 0.1194, -0.0488164,
                            0.0594863, 0.1194, -0.034938,
                            0.0663364, 0.1194, -0.0184621,
                            0.0687556, 0.1194, 2.13504e-008,
                            0.0189022, 0.117825, -0.0679176,
                            0.0357708, 0.117825, -0.0609042,
                            0.0499801, 0.117825, -0.0499801,
                            0.0609042, 0.117825, -0.0357708,
                            0.0679176, 0.117825, -0.0189022,
                            0.0703944, 0.117825, 2.10688e-008,
                            0.0193333, 0.1152, -0.0694667,
                            0.0365867, 0.1152, -0.0622933,
                            0.05112, 0.1152, -0.05112,
                            0.0622933, 0.1152, -0.0365867,
                            0.0694667, 0.1152, -0.0193333,
                            0.0779444, 0.102617, 1.83493e-008,
                            0.075202, 0.102617, 0.0209295,
                            0.0694667, 0.1152, 0.0193333,
                            0.0674364, 0.102617, 0.0396073,
                            0.0622933, 0.1152, 0.0365867,
                            0.0553406, 0.102617, 0.0553406,
                            0.0396073, 0.102617, 0.0674364,
                            0.0365867, 0.1152, 0.0622933,
                            0.0209296, 0.102617, 0.0752019,
                            0.0193334, 0.1152, 0.0694667,
                            0, 0.102617, 0.0779444,
                            0.0835556, 0.0901333, 1.61171e-008,
                            0.0806156, 0.0901333, 0.0224362,
                            0.072291, 0.0901333, 0.0424586,
                            0.0593244, 0.0901334, 0.0593245,
                            0.0424586, 0.0901333, 0.072291,
                            0.0224362, 0.0901333, 0.0806156,
                            0, 0.0901333, 0.0835556,
                            0.0885, 0.07785, 1.39207e-008,
                            0.0853861, 0.07785, 0.0237639,
                            0.0765689, 0.07785, 0.0449711,
                            0.062835, 0.07785, 0.062835,
                            0.0449711, 0.07785, 0.0765689,
                            0.0237639, 0.07785, 0.0853861,
                            0, 0.07785, 0.0885,
                            0.0924444, 0.0658667, 1.17779e-008,
                            0.0891918, 0.0658667, 0.024823,
                            0.0799816, 0.0658667, 0.0469755,
                            0.0656356, 0.0658667, 0.0656356,
                            0.0469755, 0.0658667, 0.0799816,
                            0.0248231, 0.0658667, 0.0891918,
                            0, 0.0658667, 0.0924444,
                            0.0950556, 0.0542833, 9.7066e-009,
                            0.091711, 0.0542833, 0.0255242,
                            0.0822407, 0.0542833, 0.0483023,
                            0.0674895, 0.0542833, 0.0674895,
                            0.0483023, 0.0542833, 0.0822406,
                            0.0255242, 0.0542833, 0.091711,
                            0, 0.0542833, 0.0950556,
                            0.096, 0.0432, 7.72476e-009,
                            0.0926222, 0.0432, 0.0257778,
                            0.0830578, 0.0432, 0.0487822,
                            0.06816, 0.0432, 0.06816,
                            0.0487822, 0.0432, 0.0830578,
                            0.0257778, 0.0432, 0.0926222,
                            0, 0.0432, 0.096,
                            0, 0.102617, 0.0779444,
                            -0.0209295, 0.102617, 0.075202,
                            -0.0193333, 0.1152, 0.0694667,
                            -0.0396073, 0.102617, 0.0674364,
                            -0.0365867, 0.1152, 0.0622933,
                            -0.0553405, 0.102617, 0.0553405,
                            -0.0674364, 0.102617, 0.0396073,
                            -0.0622933, 0.1152, 0.0365867,
                            -0.075202, 0.102617, 0.0209296,
                            -0.0694667, 0.1152, 0.0193334,
                            -0.0779444, 0.102617, 1.83493e-008,
                            0, 0.0901333, 0.0835555,
                            -0.0224362, 0.0901333, 0.0806156,
                            -0.0424586, 0.0901333, 0.072291,
                            -0.0593244, 0.0901334, 0.0593244,
                            -0.072291, 0.0901334, 0.0424586,
                            -0.0806156, 0.0901333, 0.0224362,
                            -0.0835555, 0.0901333, 1.61171e-008,
                            -0.0237639, 0.07785, 0.0853861,
                            -0.0449711, 0.07785, 0.0765689,
                            -0.062835, 0.07785, 0.062835,
                            -0.0765689, 0.07785, 0.0449711,
                            -0.0853861, 0.07785, 0.0237639,
                            -0.0885, 0.07785, 1.39207e-008,
                            0, 0.0658667, 0.0924444,
                            -0.024823, 0.0658667, 0.0891918,
                            -0.0469755, 0.0658667, 0.0799816,
                            -0.0656356, 0.0658667, 0.0656356,
                            -0.0799816, 0.0658667, 0.0469755,
                            -0.0891918, 0.0658667, 0.0248231,
                            -0.0924444, 0.0658667, 1.17779e-008,
                            0, 0.0542833, 0.0950556,
                            -0.0255242, 0.0542833, 0.091711,
                            -0.0483023, 0.0542833, 0.0822407,
                            -0.0674894, 0.0542834, 0.0674894,
                            -0.0822406, 0.0542834, 0.0483023,
                            -0.091711, 0.0542833, 0.0255242,
                            -0.0950556, 0.0542833, 9.70661e-009,
                            -0.0257778, 0.0432, 0.0926222,
                            -0.0487822, 0.0432, 0.0830578,
                            -0.06816, 0.0432, 0.06816,
                            -0.0830578, 0.0432, 0.0487822,
                            -0.0926222, 0.0432, 0.0257778,
                            -0.096, 0.0432, 7.72476e-009,
                            -0.0779444, 0.102617, 1.83493e-008,
                            -0.075202, 0.102617, -0.0209295,
                            -0.0694667, 0.1152, -0.0193333,
                            -0.0674364, 0.102617, -0.0396073,
                            -0.0622933, 0.1152, -0.0365866,
                            -0.0553406, 0.102617, -0.0553406,
                            -0.0396073, 0.102617, -0.0674364,
                            -0.0365867, 0.1152, -0.0622933,
                            -0.0209296, 0.102617, -0.0752019,
                            -0.0193334, 0.1152, -0.0694667,
                            0, 0.102617, -0.0779444,
                            -0.0835556, 0.0901333, 1.61171e-008,
                            -0.0806156, 0.0901333, -0.0224362,
                            -0.072291, 0.0901333, -0.0424586,
                            -0.0593244, 0.0901333, -0.0593244,
                            -0.0424586, 0.0901333, -0.072291,
                            -0.0224362, 0.0901333, -0.0806156,
                            0, 0.0901333, -0.0835556,
                            -0.0853861, 0.07785, -0.0237639,
                            -0.0765689, 0.07785, -0.0449711,
                            -0.062835, 0.07785, -0.062835,
                            -0.0449711, 0.07785, -0.0765689,
                            -0.0237639, 0.07785, -0.0853861,
                            0, 0.07785, -0.0885,
                            -0.0924444, 0.0658666, 1.17779e-008,
                            -0.0891918, 0.0658666, -0.024823,
                            -0.0799816, 0.0658666, -0.0469755,
                            -0.0656356, 0.0658666, -0.0656356,
                            -0.0469755, 0.0658666, -0.0799816,
                            -0.0248231, 0.0658666, -0.0891918,
                            0, 0.0658666, -0.0924444,
                            -0.0950556, 0.0542833, 9.7066e-009,
                            -0.091711, 0.0542833, -0.0255242,
                            -0.0822407, 0.0542833, -0.0483023,
                            -0.0674894, 0.0542833, -0.0674894,
                            -0.0483023, 0.0542833, -0.0822407,
                            -0.0255242, 0.0542833, -0.091711,
                            0, 0.0542833, -0.0950556,
                            -0.0926222, 0.0432, -0.0257778,
                            -0.0830578, 0.0432, -0.0487822,
                            -0.06816, 0.0432, -0.06816,
                            -0.0487822, 0.0432, -0.0830578,
                            -0.0257778, 0.0432, -0.0926222,
                            0, 0.0432, -0.096,
                            0.0209295, 0.102617, -0.075202,
                            0.0193333, 0.1152, -0.0694667,
                            0.0396073, 0.102617, -0.0674364,
                            0.0365867, 0.1152, -0.0622933,
                            0.0553406, 0.102617, -0.0553406,
                            0.0674364, 0.102617, -0.0396073,
                            0.0622933, 0.1152, -0.0365867,
                            0.0752019, 0.102617, -0.0209295,
                            0.0694667, 0.1152, -0.0193333,
                            0.0779444, 0.102617, 1.83493e-008,
                            0.0224362, 0.0901333, -0.0806156,
                            0.0424586, 0.0901333, -0.072291,
                            0.0593244, 0.0901333, -0.0593244,
                            0.072291, 0.0901333, -0.0424586,
                            0.0806156, 0.0901333, -0.0224362,
                            0.0835556, 0.0901333, 1.61171e-008,
                            0.0237639, 0.07785, -0.0853861,
                            0.0449711, 0.07785, -0.0765689,
                            0.062835, 0.07785, -0.062835,
                            0.0765689, 0.07785, -0.0449711,
                            0.0853861, 0.07785, -0.0237639,
                            0.024823, 0.0658666, -0.0891918,
                            0.0469755, 0.0658666, -0.0799816,
                            0.0656356, 0.0658666, -0.0656356,
                            0.0799816, 0.0658666, -0.0469755,
                            0.0891918, 0.0658666, -0.0248231,
                            0.0924444, 0.0658666, 1.17779e-008,
                            0.0255242, 0.0542833, -0.091711,
                            0.0483023, 0.0542833, -0.0822407,
                            0.0674894, 0.0542833, -0.0674894,
                            0.0822407, 0.0542833, -0.0483023,
                            0.091711, 0.0542833, -0.0255242,
                            0.0950556, 0.0542833, 9.7066e-009,
                            0.0257778, 0.0432, -0.0926222,
                            0.0487822, 0.0432, -0.0830578,
                            0.06816, 0.0432, -0.06816,
                            0.0830578, 0.0432, -0.0487822,
                            0.0926222, 0.0432, -0.0257778,
                            0.0942222, 0.0332833, 5.95152e-009,
                            0.090907, 0.0332833, 0.0253004,
                            0.0815197, 0.0332833, 0.0478788,
                            0.0668978, 0.0332833, 0.0668978,
                            0.0478789, 0.0332833, 0.0815197,
                            0.0253004, 0.0332833, 0.090907,
                            0, 0.0332833, 0.0942222,
                            0.0897778, 0.0250667, 4.48227e-009,
                            0.0866189, 0.0250667, 0.024107,
                            0.0776744, 0.0250667, 0.0456204,
                            0.0637422, 0.0250667, 0.0637422,
                            0.0456204, 0.0250667, 0.0776744,
                            0.024107, 0.0250667, 0.0866189,
                            0, 0.0250667, 0.0897778,
                            0.084, 0.01845, 3.29912e-009,
                            0.0810445, 0.01845, 0.0225556,
                            0.0726756, 0.01845, 0.0426844,
                            0.05964, 0.01845, 0.05964,
                            0.0426845, 0.01845, 0.0726755,
                            0.0225556, 0.01845, 0.0810444,
                            0, 0.01845, 0.084,
                            0.0782222, 0.0133334, 2.38419e-009,
                            0.07547, 0.0133333, 0.0210041,
                            0.0676767, 0.0133333, 0.0397485,
                            0.0555378, 0.0133333, 0.0555378,
                            0.0397485, 0.0133333, 0.0676767,
                            0.0210041, 0.0133333, 0.07547,
                            0, 0.0133333, 0.0782222,
                            0.0737778, 0.00961668, 1.7196e-009,
                            0.0711819, 0.00961668, 0.0198107,
                            0.0638315, 0.00961668, 0.03749,
                            0.0523822, 0.00961668, 0.0523822,
                            0.0374901, 0.00961668, 0.0638314,
                            0.0198107, 0.00961668, 0.0711819,
                            0, 0.00961668, 0.0737778,
                            0.072, 0.0072, 1.28746e-009,
                            0.0694667, 0.0072, 0.0193333,
                            0.0622933, 0.00719999, 0.0365867,
                            0.05112, 0.00719999, 0.05112,
                            0.0365867, 0.00719999, 0.0622933,
                            0.0193334, 0.00719999, 0.0694667,
                            0, 0.00719999, 0.072,
                            -0.0253004, 0.0332833, 0.090907,
                            -0.0478788, 0.0332833, 0.0815197,
                            -0.0668978, 0.0332833, 0.0668978,
                            -0.0815197, 0.0332833, 0.0478789,
                            -0.090907, 0.0332833, 0.0253004,
                            -0.0942222, 0.0332833, 5.95152e-009,
                            -0.024107, 0.0250667, 0.0866189,
                            -0.0456204, 0.0250667, 0.0776744,
                            -0.0637422, 0.0250667, 0.0637422,
                            -0.0776744, 0.0250667, 0.0456204,
                            -0.0866189, 0.0250667, 0.024107,
                            -0.0897778, 0.0250667, 4.48227e-009,
                            -0.0225556, 0.01845, 0.0810445,
                            -0.0426844, 0.01845, 0.0726756,
                            -0.05964, 0.01845, 0.05964,
                            -0.0726755, 0.01845, 0.0426845,
                            -0.0810444, 0.01845, 0.0225556,
                            -0.084, 0.01845, 3.29912e-009,
                            -0.0210041, 0.0133333, 0.07547,
                            -0.0397485, 0.0133333, 0.0676767,
                            -0.0555378, 0.0133333, 0.0555378,
                            -0.0676767, 0.0133333, 0.0397485,
                            -0.07547, 0.0133333, 0.0210041,
                            -0.0782222, 0.0133334, 2.38419e-009,
                            -0.0198107, 0.00961668, 0.0711819,
                            -0.03749, 0.00961667, 0.0638315,
                            -0.0523822, 0.00961668, 0.0523822,
                            -0.0638314, 0.00961668, 0.0374901,
                            -0.0711819, 0.00961668, 0.0198107,
                            -0.0737778, 0.00961668, 1.7196e-009,
                            -0.0193333, 0.00719999, 0.0694667,
                            -0.0365867, 0.00719999, 0.0622933,
                            -0.05112, 0.00719999, 0.05112,
                            -0.0622933, 0.00719999, 0.0365867,
                            -0.0694667, 0.0072, 0.0193334,
                            -0.072, 0.0072, 1.28746e-009,
                            -0.090907, 0.0332833, -0.0253004,
                            -0.0815197, 0.0332833, -0.0478788,
                            -0.0668978, 0.0332833, -0.0668978,
                            -0.0478789, 0.0332833, -0.0815197,
                            -0.0253004, 0.0332833, -0.090907,
                            0, 0.0332833, -0.0942222,
                            -0.0866189, 0.0250667, -0.024107,
                            -0.0776744, 0.0250667, -0.0456204,
                            -0.0637422, 0.0250667, -0.0637422,
                            -0.0456204, 0.0250667, -0.0776744,
                            -0.024107, 0.0250667, -0.0866189,
                            0, 0.0250667, -0.0897778,
                            -0.0810445, 0.01845, -0.0225556,
                            -0.0726756, 0.01845, -0.0426844,
                            -0.05964, 0.01845, -0.05964,
                            -0.0426845, 0.01845, -0.0726755,
                            -0.0225556, 0.01845, -0.0810444,
                            0, 0.01845, -0.084,
                            -0.07547, 0.0133334, -0.0210041,
                            -0.0676767, 0.0133334, -0.0397485,
                            -0.0555378, 0.0133334, -0.0555378,
                            -0.0397485, 0.0133334, -0.0676767,
                            -0.0210041, 0.0133334, -0.07547,
                            0, 0.0133334, -0.0782222,
                            -0.0711819, 0.00961669, -0.0198107,
                            -0.0638315, 0.00961669, -0.03749,
                            -0.0523822, 0.00961669, -0.0523822,
                            -0.0374901, 0.00961669, -0.0638314,
                            -0.0198107, 0.00961669, -0.0711819,
                            0, 0.00961669, -0.0737778,
                            -0.0694667, 0.0072, -0.0193333,
                            -0.0622933, 0.00720001, -0.0365867,
                            -0.05112, 0.00720001, -0.05112,
                            -0.0365867, 0.00720001, -0.0622933,
                            -0.0193334, 0.00720001, -0.0694667,
                            0, 0.00720001, -0.072,
                            0.0253004, 0.0332833, -0.090907,
                            0.0478788, 0.0332833, -0.0815197,
                            0.0668978, 0.0332833, -0.0668978,
                            0.0815197, 0.0332833, -0.0478789,
                            0.090907, 0.0332833, -0.0253004,
                            0.024107, 0.0250667, -0.0866189,
                            0.0456204, 0.0250667, -0.0776744,
                            0.0637422, 0.0250667, -0.0637422,
                            0.0776744, 0.0250667, -0.0456204,
                            0.0866189, 0.0250667, -0.024107,
                            0.0225556, 0.01845, -0.0810445,
                            0.0426844, 0.01845, -0.0726756,
                            0.05964, 0.01845, -0.05964,
                            0.0726755, 0.01845, -0.0426845,
                            0.0810444, 0.01845, -0.0225556,
                            0.0210041, 0.0133334, -0.07547,
                            0.0397485, 0.0133334, -0.0676767,
                            0.0555378, 0.0133334, -0.0555378,
                            0.0676767, 0.0133334, -0.0397485,
                            0.07547, 0.0133334, -0.0210041,
                            0.0198107, 0.00961669, -0.0711819,
                            0.03749, 0.00961669, -0.0638315,
                            0.0523822, 0.00961669, -0.0523822,
                            0.0638314, 0.00961669, -0.0374901,
                            0.0711819, 0.00961668, -0.0198107,
                            0.0193333, 0.00720001, -0.0694667,
                            0.0365867, 0.00720001, -0.0622933,
                            0.05112, 0.00720001, -0.05112,
                            0.0622933, 0.00720001, -0.0365867,
                            0.0694667, 0.0072, -0.0193334,
                            -0.0923778, 0.09715, 1.73718e-008,
                            -0.0768, 0.0972, 1.73807e-008,
                            -0.0924979, 0.0979463, 0.00600001,
                            -0.0764444, 0.098, 0.00600001,
                            -0.0927984, 0.099937, 0.00960001,
                            -0.0755556, 0.1, 0.00960001,
                            -0.0931889, 0.102525, 0.0108,
                            -0.0744, 0.1026, 0.0108,
                            -0.0935794, 0.105113, 0.0096,
                            -0.0732444, 0.1052, 0.0096,
                            -0.0938798, 0.107104, 0.006,
                            -0.0723556, 0.1072, 0.006,
                            -0.094, 0.1079, 1.9294e-008,
                            -0.072, 0.108, 1.93119e-008,
                            -0.105422, 0.0968, 1.73092e-008,
                            -0.105909, 0.0975704, 0.00600001,
                            -0.107128, 0.0994963, 0.00960001,
                            -0.108711, 0.102, 0.0108,
                            -0.110295, 0.104504, 0.0096,
                            -0.111513, 0.10643, 0.006,
                            -0.112, 0.1072, 1.91688e-008,
                            -0.1158, 0.09585, 1.71393e-008,
                            -0.116556, 0.09655, 0.00600001,
                            -0.118444, 0.0983, 0.00960001,
                            -0.1209, 0.100575, 0.0108,
                            -0.123356, 0.10285, 0.0096,
                            -0.125244, 0.1046, 0.006,
                            -0.126, 0.1053, 1.88291e-008,
                            -0.123378, 0.094, 1.68085e-008,
                            -0.124313, 0.094563, 0.00600001,
                            -0.12665, 0.0959704, 0.00960001,
                            -0.129689, 0.0978, 0.0108,
                            -0.132728, 0.0996296, 0.0096,
                            -0.135065, 0.101037, 0.006,
                            -0.136, 0.1016, 1.81675e-008,
                            -0.128022, 0.09095, 1.62631e-008,
                            -0.129058, 0.091287, 0.00600001,
                            -0.131646, 0.0921296, 0.00960001,
                            -0.135011, 0.093225, 0.0108,
                            -0.138376, 0.0943204, 0.0096,
                            -0.140965, 0.095163, 0.006,
                            -0.142, 0.0955, 1.70767e-008,
                            -0.1296, 0.0864, 1.54495e-008,
                            -0.130667, 0.0864, 0.00600001,
                            -0.133333, 0.0864, 0.00960001,
                            -0.1368, 0.0864, 0.0108,
                            -0.140267, 0.0864, 0.0096,
                            -0.142933, 0.0864, 0.006,
                            -0.144, 0.0864, 1.54495e-008,
                            -0.0938798, 0.107104, -0.00599999,
                            -0.0723556, 0.1072, -0.00599999,
                            -0.0935794, 0.105113, -0.0096,
                            -0.0732444, 0.1052, -0.0096,
                            -0.0931889, 0.102525, -0.0108,
                            -0.0744, 0.1026, -0.0108,
                            -0.0927983, 0.099937, -0.00959999,
                            -0.0755556, 0.1, -0.00959999,
                            -0.0924979, 0.0979463, -0.00599998,
                            -0.0764444, 0.098, -0.00599998,
                            -0.0923778, 0.09715, 1.73718e-008,
                            -0.112, 0.1072, 1.91688e-008,
                            -0.111513, 0.10643, -0.00599999,
                            -0.110295, 0.104504, -0.00959999,
                            -0.108711, 0.102, -0.0108,
                            -0.107128, 0.0994963, -0.00959999,
                            -0.105909, 0.0975704, -0.00599998,
                            -0.105422, 0.0968, 1.73092e-008,
                            -0.125244, 0.1046, -0.00599999,
                            -0.123356, 0.10285, -0.0096,
                            -0.1209, 0.100575, -0.0108,
                            -0.118444, 0.0983, -0.00959999,
                            -0.116556, 0.09655, -0.00599998,
                            -0.136, 0.1016, 1.81675e-008,
                            -0.135065, 0.101037, -0.00599999,
                            -0.132728, 0.0996296, -0.0096,
                            -0.129689, 0.0978, -0.0108,
                            -0.12665, 0.0959704, -0.00959999,
                            -0.124313, 0.094563, -0.00599998,
                            -0.123378, 0.094, 1.68085e-008,
                            -0.142, 0.0955, 1.70767e-008,
                            -0.140965, 0.095163, -0.00599999,
                            -0.138376, 0.0943204, -0.0096,
                            -0.135011, 0.093225, -0.0108,
                            -0.131646, 0.0921296, -0.00959999,
                            -0.129058, 0.091287, -0.00599998,
                            -0.128022, 0.09095, 1.62631e-008,
                            -0.142933, 0.0864, -0.00599999,
                            -0.140267, 0.0864, -0.0096,
                            -0.1368, 0.0864, -0.0108,
                            -0.133333, 0.0864, -0.00959999,
                            -0.130667, 0.0864, -0.00599998,
                            -0.128778, 0.0802, 1.43409e-008,
                            -0.129801, 0.079871, 0.00600001,
                            -0.132358, 0.0790484, 0.00960001,
                            -0.135683, 0.0779792, 0.0108,
                            -0.139008, 0.0769099, 0.0096,
                            -0.141566, 0.0760873, 0.006,
                            -0.142589, 0.0757583, 1.35466e-008,
                            -0.126222, 0.0728, 1.30176e-008,
                            -0.127118, 0.0722568, 0.00600001,
                            -0.129356, 0.0708988, 0.00960001,
                            -0.132267, 0.0691333, 0.0108,
                            -0.135177, 0.0673679, 0.0096,
                            -0.137416, 0.0660099, 0.00599999,
                            -0.138311, 0.0654667, 1.17063e-008,
                            -0.1218, 0.0648, 1.15871e-008,
                            -0.122489, 0.0641167, 0.00600001,
                            -0.124211, 0.0624083, 0.00960001,
                            -0.12645, 0.0601875, 0.0108,
                            -0.128689, 0.0579667, 0.0096,
                            -0.130411, 0.0562583, 0.00599999,
                            -0.1311, 0.055575, 9.93757e-009,
                            -0.115378, 0.0568, 1.01566e-008,
                            -0.115786, 0.0560099, 0.00600001,
                            -0.116807, 0.0540345, 0.0096,
                            -0.118133, 0.0514667, 0.0108,
                            -0.11946, 0.0488987, 0.0096,
                            -0.120481, 0.0469234, 0.00599999,
                            -0.120889, 0.0461333, 8.24927e-009,
                            -0.106822, 0.0494, 8.8334e-009,
                            -0.106881, 0.0484957, 0.00600001,
                            -0.107027, 0.0462349, 0.00960001,
                            -0.107217, 0.0432958, 0.0108,
                            -0.107407, 0.0403568, 0.0096,
                            -0.107553, 0.038096, 0.00599999,
                            -0.107611, 0.0371916, 6.65038e-009,
                            -0.0956444, 0.0421333, 0.00600001,
                            -0.0947556, 0.0394667, 0.0096,
                            -0.0936, 0.036, 0.0108,
                            -0.0924444, 0.0325333, 0.0096,
                            -0.0915556, 0.0298667, 0.00599999,
                            -0.0912, 0.0288, 5.14984e-009,
                            -0.141566, 0.0760873, -0.00599999,
                            -0.139008, 0.0769099, -0.0096,
                            -0.135683, 0.0779792, -0.0108,
                            -0.132358, 0.0790484, -0.00959999,
                            -0.129801, 0.079871, -0.00599998,
                            -0.137416, 0.0660099, -0.006,
                            -0.135177, 0.0673679, -0.0096,
                            -0.132267, 0.0691333, -0.0108,
                            -0.129356, 0.0708988, -0.00959999,
                            -0.127118, 0.0722568, -0.00599998,
                            -0.130411, 0.0562583, -0.006,
                            -0.128689, 0.0579667, -0.0096,
                            -0.12645, 0.0601875, -0.0108,
                            -0.124211, 0.0624083, -0.00959999,
                            -0.122489, 0.0641167, -0.00599998,
                            -0.120481, 0.0469234, -0.006,
                            -0.11946, 0.0488988, -0.0096,
                            -0.118133, 0.0514667, -0.0108,
                            -0.116807, 0.0540346, -0.00959999,
                            -0.115786, 0.0560099, -0.00599998,
                            -0.107553, 0.038096, -0.006,
                            -0.107407, 0.0403568, -0.0096,
                            -0.107217, 0.0432958, -0.0108,
                            -0.107027, 0.0462349, -0.00959999,
                            -0.106881, 0.0484957, -0.00599998,
                            -0.0915556, 0.0298667, -0.006,
                            -0.0924444, 0.0325333, -0.0096,
                            -0.0936, 0.036, -0.0108,
                            -0.0947556, 0.0394667, -0.00959999,
                            -0.0956445, 0.0421333, -0.00599998,
                            0.0988222, 0.0708667, 1.2672e-008,
                            0.0816, 0.0684, 1.22309e-008,
                            0.0994741, 0.0684099, 0.0125926,
                            0.0816, 0.0654667, 0.0132,
                            0.101104, 0.0622679, 0.0201482,
                            0.0816, 0.0581333, 0.02112,
                            0.103222, 0.0542833, 0.0226667,
                            0.0816, 0.0486, 0.02376,
                            0.105341, 0.0462987, 0.0201481,
                            0.0816, 0.0390666, 0.02112,
                            0.10697, 0.0401568, 0.0125926,
                            0.0816, 0.0317333, 0.0132,
                            0.107622, 0.0377, 6.74128e-009,
                            0.0816, 0.0288, 5.14984e-009,
                            0.108978, 0.0773333, 1.38283e-008,
                            0.109926, 0.0754568, 0.0110741,
                            0.112296, 0.0707654, 0.0177185,
                            0.115378, 0.0646667, 0.0199333,
                            0.118459, 0.0585679, 0.0177185,
                            0.12083, 0.0538765, 0.0110741,
                            0.121778, 0.052, 9.29832e-009,
                            0.1146, 0.0864, 1.54495e-008,
                            0.115667, 0.0851333, 0.00910001,
                            0.118333, 0.0819667, 0.01456,
                            0.1218, 0.07785, 0.01638,
                            0.125267, 0.0737333, 0.01456,
                            0.127933, 0.0705667, 0.00909999,
                            0.129, 0.0693, 1.23918e-008,
                            0.118222, 0.0966667, 1.72853e-008,
                            0.119407, 0.0959654, 0.00712594,
                            0.12237, 0.0942123, 0.0114015,
                            0.126222, 0.0919333, 0.0128267,
                            0.130074, 0.0896543, 0.0114015,
                            0.133037, 0.0879012, 0.00712592,
                            0.134222, 0.0872, 1.55926e-008,
                            0.122378, 0.106733, 1.90854e-008,
                            0.123859, 0.106479, 0.00560742,
                            0.127563, 0.105843, 0.00897186,
                            0.132378, 0.105017, 0.0100933,
                            0.137193, 0.10419, 0.00897185,
                            0.140896, 0.103554, 0.00560741,
                            0.142378, 0.1033, 1.84715e-008,
                            0.1296, 0.1152, 2.05994e-008,
                            0.131733, 0.1152, 0.00500001,
                            0.137067, 0.1152, 0.00800001,
                            0.144, 0.1152, 0.00900001,
                            0.150933, 0.1152, 0.008,
                            0.156267, 0.1152, 0.005,
                            0.1584, 0.1152, 2.05994e-008,
                            0.107622, 0.0377, 6.74128e-009,
                            0.10697, 0.0401568, -0.0125926,
                            0.0816, 0.0317333, -0.0132,
                            0.105341, 0.0462988, -0.0201482,
                            0.0816, 0.0390667, -0.02112,
                            0.103222, 0.0542833, -0.0226667,
                            0.0816, 0.0486, -0.02376,
                            0.101104, 0.0622679, -0.0201481,
                            0.0816, 0.0581334, -0.02112,
                            0.0994741, 0.0684099, -0.0125926,
                            0.0816, 0.0654667, -0.0132,
                            0.0988222, 0.0708667, 1.2672e-008,
                            0.121778, 0.052, 9.29832e-009,
                            0.12083, 0.0538765, -0.0110741,
                            0.118459, 0.0585679, -0.0177185,
                            0.115378, 0.0646667, -0.0199333,
                            0.112296, 0.0707654, -0.0177185,
                            0.109926, 0.0754568, -0.011074,
                            0.127933, 0.0705667, -0.0091,
                            0.125267, 0.0737333, -0.01456,
                            0.1218, 0.07785, -0.01638,
                            0.118333, 0.0819667, -0.01456,
                            0.115667, 0.0851333, -0.00909997,
                            0.134222, 0.0872, 1.55926e-008,
                            0.133037, 0.0879012, -0.00712592,
                            0.130074, 0.0896543, -0.0114015,
                            0.126222, 0.0919333, -0.0128267,
                            0.12237, 0.0942123, -0.0114015,
                            0.119407, 0.0959654, -0.0071259,
                            0.118222, 0.0966667, 1.72853e-008,
                            0.142378, 0.1033, 1.84715e-008,
                            0.140896, 0.103554, -0.0056074,
                            0.137193, 0.10419, -0.00897185,
                            0.132378, 0.105017, -0.0100933,
                            0.127563, 0.105843, -0.00897184,
                            0.123859, 0.106479, -0.00560739,
                            0.122378, 0.106733, 1.90854e-008,
                            0.156267, 0.1152, -0.00499999,
                            0.150933, 0.1152, -0.00799999,
                            0.144, 0.1152, -0.00899999,
                            0.137067, 0.1152, -0.00799999,
                            0.131733, 0.1152, -0.00499998,
                            0.131956, 0.1167, 2.08676e-008,
                            0.134228, 0.116732, 0.00485187,
                            0.139908, 0.116813, 0.00776297,
                            0.147292, 0.116919, 0.00873334,
                            0.154676, 0.117024, 0.00776297,
                            0.160356, 0.117105, 0.00485185,
                            0.162628, 0.117137, 2.09458e-008,
                            0.134044, 0.1176, 2.10285e-008,
                            0.136309, 0.117659, 0.0044815,
                            0.141972, 0.117807, 0.00717038,
                            0.149333, 0.118, 0.00806668,
                            0.156695, 0.118193, 0.00717038,
                            0.162357, 0.118341, 0.00448149,
                            0.164622, 0.1184, 2.11716e-008,
                            0.1356, 0.1179, 2.10822e-008,
                            0.137744, 0.117975, 0.00400002,
                            0.143106, 0.118162, 0.00640002,
                            0.150075, 0.118406, 0.00720001,
                            0.157044, 0.11865, 0.00640001,
                            0.162406, 0.118838, 0.00400001,
                            0.16455, 0.118912, 2.12632e-008,
                            0.136356, 0.1176, 2.10285e-008,
                            0.138298, 0.117674, 0.00351854,
                            0.143154, 0.117859, 0.00562965,
                            0.149467, 0.1181, 0.00633335,
                            0.155779, 0.118341, 0.00562964,
                            0.160635, 0.118526, 0.00351853,
                            0.162578, 0.1186, 2.12074e-008,
                            0.136044, 0.1167, 2.08676e-008,
                            0.137735, 0.116751, 0.00314817,
                            0.141963, 0.116878, 0.00503706,
                            0.147458, 0.117044, 0.00566668,
                            0.152954, 0.117209, 0.00503705,
                            0.157181, 0.117337, 0.00314816,
                            0.158872, 0.117387, 2.09906e-008,
                            0.1344, 0.1152, 2.05994e-008,
                            0.135822, 0.1152, 0.00300002,
                            0.139378, 0.1152, 0.00480002,
                            0.144, 0.1152, 0.00540002,
                            0.148622, 0.1152, 0.00480002,
                            0.152178, 0.1152, 0.00300001,
                            0.1536, 0.1152, 2.05994e-008,
                            0.160356, 0.117105, -0.00485184,
                            0.154676, 0.117024, -0.00776296,
                            0.147292, 0.116919, -0.00873333,
                            0.139908, 0.116813, -0.00776295,
                            0.134228, 0.116732, -0.00485183,
                            0.162357, 0.118341, -0.00448147,
                            0.156695, 0.118193, -0.00717036,
                            0.149333, 0.118, -0.00806666,
                            0.141972, 0.117807, -0.00717036,
                            0.136309, 0.117659, -0.00448146,
                            0.162406, 0.118837, -0.00399998,
                            0.157044, 0.11865, -0.00639999,
                            0.150075, 0.118406, -0.00719999,
                            0.143106, 0.118162, -0.00639998,
                            0.137744, 0.117975, -0.00399998,
                            0.160635, 0.118526, -0.0035185,
                            0.155779, 0.118341, -0.00562961,
                            0.149467, 0.1181, -0.00633332,
                            0.143154, 0.117859, -0.00562961,
                            0.138298, 0.117674, -0.00351849,
                            0.157181, 0.117337, -0.00314813,
                            0.152954, 0.117209, -0.00503702,
                            0.147458, 0.117044, -0.00566665,
                            0.141963, 0.116878, -0.00503701,
                            0.137735, 0.116751, -0.00314812,
                            0.152178, 0.1152, -0.00299998,
                            0.148622, 0.1152, -0.00479998,
                            0.144, 0.1152, -0.00539998,
                            0.139378, 0.1152, -0.00479998,
                            0.135822, 0.1152, -0.00299997,
                            0.0133778, 0.1501, 2.684e-008,
                            0, 0.1512, 2.70367e-008,
                            0.0129094, 0.1501, 0.00360378,
                            0, 0.1512, 2.70367e-008,
                            0.0115817, 0.1501, 0.00681272,
                            0, 0.1512, 2.70367e-008,
                            0.00951072, 0.1501, 0.00951074,
                            0.00681272, 0.1501, 0.0115817,
                            0.00360377, 0.1501, 0.0129094,
                            0, 0.1501, 0.0133778,
                            0.0174222, 0.1472, 2.63214e-008,
                            0.0168122, 0.1472, 0.00469302,
                            0.0150829, 0.1472, 0.00887204,
                            0.0123858, 0.1472, 0.0123858,
                            0.00887205, 0.1472, 0.0150829,
                            0.00469303, 0.1472, 0.0168122,
                            0, 0.1472, 0.0174222,
                            0.0156, 0.1431, 2.55883e-008,
                            0.0150536, 0.1431, 0.00420141,
                            0.0135049, 0.1431, 0.00794312,
                            0.0110895, 0.1431, 0.0110895,
                            0.00794312, 0.1431, 0.0135049,
                            0.00420141, 0.1431, 0.0150536,
                            0, 0.1431, 0.0156,
                            0.0113778, 0.1384, 2.47478e-008,
                            0.0109789, 0.1384, 0.00306257,
                            0.00984863, 0.1384, 0.00579109,
                            0.00808622, 0.1384, 0.00808624,
                            0.00579109, 0.1384, 0.00984864,
                            0.00306257, 0.1384, 0.0109789,
                            0, 0.1384, 0.0113778,
                            0.00822222, 0.1337, 2.39074e-008,
                            0.00793338, 0.1337, 0.00221015,
                            0.00711523, 0.1337, 0.00418109,
                            0.00584028, 0.1337, 0.0058403,
                            0.00418108, 0.1337, 0.00711524,
                            0.00221014, 0.1337, 0.0079334,
                            0, 0.1337, 0.00822224,
                            0.0096, 0.1296, 2.31743e-008,
                            0.00926222, 0.1296, 0.0025778,
                            0.00830578, 0.1296, 0.00487824,
                            0.006816, 0.1296, 0.00681602,
                            0.00487823, 0.1296, 0.00830579,
                            0.00257779, 0.1296, 0.00926224,
                            0, 0.1296, 0.00960002,
                            0, 0.1501, 0.0133778,
                            -0.00360375, 0.1501, 0.0129094,
                            -0.0068127, 0.1501, 0.0115817,
                            -0.00951072, 0.1501, 0.00951074,
                            -0.0115817, 0.1501, 0.00681274,
                            -0.0129094, 0.1501, 0.00360379,
                            -0.0133778, 0.1501, 2.684e-008,
                            0, 0.1472, 0.0174222,
                            -0.004693, 0.1472, 0.0168122,
                            -0.00887203, 0.1472, 0.0150829,
                            -0.0123858, 0.1472, 0.0123858,
                            -0.0150829, 0.1472, 0.00887207,
                            -0.0168122, 0.1472, 0.00469305,
                            -0.0174222, 0.1472, 2.63214e-008,
                            -0.00420139, 0.1431, 0.0150536,
                            -0.0079431, 0.1431, 0.0135049,
                            -0.0110895, 0.1431, 0.0110895,
                            -0.0135049, 0.1431, 0.00794314,
                            -0.0150536, 0.1431, 0.00420143,
                            -0.0156, 0.1431, 2.55883e-008,
                            0, 0.1384, 0.0113778,
                            -0.00306255, 0.1384, 0.010979,
                            -0.00579108, 0.1384, 0.00984865,
                            -0.00808623, 0.1384, 0.00808624,
                            -0.00984862, 0.1384, 0.00579111,
                            -0.0109789, 0.1384, 0.00306259,
                            -0.0113778, 0.1384, 2.47478e-008,
                            0, 0.1337, 0.00822224,
                            -0.00221013, 0.1337, 0.00793341,
                            -0.00418107, 0.1337, 0.00711525,
                            -0.00584028, 0.1337, 0.0058403,
                            -0.00711522, 0.1337, 0.0041811,
                            -0.00793338, 0.1337, 0.00221017,
                            -0.00822222, 0.1337, 2.39074e-008,
                            -0.00257778, 0.1296, 0.00926224,
                            -0.00487822, 0.1296, 0.0083058,
                            -0.006816, 0.1296, 0.00681602,
                            -0.00830577, 0.1296, 0.00487825,
                            -0.00926222, 0.1296, 0.00257781,
                            -0.0096, 0.1296, 2.31743e-008,
                            -0.0133778, 0.1501, 2.684e-008,
                            -0.0129094, 0.1501, -0.00360373,
                            -0.0115817, 0.1501, -0.00681268,
                            -0.00951073, 0.1501, -0.00951071,
                            -0.00681272, 0.1501, -0.0115816,
                            -0.00360377, 0.1501, -0.0129094,
                            0, 0.1501, -0.0133778,
                            -0.0174222, 0.1472, 2.63214e-008,
                            -0.0168122, 0.1472, -0.00469298,
                            -0.0150829, 0.1472, -0.00887201,
                            -0.0123858, 0.1472, -0.0123858,
                            -0.00887205, 0.1472, -0.0150829,
                            -0.00469303, 0.1472, -0.0168122,
                            0, 0.1472, -0.0174222,
                            -0.0150536, 0.1431, -0.00420136,
                            -0.0135049, 0.1431, -0.00794309,
                            -0.0110895, 0.1431, -0.0110895,
                            -0.00794312, 0.1431, -0.0135049,
                            -0.00420141, 0.1431, -0.0150536,
                            0, 0.1431, -0.0156,
                            -0.0113778, 0.1384, 2.47478e-008,
                            -0.0109789, 0.1384, -0.00306252,
                            -0.00984862, 0.1384, -0.00579105,
                            -0.00808622, 0.1384, -0.0080862,
                            -0.00579108, 0.1384, -0.0098486,
                            -0.00306256, 0.1384, -0.0109789,
                            0, 0.1384, -0.0113778,
                            -0.00822222, 0.1337, 2.39074e-008,
                            -0.00793338, 0.1337, -0.00221011,
                            -0.00711523, 0.1337, -0.00418104,
                            -0.00584028, 0.1337, -0.00584025,
                            -0.00418108, 0.1337, -0.0071152,
                            -0.00221014, 0.1337, -0.00793336,
                            0, 0.1337, -0.0082222,
                            -0.00926222, 0.1296, -0.00257775,
                            -0.00830578, 0.1296, -0.0048782,
                            -0.006816, 0.1296, -0.00681598,
                            -0.00487823, 0.1296, -0.00830575,
                            -0.00257779, 0.1296, -0.0092622,
                            0, 0.1296, -0.00959998,
                            0.00360375, 0.1501, -0.0129094,
                            0.0068127, 0.1501, -0.0115817,
                            0.00951073, 0.1501, -0.00951071,
                            0.0115817, 0.1501, -0.0068127,
                            0.0129094, 0.1501, -0.00360375,
                            0.0133778, 0.1501, 2.684e-008,
                            0.004693, 0.1472, -0.0168122,
                            0.00887203, 0.1472, -0.0150829,
                            0.0123858, 0.1472, -0.0123858,
                            0.0150829, 0.1472, -0.00887203,
                            0.0168122, 0.1472, -0.004693,
                            0.0174222, 0.1472, 2.63214e-008,
                            0.00420139, 0.1431, -0.0150536,
                            0.0079431, 0.1431, -0.0135049,
                            0.0110895, 0.1431, -0.0110895,
                            0.0135049, 0.1431, -0.00794311,
                            0.0150536, 0.1431, -0.00420139,
                            0.00306255, 0.1384, -0.0109789,
                            0.00579107, 0.1384, -0.0098486,
                            0.00808622, 0.1384, -0.0080862,
                            0.00984861, 0.1384, -0.00579106,
                            0.0109789, 0.1384, -0.00306254,
                            0.0113778, 0.1384, 2.47478e-008,
                            0.00221013, 0.1337, -0.00793336,
                            0.00418106, 0.1337, -0.00711521,
                            0.00584028, 0.1337, -0.00584025,
                            0.00711522, 0.1337, -0.00418105,
                            0.00793338, 0.1337, -0.00221012,
                            0.00822222, 0.1337, 2.39074e-008,
                            0.00257778, 0.1296, -0.0092622,
                            0.00487822, 0.1296, -0.00830576,
                            0.006816, 0.1296, -0.00681598,
                            0.00830577, 0.1296, -0.00487821,
                            0.00926222, 0.1296, -0.00257777,
                            0.0168444, 0.126533, 2.26259e-008,
                            0.0162518, 0.126533, 0.00452306,
                            0.0145736, 0.126533, 0.00855948,
                            0.0119595, 0.126533, 0.0119596,
                            0.00855948, 0.126533, 0.0145736,
                            0.00452306, 0.126533, 0.0162518,
                            0, 0.126533, 0.0168444,
                            0.0275555, 0.124267, 2.22206e-008,
                            0.026586, 0.124267, 0.00739918,
                            0.0238406, 0.124267, 0.0140023,
                            0.0195644, 0.124267, 0.0195644,
                            0.0140023, 0.124267, 0.0238406,
                            0.0073992, 0.124267, 0.026586,
                            0, 0.124267, 0.0275555,
                            0.0396, 0.1224, 2.18868e-008,
                            0.0382067, 0.1224, 0.0106333,
                            0.0342613, 0.1224, 0.0201227,
                            0.028116, 0.1224, 0.028116,
                            0.0201227, 0.1224, 0.0342613,
                            0.0106334, 0.1224, 0.0382067,
                            0, 0.1224, 0.0396,
                            0.0508444, 0.120533, 2.1553e-008,
                            0.0490554, 0.120533, 0.0136527,
                            0.0439898, 0.120533, 0.0258365,
                            0.0360995, 0.120533, 0.0360995,
                            0.0258365, 0.120533, 0.0439898,
                            0.0136527, 0.120533, 0.0490554,
                            0, 0.120533, 0.0508444,
                            0.0591555, 0.118267, 2.11477e-008,
                            0.0570741, 0.118267, 0.0158844,
                            0.0511805, 0.118267, 0.0300598,
                            0.0420004, 0.118267, 0.0420004,
                            0.0300598, 0.118267, 0.0511805,
                            0.0158844, 0.118267, 0.0570741,
                            0, 0.118267, 0.0591555,
                            0.0624, 0.1152, 2.05994e-008,
                            0.0602044, 0.1152, 0.0167556,
                            0.0539876, 0.1152, 0.0317084,
                            0.044304, 0.1152, 0.044304,
                            0.0317085, 0.1152, 0.0539875,
                            0.0167556, 0.1152, 0.0602044,
                            0, 0.1152, 0.0624,
                            -0.00452304, 0.126533, 0.0162518,
                            -0.00855946, 0.126533, 0.0145736,
                            -0.0119595, 0.126533, 0.0119596,
                            -0.0145735, 0.126533, 0.0085595,
                            -0.0162518, 0.126533, 0.00452308,
                            -0.0168444, 0.126533, 2.26259e-008,
                            -0.00739916, 0.124267, 0.026586,
                            -0.0140023, 0.124267, 0.0238407,
                            -0.0195644, 0.124267, 0.0195644,
                            -0.0238406, 0.124267, 0.0140023,
                            -0.026586, 0.124267, 0.00739922,
                            -0.0275555, 0.124267, 2.22206e-008,
                            -0.0106333, 0.1224, 0.0382067,
                            -0.0201227, 0.1224, 0.0342613,
                            -0.028116, 0.1224, 0.028116,
                            -0.0342613, 0.1224, 0.0201227,
                            -0.0382067, 0.1224, 0.0106334,
                            -0.0396, 0.1224, 2.18868e-008,
                            -0.0136527, 0.120533, 0.0490554,
                            -0.0258365, 0.120533, 0.0439898,
                            -0.0360995, 0.120533, 0.0360995,
                            -0.0439898, 0.120533, 0.0258365,
                            -0.0490554, 0.120533, 0.0136527,
                            -0.0508444, 0.120533, 2.1553e-008,
                            -0.0158843, 0.118267, 0.0570741,
                            -0.0300597, 0.118267, 0.0511805,
                            -0.0420004, 0.118267, 0.0420004,
                            -0.0511805, 0.118267, 0.0300598,
                            -0.0570741, 0.118267, 0.0158844,
                            -0.0591555, 0.118267, 2.11477e-008,
                            -0.0167555, 0.1152, 0.0602044,
                            -0.0317084, 0.1152, 0.0539876,
                            -0.044304, 0.1152, 0.044304,
                            -0.0539875, 0.1152, 0.0317085,
                            -0.0602044, 0.1152, 0.0167556,
                            -0.0624, 0.1152, 2.05994e-008,
                            -0.0162518, 0.126533, -0.00452302,
                            -0.0145736, 0.126533, -0.00855945,
                            -0.0119595, 0.126533, -0.0119595,
                            -0.00855948, 0.126533, -0.0145735,
                            -0.00452306, 0.126533, -0.0162517,
                            0, 0.126533, -0.0168444,
                            -0.026586, 0.124267, -0.00739915,
                            -0.0238406, 0.124267, -0.0140023,
                            -0.0195644, 0.124267, -0.0195644,
                            -0.0140023, 0.124267, -0.0238406,
                            -0.0073992, 0.124267, -0.026586,
                            0, 0.124267, -0.0275555,
                            -0.0382067, 0.1224, -0.0106333,
                            -0.0342613, 0.1224, -0.0201226,
                            -0.028116, 0.1224, -0.028116,
                            -0.0201227, 0.1224, -0.0342613,
                            -0.0106334, 0.1224, -0.0382066,
                            0, 0.1224, -0.0396,
                            -0.0490554, 0.120533, -0.0136526,
                            -0.0439898, 0.120533, -0.0258365,
                            -0.0360995, 0.120533, -0.0360995,
                            -0.0258365, 0.120533, -0.0439898,
                            -0.0136527, 0.120533, -0.0490554,
                            0, 0.120533, -0.0508444,
                            -0.0570741, 0.118267, -0.0158843,
                            -0.0511805, 0.118267, -0.0300597,
                            -0.0420004, 0.118267, -0.0420004,
                            -0.0300598, 0.118267, -0.0511805,
                            -0.0158844, 0.118267, -0.0570741,
                            0, 0.118267, -0.0591555,
                            -0.0602044, 0.1152, -0.0167555,
                            -0.0539876, 0.1152, -0.0317084,
                            -0.044304, 0.1152, -0.044304,
                            -0.0317085, 0.1152, -0.0539875,
                            -0.0167556, 0.1152, -0.0602044,
                            0, 0.1152, -0.0624,
                            0.00452304, 0.126533, -0.0162517,
                            0.00855946, 0.126533, -0.0145735,
                            0.0119595, 0.126533, -0.0119595,
                            0.0145735, 0.126533, -0.00855947,
                            0.0162518, 0.126533, -0.00452304,
                            0.00739916, 0.124267, -0.026586,
                            0.0140023, 0.124267, -0.0238406,
                            0.0195644, 0.124267, -0.0195644,
                            0.0238406, 0.124267, -0.0140023,
                            0.026586, 0.124267, -0.00739919,
                            0.0106333, 0.1224, -0.0382067,
                            0.0201227, 0.1224, -0.0342613,
                            0.028116, 0.1224, -0.028116,
                            0.0342613, 0.1224, -0.0201227,
                            0.0382067, 0.1224, -0.0106334,
                            0.0136527, 0.120533, -0.0490554,
                            0.0258365, 0.120533, -0.0439898,
                            0.0360995, 0.120533, -0.0360995,
                            0.0439898, 0.120533, -0.0258365,
                            0.0490554, 0.120533, -0.0136527,
                            0.0158843, 0.118267, -0.0570741,
                            0.0300597, 0.118267, -0.0511805,
                            0.0420004, 0.118267, -0.0420004,
                            0.0511805, 0.118267, -0.0300598,
                            0.0570741, 0.118267, -0.0158844,
                            0.0167555, 0.1152, -0.0602044,
                            0.0317084, 0.1152, -0.0539876,
                            0.044304, 0.1152, -0.044304,
                            0.0539875, 0.1152, -0.0317085,
                            0.0602044, 0.1152, -0.0167556,
                            0.0290833, 0.000283333, 5.06639e-011,
                            0, 0, 0,
                            0.02806, 0.000283335, -0.00780941,
                            0.0251625, 0.000283336, -0.0147786,
                            0.0206492, 0.000283337, -0.0206492,
                            0.0147787, 0.000283338, -0.0251625,
                            0.00780945, 0.000283338, -0.02806,
                            0, 0.000283338, -0.0290833,
                            0.0490667, 0.00106667, 1.90735e-010,
                            0.0473403, 0.00106667, -0.0131753,
                            0.0424518, 0.00106667, -0.0249331,
                            0.0348373, 0.00106667, -0.0348373,
                            0.0249332, 0.00106667, -0.0424517,
                            0.0131754, 0.00106667, -0.0473402,
                            0, 0.00106667, -0.0490667,
                            0.06165, 0.00225, 4.02331e-010,
                            0.0594808, 0.00225, -0.0165542,
                            0.0533387, 0.00225001, -0.0313273,
                            0.0437715, 0.00225001, -0.0437715,
                            0.0313274, 0.00225001, -0.0533386,
                            0.0165542, 0.00225001, -0.0594808,
                            0, 0.00225001, -0.06165,
                            0.0685333, 0.00373333, 6.67572e-010,
                            0.066122, 0.00373334, -0.0184025,
                            0.059294, 0.00373334, -0.0348251,
                            0.0486587, 0.00373334, -0.0486587,
                            0.0348251, 0.00373334, -0.059294,
                            0.0184026, 0.00373334, -0.066122,
                            0, 0.00373334, -0.0685333,
                            0.0714167, 0.00541667, 9.68575e-010,
                            0.0689039, 0.00541667, -0.0191767,
                            0.0617887, 0.00541667, -0.0362902,
                            0.0507058, 0.00541668, -0.0507058,
                            0.0362903, 0.00541668, -0.0617886,
                            0.0191768, 0.00541668, -0.0689038,
                            0, 0.00541668, -0.0714167,
                            0.0694667, 0.0072, -0.0193333,
                            0.0622933, 0.00720001, -0.0365866,
                            0.0365867, 0.00720001, -0.0622933,
                            0.0193334, 0.00720001, -0.0694666,
                            0, 0.000283338, -0.0290833,
                            -0.0078094, 0.000283338, -0.02806,
                            -0.0147786, 0.000283338, -0.0251625,
                            -0.0206492, 0.000283337, -0.0206492,
                            -0.0251624, 0.000283336, -0.0147787,
                            -0.02806, 0.000283335, -0.00780945,
                            -0.0290833, 0.000283333, 5.06639e-011,
                            0, 0.00106667, -0.0490667,
                            -0.0131753, 0.00106667, -0.0473402,
                            -0.0249331, 0.00106667, -0.0424518,
                            -0.0348373, 0.00106667, -0.0348373,
                            -0.0424517, 0.00106667, -0.0249332,
                            -0.0473402, 0.00106667, -0.0131754,
                            -0.0490667, 0.00106667, 1.90735e-010,
                            -0.0165542, 0.00225001, -0.0594808,
                            -0.0313273, 0.00225001, -0.0533387,
                            -0.0437715, 0.00225001, -0.0437715,
                            -0.0533386, 0.00225001, -0.0313274,
                            -0.0594808, 0.00225, -0.0165542,
                            -0.06165, 0.00225, 4.02331e-010,
                            0, 0.00373334, -0.0685333,
                            -0.0184024, 0.00373334, -0.066122,
                            -0.0348251, 0.00373334, -0.059294,
                            -0.0486587, 0.00373334, -0.0486587,
                            -0.059294, 0.00373334, -0.0348251,
                            -0.0661219, 0.00373334, -0.0184026,
                            -0.0685333, 0.00373333, 6.67572e-010,
                            0, 0.00541667, -0.0714167,
                            -0.0191767, 0.00541668, -0.0689039,
                            -0.0362902, 0.00541667, -0.0617887,
                            -0.0507058, 0.00541667, -0.0507058,
                            -0.0617886, 0.00541667, -0.0362903,
                            -0.0689038, 0.00541667, -0.0191768,
                            -0.0714167, 0.00541666, 9.68575e-010,
                            -0.0193333, 0.00720001, -0.0694667,
                            -0.0365866, 0.00720001, -0.0622933,
                            -0.0622933, 0.00720001, -0.0365867,
                            -0.0694666, 0.0072, -0.0193334,
                            -0.0290833, 0.000283334, 5.0664e-011,
                            -0.02806, 0.000283332, 0.00780941,
                            -0.0251625, 0.000283331, 0.0147786,
                            -0.0206492, 0.00028333, 0.0206492,
                            -0.0147787, 0.000283329, 0.0251625,
                            -0.00780945, 0.000283329, 0.02806,
                            0, 0.000283329, 0.0290833,
                            -0.0490667, 0.00106667, 1.90735e-010,
                            -0.0473403, 0.00106667, 0.0131753,
                            -0.0424518, 0.00106666, 0.0249331,
                            -0.0348374, 0.00106666, 0.0348374,
                            -0.0249332, 0.00106666, 0.0424517,
                            -0.0131754, 0.00106666, 0.0473402,
                            0, 0.00106666, 0.0490667,
                            -0.0594808, 0.00225, 0.0165542,
                            -0.0533387, 0.00224999, 0.0313273,
                            -0.0437715, 0.00224999, 0.0437715,
                            -0.0313274, 0.00224999, 0.0533386,
                            -0.0165542, 0.00224999, 0.0594808,
                            0, 0.00224999, 0.06165,
                            -0.0685333, 0.00373334, 6.67572e-010,
                            -0.066122, 0.00373333, 0.0184025,
                            -0.059294, 0.00373333, 0.0348251,
                            -0.0486587, 0.00373333, 0.0486587,
                            -0.0348251, 0.00373333, 0.059294,
                            -0.0184026, 0.00373333, 0.066122,
                            0, 0.00373333, 0.0685333,
                            -0.0714167, 0.00541667, 9.68576e-010,
                            -0.0689039, 0.00541667, 0.0191767,
                            -0.0617887, 0.00541666, 0.0362902,
                            -0.0507058, 0.00541666, 0.0507058,
                            -0.0362903, 0.00541666, 0.0617886,
                            -0.0191768, 0.00541666, 0.0689038,
                            0, 0.00541666, 0.0714167,
                            -0.0694667, 0.0072, 0.0193333,
                            -0.0622933, 0.00719999, 0.0365866,
                            -0.05112, 0.00719999, 0.05112,
                            -0.0365867, 0.00719999, 0.0622933,
                            -0.0193334, 0.00719999, 0.0694666,
                            0.00780941, 0.000283329, 0.02806,
                            0.0147786, 0.000283329, 0.0251625,
                            0.0206492, 0.00028333, 0.0206492,
                            0.0251625, 0.000283331, 0.0147787,
                            0.02806, 0.000283332, 0.00780945,
                            0.0290833, 0.000283334, 5.0664e-011,
                            0.0131753, 0.00106666, 0.0473403,
                            0.0249331, 0.00106666, 0.0424518,
                            0.0348374, 0.00106666, 0.0348374,
                            0.0424517, 0.00106666, 0.0249332,
                            0.0473402, 0.00106666, 0.0131754,
                            0.0490667, 0.00106667, 1.90735e-010,
                            0.0165542, 0.00224999, 0.0594808,
                            0.0313273, 0.00224999, 0.0533387,
                            0.0437715, 0.00224999, 0.0437715,
                            0.0533386, 0.00224999, 0.0313274,
                            0.0594808, 0.00225, 0.0165542,
                            0.0184025, 0.00373333, 0.066122,
                            0.0348251, 0.00373333, 0.059294,
                            0.0486587, 0.00373333, 0.0486587,
                            0.059294, 0.00373333, 0.0348251,
                            0.066122, 0.00373333, 0.0184026,
                            0.0685333, 0.00373334, 6.67572e-010,
                            0.0191767, 0.00541666, 0.0689039,
                            0.0362902, 0.00541666, 0.0617887,
                            0.0507058, 0.00541666, 0.0507058,
                            0.0617886, 0.00541666, 0.0362903,
                            0.0689038, 0.00541667, 0.0191768,
                            0.0714167, 0.00541667, 9.68576e-010,
                            0.0193333, 0.00719999, 0.0694667,
                            0.0365866, 0.00719999, 0.0622933,
                            0.05112, 0.00719999, 0.05112,
                            0.0622933, 0.00719999, 0.0365867,
                            0.0694666, 0.0072, 0.0193334,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            -0.06165, 0.00225, 4.02331e-010,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0.06165, 0.00225, 4.02331e-010,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0, 0, 0,
                            0.006816, 0.1296, 0.00681602,
                            0.00487823, 0.1296, 0.00830579,
                            0.00257779, 0.1296, 0.00926224,
                            0, 0.1296, 0.00960002,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0.00830577, 0.1296, -0.00487821,
                            0.00487822, 0.1296, -0.00830576,
                            0.00257778, 0.1296, -0.0092622,
                            0, 0.1296, -0.00959998,
                            -0.00257779, 0.1296, -0.0092622,
                            -0.00487823, 0.1296, -0.00830575,
                            -0.00830578, 0.1296, -0.0048782,
                            -0.00257778, 0.1296, 0.00926224,
                            -0.00487822, 0.1296, 0.0083058,
                            -0.006816, 0.1296, 0.00681602,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0, 0.1512, 2.70367e-008,
                            0.156267, 0.1152, -0.00499999,
                            0.131733, 0.1152, -0.00499998,
                            0.1296, 0.1152, 2.05994e-008,
                            0.137067, 0.1152, 0.00800001,
                            -0.094, 0.1079, 1.9294e-008,
                            -0.096, 0.0432, 7.72476e-009,
                            -0.0897778, 0.0250667, 4.48227e-009,
                            0.0897778, 0.0250667, 4.48227e-009,
                            -0.084, 0.01845, 3.29912e-009,
                            0.084, 0.01845, 3.29912e-009,
                            -0.0782222, 0.0133334, 2.38419e-009,
                            0.0782222, 0.0133334, 2.38419e-009,
                            -0.0737778, 0.00961668, 1.7196e-009,
                            0.0737778, 0.00961668, 1.7196e-009,
                            0.0926222, 0.0432, 0.0257778,
                            0.072, 0.1152, 2.05994e-008,
                            0.05112, 0.1152, -0.05112,
                            0, 0.1152, -0.072,
                            -0.05112, 0.1152, -0.05112,
                            -0.072, 0.1152, 2.05994e-008,
                            0, 0.1152, 0.072,
                            -0.05112, 0.1152, 0.05112,
                            -0.0687556, 0.1194, 2.13504e-008,
                            0.05112, 0.1152, 0.05112,
                            0, 0.117825, 0.0663056,
                            -0.0396, 0.1224, 2.18868e-008,
                            0.0396, 0.1224, 2.18868e-008};

float teapot_normals[] = {
                            -0.987635, -0.156768, 0,
                            -0.902861, -0.429933, 0,
                            -0.953562, -0.156989, -0.257047,
                            -0.871509, -0.430441, -0.234929,
                            -0.854265, -0.157281, -0.495474,
                            -0.780517, -0.431109, -0.4527,
                            -0.698293, -0.157393, -0.698294,
                            -0.637936, -0.431366, -0.637936,
                            -0.495474, -0.157281, -0.854265,
                            -0.4527, -0.431109, -0.780517,
                            -0.257047, -0.156989, -0.953562,
                            -0.234929, -0.430441, -0.871509,
                            0, -0.156767, -0.987636,
                            0, -0.429933, -0.902861,
                            -0.880022, 0.474932, 0,
                            -0.849414, 0.475466, -0.228973,
                            -0.76067, 0.476166, -0.441189,
                            -0.621695, 0.476435, -0.621695,
                            -0.441189, 0.476166, -0.76067,
                            -0.228972, 0.475466, -0.849414,
                            0, 0.474932, -0.880022,
                            0, 1, 0,
                            -3.12489e-007, 1, -4.53013e-008,
                            -4.74898e-007, 1, -2.15741e-007,
                            0, 1, 0,
                            -1.19502e-007, 1, -2.57504e-007,
                            -5.01339e-008, 1, -1.37835e-007,
                            0, 1, 0,
                            0.556738, 0.830688, 0,
                            0.537013, 0.831061, 0.14476,
                            0.480481, 0.83155, 0.278679,
                            0.392564, 0.831738, 0.392564,
                            0.278679, 0.83155, 0.480481,
                            0.14476, 0.831061, 0.537012,
                            0, 0.830688, 0.556738,
                            0.783289, 0.621658, 0,
                            0.755869, 0.622211, 0.203756,
                            0.67669, 0.622937, 0.39248,
                            0.552994, 0.623214, 0.552994,
                            0.39248, 0.622936, 0.676691,
                            0.203756, 0.62221, 0.755869,
                            0, 0.621658, 0.783289,
                            0.90286, 0.429934, 0,
                            0.871509, 0.430442, 0.234929,
                            0.780517, 0.431109, 0.4527,
                            0.637935, 0.431366, 0.637936,
                            0.4527, 0.431109, 0.780517,
                            0.234929, 0.430441, 0.87151,
                            0, 0.429934, 0.90286,
                            0.257047, -0.156989, -0.953562,
                            0.234929, -0.430441, -0.871509,
                            0.495474, -0.157281, -0.854265,
                            0.4527, -0.431109, -0.780517,
                            0.698293, -0.157393, -0.698294,
                            0.637936, -0.431366, -0.637936,
                            0.854265, -0.157281, -0.495474,
                            0.780517, -0.431109, -0.4527,
                            0.953562, -0.156989, -0.257047,
                            0.871509, -0.430441, -0.234929,
                            0.987636, -0.156767, 0,
                            0.902861, -0.429933, 0,
                            0.228973, 0.475465, -0.849414,
                            0.441188, 0.476167, -0.760669,
                            0.621695, 0.476434, -0.621696,
                            0.76067, 0.476167, -0.441188,
                            0.849414, 0.475466, -0.228972,
                            0.880022, 0.474932, 0,
                            4.53013e-008, 1, -3.12489e-007,
                            2.15741e-007, 1, -4.74898e-007,
                            0, 1, 0,
                            2.57504e-007, 1, -1.19502e-007,
                            1.37835e-007, 1, -5.01339e-008,
                            0, 1, 0,
                            0, 0.830689, 0.556737,
                            -0.14476, 0.831061, 0.537012,
                            -0.278679, 0.83155, 0.480481,
                            -0.392563, 0.831738, 0.392563,
                            -0.480482, 0.83155, 0.27868,
                            -0.537012, 0.831061, 0.14476,
                            -0.556738, 0.830688, 0,
                            0, 0.621658, 0.783289,
                            -0.203756, 0.62221, 0.755869,
                            -0.39248, 0.622937, 0.67669,
                            -0.552993, 0.623215, 0.552993,
                            -0.67669, 0.622937, 0.39248,
                            -0.755869, 0.62221, 0.203756,
                            -0.783289, 0.621658, 0,
                            -0.234929, 0.430442, 0.871509,
                            -0.4527, 0.431109, 0.780517,
                            -0.637935, 0.431366, 0.637936,
                            -0.780517, 0.431109, 0.4527,
                            -0.87151, 0.430441, 0.234929,
                            -0.90286, 0.429934, 0,
                            0.987636, -0.156767, 0,
                            0.953562, -0.156989, 0.257047,
                            0.871509, -0.430441, 0.234929,
                            0.854265, -0.15728, 0.495474,
                            0.780517, -0.431109, 0.4527,
                            0.698294, -0.157393, 0.698293,
                            0.637936, -0.431366, 0.637936,
                            0.495474, -0.157281, 0.854265,
                            0.4527, -0.431109, 0.780517,
                            0.257047, -0.156989, 0.953562,
                            0.234929, -0.430441, 0.871509,
                            0, -0.156767, 0.987636,
                            0, -0.429933, 0.902861,
                            0.880022, 0.474934, 0,
                            0.849413, 0.475467, 0.228972,
                            0.760669, 0.476167, 0.441188,
                            0.621695, 0.476436, 0.621695,
                            0.441188, 0.476167, 0.760669,
                            0.228972, 0.475466, 0.849414,
                            0, 0.474934, 0.880022,
                            3.12489e-007, 1, 4.53013e-008,
                            4.74898e-007, 1, 2.15741e-007,
                            0, 1, 0,
                            1.19502e-007, 1, 2.57504e-007,
                            5.01339e-008, 1, 1.37835e-007,
                            0, 1, 0,
                            -0.537013, 0.831061, -0.14476,
                            -0.480482, 0.83155, -0.27868,
                            -0.392566, 0.831735, -0.392566,
                            -0.27868, 0.83155, -0.480482,
                            -0.14476, 0.831061, -0.537012,
                            0, 0.830688, -0.556738,
                            -0.783289, 0.621657, 0,
                            -0.755869, 0.62221, -0.203756,
                            -0.676691, 0.622936, -0.39248,
                            -0.552994, 0.623215, -0.552993,
                            -0.392481, 0.622936, -0.676691,
                            -0.203756, 0.622209, -0.75587,
                            0, 0.621657, -0.783289,
                            -0.871509, 0.430442, -0.234929,
                            -0.780517, 0.431109, -0.4527,
                            -0.637936, 0.431366, -0.637935,
                            -0.4527, 0.431109, -0.780517,
                            -0.234929, 0.430441, -0.87151,
                            0, 0.429934, -0.90286,
                            -0.257047, -0.156989, 0.953562,
                            -0.234929, -0.430441, 0.871509,
                            -0.495474, -0.15728, 0.854265,
                            -0.4527, -0.431109, 0.780517,
                            -0.698294, -0.157393, 0.698293,
                            -0.637936, -0.431366, 0.637936,
                            -0.854265, -0.157281, 0.495474,
                            -0.780517, -0.431109, 0.4527,
                            -0.953562, -0.156989, 0.257047,
                            -0.871509, -0.430442, 0.234928,
                            -0.987636, -0.156767, 0,
                            -0.228972, 0.475467, 0.849413,
                            -0.441188, 0.476167, 0.760669,
                            -0.621695, 0.476436, 0.621695,
                            -0.76067, 0.476167, 0.441188,
                            -0.849414, 0.475466, 0.228972,
                            -0.880022, 0.474934, 0,
                            -4.53013e-008, 1, 3.12489e-007,
                            -2.15741e-007, 1, 4.74898e-007,
                            0, 1, 0,
                            -2.57504e-007, 1, 1.19502e-007,
                            -1.37835e-007, 1, 5.01339e-008,
                            0.14476, 0.831061, -0.537013,
                            0.27868, 0.83155, -0.480482,
                            0.392566, 0.831735, -0.392566,
                            0.480482, 0.83155, -0.27868,
                            0.537012, 0.831061, -0.14476,
                            0.556738, 0.830688, 0,
                            0.203756, 0.62221, -0.755869,
                            0.392481, 0.622936, -0.67669,
                            0.552994, 0.623215, -0.552993,
                            0.676691, 0.622936, -0.39248,
                            0.75587, 0.622209, -0.203756,
                            0.783289, 0.621657, 0,
                            0.234929, 0.430442, -0.871509,
                            0.4527, 0.431109, -0.780517,
                            0.637936, 0.431366, -0.637935,
                            0.780517, 0.431109, -0.4527,
                            0.87151, 0.430441, -0.234928,
                            0.906828, 0.421501, 0,
                            0.875348, 0.422003, 0.235963,
                            0.871509, 0.430442, 0.234929,
                            0.783966, 0.422664, 0.4547,
                            0.780517, 0.43111, 0.4527,
                            0.640758, 0.422917, 0.640758,
                            0.4547, 0.422664, 0.783966,
                            0.4527, 0.43111, 0.780517,
                            0.235964, 0.422003, 0.875348,
                            0.234929, 0.430442, 0.871509,
                            0, 0.421501, 0.906828,
                            0.918633, 0.395111, 0,
                            0.886771, 0.395595, 0.239043,
                            0.794229, 0.39623, 0.460653,
                            0.649156, 0.396474, 0.649157,
                            0.460653, 0.39623, 0.794229,
                            0.239043, 0.395595, 0.886771,
                            0, 0.395111, 0.918633,
                            0.937749, 0.347314, 0,
                            0.905271, 0.347757, 0.244029,
                            0.810853, 0.34834, 0.470295,
                            0.662761, 0.348563, 0.662761,
                            0.470295, 0.34834, 0.810853,
                            0.24403, 0.347757, 0.90527,
                            0, 0.347314, 0.937749,
                            0.96234, 0.271848, 0,
                            0.929073, 0.272213, 0.250446,
                            0.832247, 0.272693, 0.482704,
                            0.680271, 0.272877, 0.680271,
                            0.482704, 0.272693, 0.832247,
                            0.250446, 0.272213, 0.929073,
                            0, 0.271848, 0.96234,
                            0.987204, 0.15946, 0,
                            0.953145, 0.159686, 0.256935,
                            0.85389, 0.159982, 0.495256,
                            0.697986, 0.160096, 0.697986,
                            0.495256, 0.159982, 0.853889,
                            0.256935, 0.159686, 0.953145,
                            0, 0.15946, 0.987204,
                            1, 0, 0,
                            0.965535, -2.69333e-008, 0.260275,
                            0.865031, -2.6582e-008, 0.501718,
                            0.707107, -1.58051e-008, 0.707107,
                            0.501718, -5.72888e-009, 0.865031,
                            0.260275, -7.99313e-010, 0.965535,
                            0, 0, 1,
                            0, 0.421501, 0.906828,
                            -0.235963, 0.422003, 0.875348,
                            -0.234928, 0.430442, 0.871509,
                            -0.4547, 0.422664, 0.783966,
                            -0.4527, 0.43111, 0.780517,
                            -0.640758, 0.422917, 0.640758,
                            -0.783966, 0.422664, 0.454701,
                            -0.780517, 0.43111, 0.4527,
                            -0.875348, 0.422003, 0.235964,
                            -0.871509, 0.430442, 0.234929,
                            -0.906828, 0.421501, 0,
                            0, 0.395111, 0.918633,
                            -0.239043, 0.395595, 0.886771,
                            -0.460653, 0.39623, 0.794229,
                            -0.649157, 0.396474, 0.649157,
                            -0.794229, 0.39623, 0.460653,
                            -0.886771, 0.395595, 0.239043,
                            -0.918633, 0.395111, 0,
                            -0.244029, 0.347757, 0.905271,
                            -0.470295, 0.34834, 0.810853,
                            -0.662761, 0.348563, 0.662761,
                            -0.810853, 0.34834, 0.470295,
                            -0.90527, 0.347757, 0.24403,
                            -0.937749, 0.347314, 0,
                            0, 0.271848, 0.96234,
                            -0.250446, 0.272213, 0.929073,
                            -0.482703, 0.272693, 0.832248,
                            -0.680271, 0.272877, 0.680271,
                            -0.832247, 0.272693, 0.482704,
                            -0.929073, 0.272213, 0.250446,
                            -0.96234, 0.271848, 0,
                            0, 0.159461, 0.987204,
                            -0.256935, 0.159686, 0.953145,
                            -0.495256, 0.159983, 0.853889,
                            -0.697986, 0.160096, 0.697986,
                            -0.853889, 0.159982, 0.495256,
                            -0.953145, 0.159686, 0.256935,
                            -0.987204, 0.159461, 0,
                            -0.260274, -7.9931e-010, 0.965535,
                            -0.501718, -5.72887e-009, 0.865031,
                            -0.707107, -1.58051e-008, 0.707107,
                            -0.865031, -2.6582e-008, 0.501718,
                            -0.965535, -2.69333e-008, 0.260275,
                            0.410365, 0.911921, 0,
                            -0.906828, 0.421501, 0,
                            -0.875348, 0.422003, -0.235963,
                            -0.871509, 0.430442, -0.234928,
                            -0.783966, 0.422664, -0.4547,
                            -0.780517, 0.43111, -0.4527,
                            -0.640758, 0.422917, -0.640758,
                            -0.454701, 0.422664, -0.783966,
                            -0.4527, 0.43111, -0.780517,
                            -0.235964, 0.422003, -0.875348,
                            -0.234929, 0.430442, -0.871509,
                            0, 0.421501, -0.906828,
                            -0.918633, 0.395111, 0,
                            -0.886771, 0.395595, -0.239043,
                            -0.794229, 0.39623, -0.460653,
                            -0.649157, 0.396474, -0.649156,
                            -0.460653, 0.39623, -0.794229,
                            -0.239043, 0.395595, -0.886771,
                            0, 0.395111, -0.918633,
                            -0.905271, 0.347757, -0.244029,
                            -0.810853, 0.34834, -0.470295,
                            -0.662761, 0.348563, -0.662761,
                            -0.470295, 0.34834, -0.810853,
                            -0.24403, 0.347757, -0.90527,
                            0, 0.347314, -0.937749,
                            -0.96234, 0.271847, 0,
                            -0.929073, 0.272213, -0.250446,
                            -0.832248, 0.272693, -0.482703,
                            -0.680271, 0.272877, -0.680271,
                            -0.482704, 0.272693, -0.832247,
                            -0.250446, 0.272213, -0.929073,
                            0, 0.271847, -0.96234,
                            -0.987204, 0.15946, 0,
                            -0.953145, 0.159685, -0.256935,
                            -0.85389, 0.159982, -0.495256,
                            -0.697986, 0.160096, -0.697986,
                            -0.495256, 0.159982, -0.853889,
                            -0.256935, 0.159685, -0.953145,
                            0, 0.15946, -0.987204,
                            -0.965535, 2.69333e-008, -0.260274,
                            -0.865031, 2.6582e-008, -0.501718,
                            -0.707107, 1.58051e-008, -0.707107,
                            -0.501718, 5.72888e-009, -0.865031,
                            -0.260275, 7.99313e-010, -0.965535,
                            0, 0 , -1,
                            0.235963, 0.422003, -0.875348,
                            0.234928, 0.430442, -0.871509,
                            0.4547, 0.422664, -0.783966,
                            0.4527, 0.43111, -0.780517,
                            0.640758, 0.422917, -0.640758,
                            0.783966, 0.422664, -0.4547,
                            0.780517, 0.43111, -0.4527,
                            0.875348, 0.422003, -0.235964,
                            0.871509, 0.430442, -0.234929,
                            0.906828, 0.421501, 0,
                            0.239043, 0.395595, -0.886771,
                            0.460653, 0.39623, -0.794229,
                            0.649157, 0.396474, -0.649156,
                            0.794229, 0.39623, -0.460653,
                            0.886771, 0.395595, -0.239043,
                            0.918633, 0.395111, 0,
                            0.244029, 0.347757, -0.905271,
                            0.470295, 0.34834, -0.810853,
                            0.662761, 0.348563, -0.662761,
                            0.810853, 0.34834, -0.470295,
                            0.90527, 0.347757, -0.24403,
                            0.250446, 0.272213, -0.929073,
                            0.482704, 0.272693, -0.832247,
                            0.680271, 0.272877, -0.680271,
                            0.832247, 0.272693, -0.482704,
                            0.929073, 0.272213, -0.250446,
                            0.96234, 0.271847, 0,
                            0.256935, 0.159685, -0.953145,
                            0.495256, 0.159982, -0.85389,
                            0.697986, 0.160096, -0.697986,
                            0.853889, 0.159982, -0.495256,
                            0.953145, 0.159685, -0.256935,
                            0.987204, 0.15946, 0,
                            0.260274, 7.9931e-010, -0.965535,
                            0.501718, 5.72887e-009, -0.865031,
                            0.707107, 1.58051e-008, -0.707107,
                            0.865031, 2.6582e-008, -0.501718,
                            0.965535, 2.69333e-008, -0.260275,
                            0.938373, -0.345625, -3.10672e-010,
                            0.905874, -0.346066, 0.244192,
                            0.811396, -0.346647, 0.470609,
                            0.663205, -0.346869, 0.663205,
                            0.47061, -0.346647, 0.811395,
                            0.244192, -0.346066, 0.905874,
                            0, -0.345625, 0.938373,
                            0.811257, -0.584689, -4.41262e-009,
                            0.782908, -0.585247, 0.211045,
                            0.700957, -0.58598, 0.406555,
                            0.572843, -0.586261, 0.572843,
                            0.406555, -0.58598, 0.700957,
                            0.211045, -0.585247, 0.782908,
                            0, -0.584689, 0.811257,
                            0.6981, -0.716, -1.94916e-008,
                            0.673539, -0.716506, 0.181563,
                            0.602839, -0.717169, 0.349647,
                            0.492597, -0.717423, 0.492597,
                            0.349647, -0.717169, 0.602839,
                            0.181563, -0.716506, 0.673539,
                            0, -0.716, 0.6981,
                            0.636383, -0.771373, -5.3452e-008,
                            0.61392, -0.771826, 0.165491,
                            0.549392, -0.772419, 0.318648,
                            0.448897, -0.772647, 0.448897,
                            0.318648, -0.772419, 0.549392,
                            0.165492, -0.771826, 0.61392,
                            0, -0.771373, 0.636383,
                            0.675056, -0.737767, -1.05865e-007,
                            0.651275, -0.738254, 0.175561,
                            0.582878, -0.738893, 0.338069,
                            0.476275, -0.739138, 0.476275,
                            0.338069, -0.738893, 0.582878,
                            0.175561, -0.738254, 0.651275,
                            0, -0.737767, 0.675056,
                            1, 0, 0,
                            0.965535, -2.69332e-008, 0.260274,
                            0.865031, -2.65819e-008, 0.501718,
                            0.707107, -1.5805e-008, 0.707107,
                            0.501718, -5.72887e-009, 0.865031,
                            0.260275, -7.99311e-010, 0.965535,
                            0, 0, 1,
                            -0.244192, -0.346066, 0.905874,
                            -0.470609, -0.346647, 0.811396,
                            -0.663205, -0.346869, 0.663205,
                            -0.811395, -0.346647, 0.47061,
                            -0.905874, -0.346066, 0.244193,
                            -0.938373, -0.345625, -3.10672e-010,
                            -0.211045, -0.585247, 0.782908,
                            -0.406555, -0.58598, 0.700957,
                            -0.572843, -0.586261, 0.572843,
                            -0.700957, -0.58598, 0.406555,
                            -0.782908, -0.585247, 0.211045,
                            -0.811257, -0.584689, -4.41262e-009,
                            -0.181563, -0.716506, 0.673539,
                            -0.349647, -0.717169, 0.602839,
                            -0.492597, -0.717423, 0.492597,
                            -0.602839, -0.717169, 0.349647,
                            -0.673539, -0.716506, 0.181563,
                            -0.6981, -0.716, -1.94916e-008,
                            -0.165491, -0.771826, 0.61392,
                            -0.318648, -0.772419, 0.549393,
                            -0.448897, -0.772647, 0.448897,
                            -0.549392, -0.772419, 0.318648,
                            -0.61392, -0.771826, 0.165492,
                            -0.636383, -0.771373, -5.3452e-008,
                            -0.175561, -0.738254, 0.651275,
                            -0.338069, -0.738893, 0.582878,
                            -0.476275, -0.739138, 0.476275,
                            -0.582878, -0.738893, 0.338069,
                            -0.651275, -0.738254, 0.175561,
                            -0.675056, -0.737767, -1.05865e-007,
                            -0.260274, -7.99309e-010, 0.965535,
                            -0.501718, -5.72886e-009, 0.865031,
                            -0.707107, -1.5805e-008, 0.707107,
                            -0.865031, -2.65819e-008, 0.501718,
                            -0.965535, -2.69333e-008, 0.260275,
                            -1, 0, 0,
                            -0.905874, -0.346066, -0.244192,
                            -0.811396, -0.346647, -0.470609,
                            -0.663205, -0.346869, -0.663205,
                            -0.47061, -0.346647, -0.811395,
                            -0.244192, -0.346066, -0.905874,
                            0, -0.345625, -0.938373,
                            -0.782908, -0.585247, -0.211045,
                            -0.700957, -0.58598, -0.406555,
                            -0.572843, -0.586261, -0.572843,
                            -0.406555, -0.58598, -0.700957,
                            -0.211045, -0.585247, -0.782908,
                            0, -0.584689, -0.811257,
                            -0.673539, -0.716506, -0.181563,
                            -0.602839, -0.717169, -0.349647,
                            -0.492597, -0.717423, -0.492597,
                            -0.349647, -0.717169, -0.602839,
                            -0.181563, -0.716506, -0.673539,
                            0, -0.716, -0.6981,
                            -0.61392, -0.771826, -0.165491,
                            -0.549392, -0.77242, -0.318647,
                            -0.448897, -0.772647, -0.448897,
                            -0.318648, -0.77242, -0.549392,
                            -0.165492, -0.771826, -0.61392,
                            0, -0.771373, -0.636383,
                            -0.651275, -0.738254, -0.175561,
                            -0.582877, -0.738894, -0.338069,
                            -0.476274, -0.739138, -0.476274,
                            -0.338069, -0.738894, -0.582877,
                            -0.175561, -0.738255, -0.651275,
                            0, -0.737767, -0.675055,
                            -0.965535, 2.69333e-008, -0.260274,
                            -0.865031, 2.6582e-008, -0.501718,
                            -0.707107, 1.58051e-008, -0.707107,
                            -0.501718, 5.7289e-009, -0.865031,
                            -0.260275, 7.99315e-010, -0.965535,
                            0, 0 , -1,
                            0.244192, -0.346066, -0.905874,
                            0.470609, -0.346647, -0.811396,
                            0.663205, -0.346869, -0.663205,
                            0.811395, -0.346647, -0.47061,
                            0.905874, -0.346066, -0.244192,
                            0.211045, -0.585247, -0.782908,
                            0.406555, -0.58598, -0.700957,
                            0.572843, -0.586261, -0.572843,
                            0.700957, -0.58598, -0.406555,
                            0.782908, -0.585247, -0.211045,
                            0.181563, -0.716506, -0.673539,
                            0.349647, -0.717169, -0.602839,
                            0.492597, -0.717423, -0.492597,
                            0.602839, -0.717169, -0.349647,
                            0.673539, -0.716506, -0.181563,
                            0.165491, -0.771826, -0.61392,
                            0.318647, -0.77242, -0.549392,
                            0.448897, -0.772647, -0.448897,
                            0.549392, -0.77242, -0.318648,
                            0.61392, -0.771826, -0.165492,
                            0.175561, -0.738255, -0.651275,
                            0.338069, -0.738894, -0.582877,
                            0.476274, -0.739138, -0.476274,
                            0.582877, -0.738894, -0.338069,
                            0.651275, -0.738254, -0.175561,
                            0.260274, 7.99314e-010, -0.965535,
                            0.501718, 5.72889e-009, -0.865031,
                            0.707107, 1.58051e-008, -0.707107,
                            0.865031, 2.6582e-008, -0.501718,
                            0.965535, 2.69333e-008, -0.260275,
                            0.0104645, -0.999945, 0,
                            0 , -1, 0,
                            0.0104255, -0.954681, 0.297447,
                            2.56825e-008, -0.95448, 0.298276,
                            0.00846391, -0.708083, 0.706078,
                            1.14879e-007, -0.707106, 0.707108,
                            -2.9238e-009, -8.98486e-008, 1,
                            8.16344e-015, -8.94074e-008, 1,
                            -0.00997561, 0.707961, 0.706181,
                            5.80084e-008, 0.707107, 0.707107,
                            -0.0140841, 0.95459, 0.297589,
                            1.94189e-007, 0.95448, 0.298275,
                            -0.0149982, 0.999888, 0,
                            0, 1, 0,
                            0.0510697, -0.998695, 0,
                            0.0510028, -0.953615, 0.296676,
                            0.0415993, -0.706917, 0.706072,
                            -2.78701e-009, -9.11701e-008, 1,
                            -0.0493858, 0.704244, 0.708239,
                            -0.0701018, 0.951466, 0.299663,
                            -0.07479, 0.997199, 0,
                            0.14834, -0.988936, 0,
                            0.148104, -0.941964, 0.30128,
                            0.119688, -0.688399, 0.715389,
                            7.13598e-009, -8.17051e-008, 1,
                            -0.141352, 0.675015, 0.724137,
                            -0.204668, 0.927128, 0.313917,
                            -0.219512, 0.97561, 0,
                            0.364399, -0.931243, 0,
                            0.359682, -0.875088, 0.323804,
                            0.275915, -0.604128, 0.747597,
                            1.54202e-008, -6.37972e-008, 1,
                            -0.313659, 0.564289, 0.763672,
                            -0.474611, 0.807244, 0.350859,
                            -0.514496, 0.857493, 0,
                            0.767382, -0.64119, 0,
                            0.727532, -0.577566, 0.37029,
                            0.497151, -0.35353, 0.792374,
                            1.10972e-008, -5.53164e-008, 1,
                            -0.519904, 0.300684, 0.799556,
                            -0.810111, 0.441475, 0.385771,
                            -0.882353, 0.470588, 0,
                            1, 0, 0,
                            0.923077, -3.76483e-008, 0.384616,
                            0.599999, -4.20741e-008, 0.8,
                            0, -4.47037e-008, 1,
                            -0.600001, -5.17421e-008, 0.799999,
                            -0.923077, -4.14964e-008, 0.384614,
                            -1, 0, 0,
                            -0.014084, 0.95459, -0.297589,
                            5.67983e-008, 0.95448, -0.298275,
                            -0.00997558, 0.707961, -0.706182,
                            -4.84905e-008, 0.707107, -0.707107,
                            5.84773e-010, 8.94956e-008 , -1,
                            -8.16344e-015, 8.94074e-008 , -1,
                            0.0084637, -0.708085, -0.706076,
                            3.66172e-008, -0.707108, -0.707106,
                            0.0104256, -0.954682, -0.297445,
                            7.36826e-009, -0.95448, -0.298274,
                            0.0104646, -0.999945, 0,
                            -0.07479, 0.997199, 0,
                            -0.0701018, 0.951466, -0.299663,
                            -0.0493858, 0.704243, -0.708239,
                            -8.36107e-009, 8.41192e-008 , -1,
                            0.0415994, -0.706919, -0.70607,
                            0.0510028, -0.953616, -0.296674,
                            0.0510696, -0.998695, 0,
                            -0.204668, 0.927128, -0.313917,
                            -0.141352, 0.675015, -0.724137,
                            -7.13598e-009, 8.17051e-008 , -1,
                            0.119688, -0.688401, -0.715387,
                            0.148104, -0.941964, -0.301278,
                            -0.514495, 0.857493, 0,
                            -0.47461, 0.807244, -0.350859,
                            -0.313658, 0.564289, -0.763673,
                            -9.25216e-009, 7.40412e-008 , -1,
                            0.275916, -0.60413, -0.747595,
                            0.359681, -0.875089, -0.323802,
                            0.364399, -0.931243, 0,
                            -0.882353, 0.470589, 0,
                            -0.810111, 0.441477, -0.385771,
                            -0.519903, 0.300684, -0.799556,
                            -1.01322e-008, 5.82809e-008 , -1,
                            0.497153, -0.353532, -0.792373,
                            0.727532, -0.577567, -0.370288,
                            0.767381, -0.641191, 0,
                            -0.923077, 4.14963e-008, -0.384615,
                            -0.6, 5.17421e-008, -0.8,
                            0, 4.47037e-008 , -1,
                            0.600002, 4.2074e-008, -0.799999,
                            0.923078, 3.76482e-008, -0.384614,
                            0.972045, 0.234794, 0,
                            0.895972, 0.219226, 0.38623,
                            0.57987, 0.145888, 0.801541,
                            -1.56774e-008, -4.06593e-008, 1,
                            -0.577708, -0.153129, 0.801751,
                            -0.890548, -0.23959, 0.386678,
                            -0.965311, -0.261102, 0,
                            0.913811, 0.406139, 0,
                            0.842942, 0.38439, 0.376421,
                            0.548194, 0.264706, 0.793356,
                            -1.8594e-008, -5.87553e-008, 1,
                            -0.534196, -0.289235, 0.794341,
                            -0.807437, -0.452559, 0.378465,
                            -0.869653, -0.493664, 0,
                            0.83205, 0.5547, 0,
                            0.772293, 0.530527, 0.349435,
                            0.515845, 0.379263, 0.768156,
                            -2.48164e-008, -6.43889e-008, 1,
                            -0.486434, -0.411777, 0.770598,
                            -0.700515, -0.619694, 0.353919,
                            -0.743581, -0.668646, 0,
                            0.722373, 0.691503, 0,
                            0.676612, 0.666255, 0.31353,
                            0.471519, 0.495195, 0.729693,
                            -2.71577e-008, -7.53755e-008, 1,
                            -0.433172, -0.52092, 0.73553,
                            -0.589822, -0.740319, 0.322549,
                            -0.617031, -0.786939, 0,
                            0.580972, 0.813923, 0,
                            0.548733, 0.784249, 0.289562,
                            0.396971, 0.593617, 0.700024,
                            -2.572e-008, -8.77449e-008, 1,
                            -0.367048, -0.602921, 0.708352,
                            -0.485318, -0.820874, 0.301051,
                            -0.504835, -0.863216, 0,
                            0.390503, 0.867784, 0.307341,
                            0.285351, 0.634113, 0.718663,
                            -2.36665e-008, -9.72958e-008, 1,
                            -0.285351, -0.634114, 0.718661,
                            -0.390503, -0.867784, 0.30734,
                            -0.410365, -0.911921, 0,
                            -0.890548, -0.23959, -0.386679,
                            -0.577707, -0.153129, -0.801752,
                            1.08654e-008, 5.5622e-008 , -1,
                            0.579872, 0.145888, -0.801539,
                            0.895973, 0.219227, -0.386228,
                            -0.807437, -0.452558, -0.378466,
                            -0.534196, -0.289235, -0.794341,
                            2.27516e-008, 5.19016e-008 , -1,
                            0.548196, 0.264707, -0.793355,
                            0.842943, 0.384391, -0.376419,
                            -0.700515, -0.619694, -0.353919,
                            -0.486433, -0.411777, -0.770599,
                            2.48164e-008, 6.43889e-008 , -1,
                            0.515847, 0.379264, -0.768154,
                            0.772293, 0.530528, -0.349433,
                            -0.589822, -0.740319, -0.322549,
                            -0.433171, -0.520919, -0.735531,
                            2.71577e-008, 7.53755e-008 , -1,
                            0.47152, 0.495196, -0.729691,
                            0.676612, 0.666255, -0.313529,
                            -0.485318, -0.820874, -0.301052,
                            -0.367047, -0.60292, -0.708353,
                            2.88747e-008, 8.75411e-008 , -1,
                            0.396972, 0.593619, -0.700022,
                            0.548733, 0.784249, -0.289561,
                            -0.390503, -0.867784, -0.30734,
                            -0.285351, -0.634113, -0.718662,
                            2.36665e-008, 9.72958e-008 , -1,
                            0.285351, 0.634114, -0.718661,
                            0.390503, 0.867785, -0.307339,
                            -0.333935, 0.942596, 0,
                            0, 1, 0,
                            -0.291732, 0.855995, 0.426808,
                            -0.0157731, 0.886804, 0.461877,
                            -0.135103, 0.53438, 0.834377,
                            -0.0291362, 0.514277, 0.857129,
                            0.110195, 0.0292375, 0.99348,
                            4.3732e-009, -8.94073e-008, 1,
                            0.348602, -0.464039, 0.814337,
                            0.0673463, -0.513328, 0.855546,
                            0.492146, -0.767551, 0.410679,
                            0.134339, -0.878875, 0.457746,
                            0.528678, -0.848822, 0,
                            0.158678, -0.98733, 0,
                            -0.731055, 0.682318, 0,
                            -0.64585, 0.656206, 0.390219,
                            -0.31251, 0.484842, 0.816864,
                            0.215359, 0.108813, 0.970454,
                            0.627608, -0.260237, 0.733747,
                            0.813963, -0.465103, 0.348055,
                            0.854063, -0.52017, 0,
                            -0.920582, 0.39055, 0,
                            -0.835236, 0.412221, 0.363943,
                            -0.451322, 0.38916, 0.803034,
                            0.214084, 0.180281, 0.960035,
                            0.705425, -0.0805069, 0.704198,
                            0.913262, -0.239978, 0.329185,
                            0.957826, -0.287348, 0,
                            -0.948683, 0.316228, 0,
                            -0.842821, 0.34961, 0.409177,
                            -0.452672, 0.347535, 0.821162,
                            0.113546, 0.191909, 0.974822,
                            0.60461, -0.0547987, 0.794634,
                            0.880145, -0.253261, 0.401503,
                            0.947589, -0.319493, 0,
                            -0.874591, 0.484861, 0,
                            -0.723794, 0.476715, 0.498864,
                            -0.365377, 0.375544, 0.851743,
                            0.0260102, 0.151516, 0.988113,
                            0.417243, -0.185123, 0.88974,
                            0.70819, -0.506054, 0.492318,
                            0.787582, -0.61621, 0,
                            -0.600001, 0.799999, 0,
                            -0.497164, 0.711095, 0.497165,
                            -0.267367, 0.443286, 0.855577,
                            0, -4.47006e-008, 1,
                            0.250514, -0.54278, 0.801644,
                            0.366221, -0.855433, 0.36622,
                            0.384615, -0.923077, 0,
                            0.528678, -0.848822, 0,
                            0.492146, -0.767551, -0.41068,
                            0.134339, -0.878875, -0.457747,
                            0.348602, -0.464038, -0.814337,
                            0.0673462, -0.513327, -0.855546,
                            0.110195, 0.0292377, -0.99348,
                            -4.3732e-009, 8.94073e-008 , -1,
                            -0.135104, 0.534382, -0.834376,
                            -0.0291362, 0.514278, -0.857128,
                            -0.291732, 0.855996, -0.426806,
                            -0.0157731, 0.886804, -0.461876,
                            -0.333935, 0.942596, 0,
                            0.854063, -0.52017, 0,
                            0.813963, -0.465103, -0.348056,
                            0.627607, -0.260237, -0.733748,
                            0.215359, 0.108813, -0.970454,
                            -0.312512, 0.484843, -0.816862,
                            -0.645851, 0.656206, -0.390218,
                            0.913262, -0.239977, -0.329185,
                            0.705424, -0.0805064, -0.704199,
                            0.214084, 0.180281, -0.960035,
                            -0.451324, 0.38916, -0.803032,
                            -0.835237, 0.412221, -0.363941,
                            0.947589, -0.319493, 0,
                            0.880144, -0.253261, -0.401503,
                            0.60461, -0.0547981, -0.794635,
                            0.113546, 0.191909, -0.974822,
                            -0.452675, 0.347535, -0.821161,
                            -0.842822, 0.34961, -0.409175,
                            -0.948683, 0.316228, 0,
                            0.787582, -0.61621, 0,
                            0.70819, -0.506053, -0.492318,
                            0.417243, -0.185122, -0.88974,
                            0.0260103, 0.151516, -0.988113,
                            -0.365379, 0.375545, -0.851742,
                            -0.723796, 0.476715, -0.498861,
                            -0.874591, 0.484861, 0,
                            0.36622, -0.855433, -0.36622,
                            0.250514, -0.54278, -0.801644,
                            0, 4.47006e-008 , -1,
                            -0.267368, 0.443289, -0.855575,
                            -0.497165, 0.711096, -0.497162,
                            -0.467888, 0.883788, 0,
                            -0.387053, 0.824948, 0.411887,
                            -0.215548, 0.655025, 0.72421,
                            -0.00489616, 0.343259, 0.939228,
                            0.269127, -0.23781, 0.933283,
                            0.442187, -0.761825, 0.473385,
                            0.463425, -0.886136, 0,
                            -0.306008, 0.952029, 0,
                            -0.253998, 0.928137, 0.272115,
                            -0.14959, 0.863647, 0.481391,
                            -0.0195232, 0.746219, 0.665414,
                            0.218115, 0.441118, 0.870541,
                            0.612385, -0.337374, 0.714957,
                            0.694135, -0.719844, 0,
                            0, 1, 0,
                            -0.0182315, 0.999613, -0.0210205,
                            -0.0369304, 0.999286, 0.00796664,
                            -0.0348909, 0.997622, 0.059444,
                            -0.00787177, 0.994104, 0.108145,
                            0.0539575, 0.992309, 0.111405,
                            0.106533, 0.994309, 0,
                            0.913813, 0.406135, 0,
                            0.507716, 0.52532, -0.682835,
                            0.148478, 0.676273, -0.721533,
                            -0.0300304, 0.787464, -0.615629,
                            -0.144372, 0.876436, -0.459366,
                            -0.223743, 0.943891, -0.242919,
                            -0.253109, 0.967438, 0,
                            0.789351, -0.613942, 0,
                            0.577415, -0.400033, -0.711734,
                            0.241288, -0.0136421, -0.970358,
                            -0.0103803, 0.344669, -0.938667,
                            -0.199105, 0.663018, -0.72164,
                            -0.316295, 0.875642, -0.364979,
                            -0.349987, 0.936755, 0,
                            0.6, -0.8, 0,
                            0.483629, -0.690899, -0.537366,
                            0.247465, -0.40568, -0.879878,
                            0, 4.47028e-008 , -1,
                            -0.236617, 0.486025, -0.841304,
                            -0.378646, 0.824393, -0.420717,
                            -0.410365, 0.911921, 0,
                            0.442188, -0.761824, -0.473386,
                            0.269127, -0.237807, -0.933284,
                            -0.0048962, 0.343262, -0.939227,
                            -0.215548, 0.655028, -0.724208,
                            -0.387053, 0.82495, -0.411884,
                            0.612385, -0.337369, -0.714959,
                            0.218114, 0.441124, -0.870538,
                            -0.0195232, 0.746221, -0.665412,
                            -0.14959, 0.863648, -0.481389,
                            -0.253997, 0.928138, -0.272112,
                            0.0539562, 0.992309, -0.111404,
                            -0.00787199, 0.994104, -0.108144,
                            -0.0348909, 0.997622, -0.0594425,
                            -0.0369306, 0.999286, -0.00796709,
                            -0.0182318, 0.999613, 0.0210199,
                            -0.223743, 0.943891, 0.242919,
                            -0.144372, 0.876437, 0.459364,
                            -0.0300305, 0.787466, 0.615626,
                            0.148478, 0.676276, 0.721529,
                            0.507717, 0.525323, 0.682832,
                            -0.316294, 0.875642, 0.364979,
                            -0.199104, 0.663019, 0.72164,
                            -0.0103804, 0.344672, 0.938666,
                            0.241289, -0.0136406, 0.970357,
                            0.577417, -0.400034, 0.711732,
                            -0.378646, 0.824393, 0.420718,
                            -0.236617, 0.486023, 0.841305,
                            0, -4.47028e-008, 1,
                            0.247466, -0.405682, 0.879877,
                            0.48363, -0.690899, 0.537365,
                            0.249998, 0.968246, 0,
                            0.001257, 0.999999, 0,
                            0.241077, 0.968356, 0.0645611,
                            0.00120899, 0.999999, 0.000335259,
                            0.215548, 0.968509, 0.124615,
                            0.00108352, 0.999999, 0.000626407,
                            0.175886, 0.96857, 0.175886,
                            0.124616, 0.968509, 0.215548,
                            0.0645611, 0.968356, 0.241077,
                            0, 0.968246, 0.249998,
                            0.989204, 0.146548, 0,
                            0.955495, 0.146755, 0.255913,
                            0.856312, 0.147029, 0.495088,
                            0.699411, 0.147135, 0.699411,
                            0.495089, 0.147029, 0.856312,
                            0.255914, 0.146754, 0.955495,
                            0, 0.146548, 0.989204,
                            0.780869, -0.624695, 0,
                            0.753687, -0.625441, 0.201937,
                            0.674735, -0.626493, 0.390178,
                            0.550895, -0.62692, 0.550896,
                            0.390179, -0.626493, 0.674734,
                            0.201938, -0.625441, 0.753688,
                            0, -0.624695, 0.780869,
                            0.747409, -0.664364, 0,
                            0.721243, -0.665116, 0.193465,
                            0.645526, -0.66618, 0.373497,
                            0.527081, -0.666611, 0.527081,
                            0.373498, -0.66618, 0.645526,
                            0.193466, -0.665116, 0.721243,
                            0, -0.664364, 0.747409,
                            0.950775, -0.309882, 0,
                            0.917897, -0.310647, 0.246906,
                            0.822132, -0.311772, 0.476337,
                            0.671753, -0.312241, 0.671754,
                            0.476338, -0.311771, 0.822132,
                            0.246907, -0.310647, 0.917897,
                            0, -0.309882, 0.950775,
                            0.6, 0.8, 0,
                            0.578783, 0.800417, 0.15602,
                            0.517905, 0.800964, 0.300385,
                            0.423156, 0.801173, 0.423156,
                            0.300386, 0.800964, 0.517904,
                            0.156021, 0.800416, 0.578784,
                            0, 0.799999, 0.600001,
                            0, 0.968246, 0.249998,
                            -0.064561, 0.968356, 0.241077,
                            -0.124615, 0.968509, 0.215548,
                            -0.175885, 0.968571, 0.175885,
                            -0.215548, 0.968509, 0.124616,
                            -0.241076, 0.968356, 0.064561,
                            -0.249998, 0.968246, 0,
                            0, 0.146549, 0.989203,
                            -0.255913, 0.146755, 0.955495,
                            -0.495088, 0.14703, 0.856312,
                            -0.699411, 0.147136, 0.699411,
                            -0.856311, 0.14703, 0.495089,
                            -0.955495, 0.146755, 0.255914,
                            -0.989203, 0.146549, 0,
                            -0.201937, -0.625441, 0.753688,
                            -0.390178, -0.626493, 0.674735,
                            -0.550895, -0.62692, 0.550896,
                            -0.674734, -0.626493, 0.390179,
                            -0.753687, -0.625441, 0.201939,
                            -0.780869, -0.624695, 0,
                            0, -0.664364, 0.747409,
                            -0.193465, -0.665116, 0.721244,
                            -0.373497, -0.66618, 0.645527,
                            -0.527081, -0.666611, 0.527081,
                            -0.645526, -0.66618, 0.373498,
                            -0.721243, -0.665116, 0.193466,
                            -0.747409, -0.664364, 0,
                            0, -0.309883, 0.950775,
                            -0.246906, -0.310648, 0.917897,
                            -0.476336, -0.311773, 0.822132,
                            -0.671753, -0.312242, 0.671753,
                            -0.822131, -0.311773, 0.476338,
                            -0.917897, -0.310648, 0.246907,
                            -0.950775, -0.309883, 0,
                            -0.15602, 0.800417, 0.578784,
                            -0.300385, 0.800964, 0.517905,
                            -0.423156, 0.801173, 0.423156,
                            -0.517904, 0.800964, 0.300386,
                            -0.578783, 0.800417, 0.15602,
                            -0.6, 0.8, 0,
                            -0.249998, 0.968246, 0,
                            -0.241077, 0.968356, -0.064561,
                            -0.215548, 0.968509, -0.124615,
                            -0.175885, 0.968571, -0.175885,
                            -0.124616, 0.968509, -0.215548,
                            -0.064561, 0.968356, -0.241077,
                            0, 0.968246, -0.249998,
                            -0.989204, 0.146547, 0,
                            -0.955496, 0.146753, -0.255912,
                            -0.856312, 0.147028, -0.495088,
                            -0.699411, 0.147134, -0.699411,
                            -0.495089, 0.147028, -0.856312,
                            -0.255914, 0.146753, -0.955495,
                            0, 0.146547, -0.989204,
                            -0.753688, -0.625441, -0.201937,
                            -0.674735, -0.626494, -0.390178,
                            -0.550896, -0.62692, -0.550895,
                            -0.390179, -0.626494, -0.674734,
                            -0.201938, -0.625441, -0.753687,
                            0, -0.624695, -0.780869,
                            -0.747409, -0.664364, 0,
                            -0.721244, -0.665116, -0.193465,
                            -0.645526, -0.66618, -0.373497,
                            -0.527081, -0.666612, -0.527081,
                            -0.373498, -0.66618, -0.645526,
                            -0.193466, -0.665116, -0.721243,
                            0, -0.664364, -0.747409,
                            -0.950776, -0.30988, 0,
                            -0.917898, -0.310645, -0.246906,
                            -0.822133, -0.31177, -0.476337,
                            -0.671754, -0.312239, -0.671754,
                            -0.476338, -0.31177, -0.822132,
                            -0.246907, -0.310646, -0.917898,
                            0, -0.309881, -0.950775,
                            -0.578783, 0.800417, -0.15602,
                            -0.517905, 0.800964, -0.300384,
                            -0.423155, 0.801174, -0.423155,
                            -0.300386, 0.800964, -0.517904,
                            -0.15602, 0.800417, -0.578783,
                            0, 0.8, -0.6,
                            0.064561, 0.968356, -0.241077,
                            0.124615, 0.968509, -0.215548,
                            0.175885, 0.968571, -0.175885,
                            0.215549, 0.968509, -0.124616,
                            0.241077, 0.968356, -0.064561,
                            0.249998, 0.968246, 0,
                            0.255913, 0.146754, -0.955496,
                            0.495088, 0.147028, -0.856312,
                            0.699411, 0.147134, -0.699411,
                            0.856312, 0.147028, -0.495089,
                            0.955495, 0.146753, -0.255914,
                            0.989204, 0.146547, 0,
                            0.201937, -0.625441, -0.753687,
                            0.390178, -0.626494, -0.674735,
                            0.550896, -0.62692, -0.550895,
                            0.674734, -0.626494, -0.390179,
                            0.753687, -0.625441, -0.201938,
                            0.193465, -0.665116, -0.721243,
                            0.373497, -0.66618, -0.645526,
                            0.527081, -0.666612, -0.527081,
                            0.645526, -0.66618, -0.373498,
                            0.721244, -0.665116, -0.193466,
                            0.747409, -0.664364, 0,
                            0.246906, -0.310646, -0.917898,
                            0.476337, -0.31177, -0.822133,
                            0.671754, -0.312239, -0.671754,
                            0.822133, -0.31177, -0.476338,
                            0.917898, -0.310646, -0.246907,
                            0.950776, -0.30988, 0,
                            0.15602, 0.800417, -0.578783,
                            0.300384, 0.800964, -0.517905,
                            0.423155, 0.801174, -0.423155,
                            0.517904, 0.800964, -0.300386,
                            0.578783, 0.800417, -0.15602,
                            0.268354, 0.96332, 0,
                            0.258757, 0.963421, 0.0697519,
                            0.231413, 0.963552, 0.134219,
                            0.189037, 0.963603, 0.189037,
                            0.13422, 0.963552, 0.231413,
                            0.0697519, 0.963421, 0.258756,
                            0, 0.96332, 0.268354,
                            0.168031, 0.985782, 0,
                            0.162012, 0.985822, 0.0436728,
                            0.144879, 0.985875, 0.0840299,
                            0.118345, 0.985895, 0.118345,
                            0.0840302, 0.985875, 0.144879,
                            0.0436728, 0.985822, 0.162011,
                            0, 0.985782, 0.168031,
                            0.14834, 0.988936, 0,
                            0.143025, 0.988968, 0.0385546,
                            0.127899, 0.989009, 0.0741814,
                            0.104474, 0.989025, 0.104474,
                            0.0741816, 0.989009, 0.127899,
                            0.0385547, 0.988968, 0.143025,
                            0, 0.988936, 0.148341,
                            0.193633, 0.981074, 0,
                            0.186698, 0.981127, 0.0503274,
                            0.166959, 0.981197, 0.0968359,
                            0.136382, 0.981224, 0.136382,
                            0.0968361, 0.981197, 0.166958,
                            0.0503276, 0.981127, 0.186699,
                            0, 0.981074, 0.193633,
                            0.390291, 0.920691, 0,
                            0.376377, 0.920895, 0.101458,
                            0.336655, 0.921161, 0.19526,
                            0.275023, 0.921262, 0.275023,
                            0.19526, 0.921161, 0.336655,
                            0.101459, 0.920894, 0.376377,
                            0, 0.920691, 0.390291,
                            1, 0, 0,
                            0.965535, -2.6932e-008, 0.260274,
                            0.865031, -2.65808e-008, 0.501718,
                            0.707107, -1.58043e-008, 0.707107,
                            0.501719, -5.72865e-009, 0.865031,
                            0.260276, -7.99283e-010, 0.965534,
                            0, 0, 1,
                            -0.0697519, 0.963421, 0.258757,
                            -0.134219, 0.963552, 0.231413,
                            -0.189037, 0.963603, 0.189037,
                            -0.231413, 0.963552, 0.13422,
                            -0.258756, 0.963421, 0.0697519,
                            -0.268354, 0.96332, 0,
                            -0.0436727, 0.985822, 0.162012,
                            -0.0840298, 0.985875, 0.144879,
                            -0.118345, 0.985895, 0.118345,
                            -0.144879, 0.985875, 0.0840302,
                            -0.162011, 0.985822, 0.0436728,
                            -0.168031, 0.985782, 0,
                            -0.0385546, 0.988968, 0.143025,
                            -0.0741813, 0.989009, 0.127899,
                            -0.104474, 0.989025, 0.104474,
                            -0.127899, 0.989009, 0.0741816,
                            -0.143025, 0.988968, 0.0385547,
                            -0.14834, 0.988936, 0,
                            -0.0503274, 0.981127, 0.186698,
                            -0.0968359, 0.981197, 0.166959,
                            -0.136382, 0.981224, 0.136382,
                            -0.166958, 0.981197, 0.0968361,
                            -0.186699, 0.981127, 0.0503276,
                            -0.193633, 0.981074, 0,
                            -0.101458, 0.920895, 0.376377,
                            -0.19526, 0.921161, 0.336655,
                            -0.275023, 0.921262, 0.275023,
                            -0.336655, 0.921161, 0.19526,
                            -0.376377, 0.920894, 0.101459,
                            -0.390291, 0.920691, 0,
                            -0.260274, -7.99271e-010, 0.965535,
                            -0.501718, -5.72859e-009, 0.865031,
                            -0.707107, -1.58043e-008, 0.707107,
                            -0.865031, -2.65808e-008, 0.501719,
                            -0.965534, -2.69321e-008, 0.260276,
                            -1, 0, 0,
                            -0.258757, 0.963421, -0.0697518,
                            -0.231413, 0.963552, -0.134219,
                            -0.189037, 0.963603, -0.189037,
                            -0.13422, 0.963552, -0.231413,
                            -0.0697518, 0.963421, -0.258756,
                            0, 0.96332, -0.268354,
                            -0.162012, 0.985822, -0.0436727,
                            -0.144879, 0.985875, -0.0840298,
                            -0.118345, 0.985895, -0.118345,
                            -0.0840302, 0.985875, -0.144879,
                            -0.0436727, 0.985822, -0.162011,
                            0, 0.985782, -0.168031,
                            -0.143025, 0.988968, -0.0385546,
                            -0.127899, 0.989009, -0.0741813,
                            -0.104474, 0.989025, -0.104474,
                            -0.0741816, 0.989009, -0.127899,
                            -0.0385547, 0.988968, -0.143025,
                            0, 0.988936, -0.14834,
                            -0.186698, 0.981127, -0.0503273,
                            -0.166959, 0.981197, -0.0968358,
                            -0.136382, 0.981224, -0.136382,
                            -0.0968361, 0.981197, -0.166958,
                            -0.0503276, 0.981127, -0.186699,
                            0, 0.981074, -0.193633,
                            -0.376377, 0.920895, -0.101458,
                            -0.336655, 0.921161, -0.19526,
                            -0.275023, 0.921262, -0.275023,
                            -0.19526, 0.921161, -0.336655,
                            -0.101459, 0.920894, -0.376377,
                            0, 0.920691, -0.390291,
                            -0.965535, 2.6932e-008, -0.260274,
                            -0.865031, 2.65807e-008, -0.501718,
                            -0.707107, 1.58043e-008, -0.707107,
                            -0.501719, 5.72864e-009, -0.865031,
                            -0.260276, 7.99283e-010, -0.965534,
                            0, 0 , -1,
                            0.0697518, 0.963421, -0.258757,
                            0.134219, 0.963552, -0.231413,
                            0.189037, 0.963603, -0.189037,
                            0.231413, 0.963552, -0.13422,
                            0.258756, 0.963421, -0.0697518,
                            0.0436727, 0.985822, -0.162012,
                            0.0840298, 0.985875, -0.144879,
                            0.118345, 0.985895, -0.118345,
                            0.144879, 0.985875, -0.0840302,
                            0.162011, 0.985822, -0.0436727,
                            0.0385546, 0.988968, -0.143025,
                            0.0741813, 0.989009, -0.127899,
                            0.104474, 0.989025, -0.104474,
                            0.127899, 0.989009, -0.0741816,
                            0.143025, 0.988968, -0.0385547,
                            0.0503274, 0.981127, -0.186698,
                            0.0968359, 0.981197, -0.166959,
                            0.136382, 0.981224, -0.136382,
                            0.166958, 0.981197, -0.0968361,
                            0.186699, 0.981127, -0.0503276,
                            0.101458, 0.920895, -0.376377,
                            0.19526, 0.921161, -0.336655,
                            0.275023, 0.921262, -0.275023,
                            0.336655, 0.921161, -0.19526,
                            0.376377, 0.920894, -0.101459,
                            0.260274, 7.99271e-010, -0.965535,
                            0.501718, 5.72859e-009, -0.865031,
                            0.707107, 1.58043e-008, -0.707107,
                            0.865031, 2.65807e-008, -0.501719,
                            0.965534, 2.6932e-008, -0.260276,
                            0.0226746, -0.999743, -1.91575e-007,
                            0.00017586 , -1, -1.78936e-007,
                            0.0218614, -0.999744, -0.00589325,
                            0.0195486, -0.999745, -0.0113383,
                            0.0159681, -0.999745, -0.0159682,
                            0.0113382, -0.999745, -0.0195487,
                            0.0058931, -0.999744, -0.0218616,
                            0, -0.999743, -0.0226747,
                            0.0623783, -0.998053, -2.05165e-007,
                            0.0601415, -0.998058, -0.0162122,
                            0.0537792, -0.998066, -0.0311921,
                            0.0439291, -0.998068, -0.0439292,
                            0.031192, -0.998066, -0.0537793,
                            0.0162121, -0.998058, -0.0601416,
                            0, -0.998053, -0.0623784,
                            0.141421, -0.98995, -2.16354e-007,
                            0.136353, -0.989978, -0.0367563,
                            0.121933, -0.990016, -0.0707209,
                            0.0996006, -0.99003, -0.0996008,
                            0.070721, -0.990016, -0.121933,
                            0.0367563, -0.989978, -0.136353,
                            0, -0.98995, -0.141421,
                            0.328521, -0.944497, -2.21665e-007,
                            0.316788, -0.944644, -0.0853952,
                            0.283332, -0.944838, -0.164332,
                            0.231454, -0.944912, -0.231454,
                            0.164333, -0.944838, -0.283331,
                            0.0853954, -0.944644, -0.316788,
                            0, -0.944497, -0.328521,
                            0.770022, -0.638017, -1.57624e-007,
                            0.743044, -0.638566, -0.200299,
                            0.665183, -0.639286, -0.385806,
                            0.543581, -0.639561, -0.543581,
                            0.385806, -0.639286, -0.665182,
                            0.2003, -0.638566, -0.743044,
                            0, -0.638017, -0.770022,
                            0.965535, 2.69333e-008, -0.260274,
                            0.865031, 2.6582e-008, -0.501718,
                            0.501719, 5.7289e-009, -0.865031,
                            0.260276, 7.9932e-010, -0.965534,
                            0, -0.999743, -0.0226747,
                            -0.00589307, -0.999744, -0.0218616,
                            -0.0113382, -0.999745, -0.0195487,
                            -0.015968, -0.999745, -0.0159682,
                            -0.0195486, -0.999745, -0.0113384,
                            -0.0218614, -0.999744, -0.00589328,
                            -0.0226746, -0.999743, -1.91575e-007,
                            0, -0.998053, -0.0623784,
                            -0.016212, -0.998058, -0.0601416,
                            -0.0311919, -0.998066, -0.0537794,
                            -0.0439291, -0.998068, -0.0439292,
                            -0.0537792, -0.998066, -0.0311922,
                            -0.0601415, -0.998058, -0.0162123,
                            -0.0623783, -0.998053, -2.05165e-007,
                            -0.0367561, -0.989978, -0.136353,
                            -0.0707208, -0.990016, -0.121933,
                            -0.0996006, -0.99003, -0.0996008,
                            -0.121932, -0.990016, -0.0707211,
                            -0.136353, -0.989978, -0.0367565,
                            -0.141421, -0.98995, -2.16354e-007,
                            0, -0.944497, -0.32852,
                            -0.0853949, -0.944644, -0.316788,
                            -0.164332, -0.944838, -0.283331,
                            -0.231454, -0.944912, -0.231454,
                            -0.283331, -0.944838, -0.164333,
                            -0.316788, -0.944644, -0.0853956,
                            -0.32852, -0.944497, -2.21665e-007,
                            0, -0.638018, -0.770021,
                            -0.200298, -0.638567, -0.743043,
                            -0.385805, -0.639287, -0.665182,
                            -0.543581, -0.639562, -0.543581,
                            -0.665181, -0.639287, -0.385806,
                            -0.743043, -0.638567, -0.2003,
                            -0.770021, -0.638018, -1.57625e-007,
                            -0.260274, 7.99307e-010, -0.965535,
                            -0.501718, 5.72886e-009, -0.865031,
                            -0.865031, 2.65819e-008, -0.501719,
                            -0.965534, 2.69333e-008, -0.260276,
                            -0.0226746, -0.999743, -1.91442e-007,
                            -0.0218614, -0.999744, 0.00589289,
                            -0.0195486, -0.999745, 0.011338,
                            -0.0159681, -0.999745, 0.0159679,
                            -0.0113382, -0.999745, 0.0195484,
                            -0.0058931, -0.999744, 0.0218612,
                            0, -0.999743, 0.0226744,
                            -0.0623783, -0.998053, -2.04538e-007,
                            -0.0601415, -0.998058, 0.0162119,
                            -0.0537793, -0.998066, 0.0311918,
                            -0.0439291, -0.998068, 0.0439289,
                            -0.031192, -0.998066, 0.0537791,
                            -0.0162121, -0.998058, 0.0601414,
                            0, -0.998053, 0.0623782,
                            -0.136353, -0.989978, 0.0367559,
                            -0.121932, -0.990016, 0.0707206,
                            -0.0996006, -0.99003, 0.0996005,
                            -0.0707209, -0.990016, 0.121932,
                            -0.0367563, -0.989978, 0.136353,
                            0, -0.98995, 0.141421,
                            -0.328521, -0.944497, -2.1827e-007,
                            -0.316789, -0.944644, 0.0853949,
                            -0.283332, -0.944838, 0.164332,
                            -0.231455, -0.944911, 0.231454,
                            -0.164333, -0.944837, 0.283332,
                            -0.0853956, -0.944644, 0.316789,
                            0, -0.944497, 0.328521,
                            -0.770023, -0.638016, -1.53325e-007,
                            -0.743045, -0.638564, 0.200299,
                            -0.665184, -0.639284, 0.385806,
                            -0.543582, -0.63956, 0.543582,
                            -0.385807, -0.639284, 0.665183,
                            -0.2003, -0.638564, 0.743045,
                            0, -0.638016, 0.770023,
                            -0.965535, -2.69333e-008, 0.260274,
                            -0.865031, -2.6582e-008, 0.501718,
                            -0.707107, -1.58051e-008, 0.707107,
                            -0.501719, -5.7289e-009, 0.865031,
                            -0.260276, -7.9932e-010, 0.965534,
                            0.00589307, -0.999744, 0.0218612,
                            0.0113382, -0.999745, 0.0195484,
                            0.0159681, -0.999745, 0.0159679,
                            0.0195486, -0.999745, 0.011338,
                            0.0218614, -0.999744, 0.00589292,
                            0.0226746, -0.999743, -1.91442e-007,
                            0.016212, -0.998058, 0.0601414,
                            0.0311919, -0.998066, 0.0537791,
                            0.0439291, -0.998068, 0.0439289,
                            0.0537792, -0.998066, 0.0311918,
                            0.0601415, -0.998058, 0.016212,
                            0.0623783, -0.998053, -2.04538e-007,
                            0.0367561, -0.989978, 0.136353,
                            0.0707208, -0.990016, 0.121932,
                            0.0996006, -0.99003, 0.0996005,
                            0.121932, -0.990016, 0.0707208,
                            0.136353, -0.989978, 0.0367561,
                            0.0853951, -0.944644, 0.316789,
                            0.164332, -0.944838, 0.283332,
                            0.231455, -0.944911, 0.231454,
                            0.283332, -0.944837, 0.164333,
                            0.316789, -0.944644, 0.0853954,
                            0.328521, -0.944497, -2.1827e-007,
                            0.200299, -0.638564, 0.743045,
                            0.385806, -0.639284, 0.665184,
                            0.543582, -0.63956, 0.543582,
                            0.665183, -0.639284, 0.385807,
                            0.743045, -0.638565, 0.2003,
                            0.770023, -0.638016, -1.53325e-007,
                            0.260274, -7.99307e-010, 0.965535,
                            0.501718, -5.72886e-009, 0.865031,
                            0.707107, -1.58051e-008, 0.707107,
                            0.865031, -2.65819e-008, 0.501719,
                            0.965534, -2.69333e-008, 0.260276,
                            0.000169553 , -1, 4.55269e-005,
                            0.000151615 , -1, 8.7758e-005,
                            0.000123845 , -1, 0.000123666,
                            8.79365e-005 , -1, 0.000151436,
                            4.57054e-005 , -1, 0.000169374,
                            0 , -1, 0.000175681,
                            -4.57057e-005 , -1, 0.000169374,
                            -8.79367e-005 , -1, 0.000151436,
                            -0.000123845 , -1, 0.000123666,
                            -0.000151615 , -1, 8.77577e-005,
                            -0.000169553 , -1, 4.55266e-005,
                            -0.00017586 , -1, -1.78936e-007,
                            -0.141421, -0.98995, -2.18023e-007,
                            0 , -1, -0.000176026,
                            -4.57022e-005 , -1, -0.000169719,
                            -8.79303e-005 , -1, -0.000151783,
                            -0.000123836 , -1, -0.000124015,
                            -0.000151604 , -1, -8.81092e-005,
                            -0.00016954 , -1, -4.58813e-005,
                            -0.000175847 , -1, -1.78936e-007,
                            0.141421, -0.98995, -2.18023e-007,
                            0.000175847 , -1, -1.78936e-007,
                            0.000169541 , -1, -4.58811e-005,
                            0.000151604 , -1, -8.81091e-005,
                            0.000123836 , -1, -0.000124015,
                            8.79306e-005 , -1, -0.000151783,
                            4.57025e-005 , -1, -0.000169719,
                            0.423155, 0.801174, 0.423155,
                            0.300386, 0.800964, 0.517905,
                            0.15602, 0.800417, 0.578784,
                            0, 0.8, 0.6,
                            0.000884181, 0.999999, 0.000884182,
                            0.0006461, 0.999999, 0.00107175,
                            0.000305924, 0.999999, 0.00121748,
                            0, 0.999999, 0.001257,
                            0.00125688, 0.999999, 0,
                            0.00121716, 0.999999, -0.000305839,
                            0.00107193, 0.999999, -0.000646202,
                            0.00088386, 0.999999, -0.00088386,
                            0.000626479, 0.999999, -0.00108364,
                            0.000335298, 0.999999, -0.00120914,
                            0, 0.999999, -0.00125688,
                            -0.000305839, 0.999999, -0.00121716,
                            -0.000646202, 0.999999, -0.00107193,
                            -0.00088386, 0.999999, -0.00088386,
                            -0.00108364, 0.999999, -0.000626479,
                            -0.00120914, 0.999999, -0.000335298,
                            -0.00125688, 0.999999, 0,
                            0.517904, 0.800965, -0.300385,
                            0.300384, 0.800965, -0.517904,
                            0.15602, 0.800418, -0.578782,
                            0, 0.800001, -0.599999,
                            -0.15602, 0.800418, -0.578783,
                            -0.300385, 0.800965, -0.517903,
                            -0.517904, 0.800965, -0.300384,
                            -0.15602, 0.800417, 0.578783,
                            -0.300384, 0.800964, 0.517905,
                            -0.423155, 0.801174, 0.423155,
                            0, 0.999999, 0.00125701,
                            -0.000335262, 0.999999, 0.00120901,
                            -0.000626413, 0.999999, 0.00108353,
                            -0.00088419, 0.999999, 0.00088419,
                            -0.00107176, 0.999999, 0.000646106,
                            -0.00121749, 0.999999, 0.000305927,
                            -0.00125701, 0.999999, 0,
                            0.366221, -0.855433, -0.36622,
                            -0.497164, 0.711096, -0.497162,
                            -0.6, 0.8, 0,
                            -0.267367, 0.443287, 0.855577,
                            -0.0149983, 0.999888, 0,
                            -1, 0, 0,
                            -0.811257, -0.584689, -4.21204e-009,
                            0.811257, -0.584689, -4.21204e-009,
                            -0.6981, -0.716, -1.86057e-008,
                            0.6981, -0.716, -1.86057e-008,
                            -0.636383, -0.771373, -5.10224e-008,
                            0.636383, -0.771373, -5.10224e-008,
                            -0.675056, -0.737767, -1.01053e-007,
                            0.675056, -0.737767, -1.01053e-007,
                            0.965535, -2.6933e-008, 0.260274,
                            0.902861, 0.429933, 0,
                            0.637936, 0.431366, -0.637936,
                            0, 0.429933, -0.902861,
                            -0.637936, 0.431366, -0.637936,
                            -0.902861, 0.429933, 0,
                            0, 0.429933, 0.902861,
                            -0.637936, 0.431366, 0.637936,
                            -0.556737, 0.830689, 0,
                            0.637936, 0.431366, 0.637936,
                            0, -0.156768, -0.987635,
                            -0.148341, 0.988936, 0,
                            0.148341, 0.988936, 0};

short teapot_indices[] = {   
                            1122, 1243, 1272, 1242, 1273, 1241, 1274, 1240, 
                        1275, 1239, 1276, 1238, 1277, 1205, 1278, 1204, 
                        1279, 1203, 1280, 1202, 1281, 1201, 1282, 1200, 
                        1283, 1199, -1, 1243, 1249, 1242, 1248, 1241, 1247, 
                        1240, 1246, 1239, 1245, 1238, 1244, 1205, 1212, 
                        1204, 1211, 1203, 1210, 1202, 1209, 1201, 1208, 
                        1200, 1207, 1199, 1206, -1, 1249, 1136, 1248, 1254, 
                        1247, 1253, 1246, 1252, 1245, 1251, 1244, 1250, 
                        1212, 1218, 1211, 1217, 1210, 1216, 1209, 1215, 
                        1208, 1214, 1207, 1213, 1206, 1180, -1, 1136, 1260, 
                        1254, 1259, 1253, 1258, 1252, 1257, 1251, 1256, 
                        1250, 1255, 1218, 1225, 1217, 1224, 1216, 1223, 
                        1215, 1222, 1214, 1221, 1213, 1220, 1180, 1219, 
                        -1, 1260, 1266, 1259, 1265, 1258, 1264, 1257, 1263, 
                        1256, 1262, 1255, 1261, 1225, 1232, 1224, 1231, 
                        1223, 1230, 1222, 1229, 1221, 1228, 1220, 1227, 
                        1219, 1226, -1, 1266, 384, 1265, 1271, 1264, 1270, 
                        1263, 1269, 1262, 1268, 1261, 1267, 1232, 390, 
                        1231, 1237, 1230, 1236, 1229, 1235, 1228, 1234, 
                        1227, 1233, 1226, 426, -1, 462, 1188, 1195, 1189, 
                        1196, 1190, 459, 1191, 1197, 1192, 1198, 1193, 
                        426, 1194, -1, 1188, 1181, 1189, 1182, 1190, 1183, 
                        1191, 1184, 1192, 1185, 1193, 1186, 1194, 1187, 
                        -1, 1181, 1142, 1182, 1175, 1183, 1176, 1184, 1177, 
                        1185, 1178, 1186, 1179, 1187, 1284, -1, 1142, 1168, 
                        1175, 1169, 1176, 1170, 1177, 1171, 1178, 1172, 
                        1179, 1173, 1284, 1174, -1, 1168, 1161, 1169, 1162, 
                        1170, 1163, 1171, 1164, 1172, 1165, 1173, 1166, 
                        1174, 1167, -1, 1161, 1285, 1162, 1286, 1163, 1287, 
                        1164, 1288, 1165, 1289, 1166, 1290, 1167, 1291, 
                        -1, 384, 1150, 1157, 1151, 1158, 1152, 490, 1153, 
                        1159, 1154, 1160, 1155, 462, 1156, -1, 1150, 1143, 
                        1151, 1144, 1152, 1145, 1153, 1146, 1154, 1147, 
                        1155, 1148, 1156, 1149, -1, 1143, 1292, 1144, 1137, 
                        1145, 1138, 1146, 1139, 1147, 1140, 1148, 1141, 
                        1149, 1142, -1, 1292, 1129, 1137, 1130, 1138, 1131, 
                        1139, 1132, 1140, 1133, 1141, 1134, 1142, 1135, 
                        -1, 1129, 1121, 1130, 1123, 1131, 1124, 1132, 1125, 
                        1133, 1126, 1134, 1127, 1135, 1128, -1, 1121, 1293, 
                        1123, 1294, 1124, 1295, 1125, 1296, 1126, 1297, 
                        1127, 1298, 1128, 1285, -1, 902, 1024, 901, 1023, 
                        900, 1022, 899, 1021, 898, 1020, 897, 1019, 
                        862, 983, 861, 982, 860, 981, 859, 980, 
                        858, 979, 857, 978, 856, 977, -1, 856, 849, 
                        857, 850, 858, 851, 1299, 852, 1300, 853, 
                        1301, 854, 1302, 855, -1, 849, 842, 850, 843, 
                        851, 844, 852, 845, 853, 846, 854, 847, 
                        855, 848, -1, 842, 835, 843, 836, 844, 837, 
                        845, 838, 846, 839, 847, 840, 848, 841, 
                        -1, 835, 828, 836, 829, 837, 830, 838, 831, 
                        839, 832, 840, 833, 841, 834, -1, 828, 818, 
                        829, 820, 830, 822, 831, 824, 832, 825, 
                        833, 826, 834, 827, -1, 818, 819, 820, 821, 
                        822, 823, 824, 1303, 825, 1304, 826, 1305, 
                        827, 1306, -1, 1307, 948, 1308, 947, 1309, 946, 
                        1310, 945, 1311, 944, 1312, 943, 1313, 909, 
                        1314, 908, 1315, 907, 1316, 906, 1317, 905, 
                        1318, 904, 1319, 903, -1, 948, 954, 947, 953, 
                        946, 952, 945, 951, 944, 950, 943, 949, 
                        909, 916, 908, 915, 907, 914, 906, 913, 
                        905, 912, 904, 911, 903, 910, -1, 954, 835, 
                        953, 959, 952, 958, 951, 957, 950, 956, 
                        949, 955, 916, 922, 915, 921, 914, 920, 
                        913, 919, 912, 918, 911, 917, 910, 882, 
                        -1, 835, 965, 959, 964, 958, 963, 957, 962, 
                        956, 961, 955, 960, 922, 929, 921, 928, 
                        920, 927, 919, 926, 918, 925, 917, 924, 
                        882, 923, -1, 965, 971, 964, 970, 963, 969, 
                        962, 968, 961, 967, 960, 966, 929, 936, 
                        928, 935, 927, 934, 926, 933, 925, 932, 
                        924, 931, 923, 930, -1, 971, 856, 970, 976, 
                        969, 975, 968, 974, 967, 973, 966, 972, 
                        936, 942, 935, 941, 934, 940, 933, 939, 
                        932, 938, 931, 937, 930, 902, -1, 856, 977, 
                        976, 1095, 1320, 1094, 974, 1093, 1321, 1092, 
                        1322, 1091, 1323, 1060, 1324, 1059, 1325, 1058, 
                        939, 1057, 1326, 1056, 937, 1055, 902, 1024, 
                        -1, 1302, 890, 1327, 891, 1328, 892, 1329, 893, 
                        900, 894, 901, 895, 902, 896, -1, 890, 883, 
                        891, 884, 892, 885, 893, 886, 894, 887, 
                        895, 888, 896, 889, -1, 883, 841, 884, 877, 
                        885, 878, 886, 879, 887, 880, 888, 881, 
                        889, 882, -1, 841, 870, 877, 871, 878, 872, 
                        879, 873, 880, 874, 881, 875, 882, 876, 
                        -1, 870, 863, 871, 864, 872, 865, 873, 866, 
                        874, 867, 875, 868, 876, 869, -1, 863, 1330, 
                        864, 1331, 865, 1332, 866, 1333, 867, 1334, 
                        868, 1335, 869, 1336, -1, 787, 780, 813, 808, 
                        814, 809, 815, 810, 816, 811, 817, 812, 
                        781, 774, 782, 775, 783, 776, 784, 777, 
                        785, 778, 786, 779, 787, 780, -1, 774, 767, 
                        775, 768, 776, 769, 777, 770, 778, 771, 
                        779, 772, 780, 773, -1, 767, 760, 768, 761, 
                        769, 762, 770, 763, 771, 764, 772, 765, 
                        773, 766, 803, 798, 804, 799, 805, 800, 
                        806, 801, 807, 802, 767, 760, -1, 767, 774, 
                        807, 812, 806, 811, 805, 810, 804, 809, 
                        803, 808, 773, 780, -1, 760, 753, 761, 754, 
                        762, 755, 763, 756, 764, 757, 765, 758, 
                        766, 759, 798, 793, 799, 794, 800, 795, 
                        801, 796, 802, 797, 760, 753, -1, 759, 752, 
                        793, 788, 794, 789, 795, 790, 796, 791, 
                        797, 792, 753, 746, -1, 752, 703, 788, 741, 
                        789, 742, 790, 743, 791, 744, 792, 745, 
                        746, 697, 747, 698, 748, 699, 749, 700, 
                        750, 701, 751, 702, 752, 703, -1, 752, 759, 
                        751, 758, 750, 757, 749, 756, 748, 755, 
                        747, 754, 746, 753, -1, 703, 734, 1337, 735, 
                        742, 736, 743, 737, 744, 738, 1338, 739, 
                        1339, 740, -1, 734, 727, 735, 728, 736, 729, 
                        737, 730, 738, 731, 739, 732, 740, 733, 
                        -1, 727, 682, 728, 722, 729, 723, 730, 724, 
                        731, 725, 732, 726, 733, 676, -1, 682, 716, 
                        722, 717, 723, 718, 724, 719, 725, 720, 
                        726, 721, 676, 669, -1, 716, 704, 717, 705, 
                        718, 707, 719, 709, 720, 711, 721, 713, 
                        669, 715, -1, 704, 668, 705, 706, 707, 708, 
                        709, 710, 711, 712, 713, 714, 715, 656, 
                        -1, 1339, 690, 698, 691, 1340, 692, 700, 693, 
                        701, 694, 702, 695, 703, 696, -1, 690, 683, 
                        691, 684, 692, 685, 693, 686, 694, 687, 
                        695, 688, 696, 689, -1, 683, 676, 684, 677, 
                        685, 678, 686, 679, 687, 680, 688, 681, 
                        689, 682, -1, 676, 669, 677, 670, 678, 671, 
                        679, 672, 680, 673, 681, 674, 682, 675, 
                        -1, 669, 655, 670, 657, 671, 659, 672, 661, 
                        673, 663, 674, 665, 675, 667, -1, 655, 656, 
                        657, 658, 659, 660, 661, 662, 663, 664, 
                        665, 666, 667, 668, -1, 624, 618, 650, 645, 
                        651, 646, 652, 647, 653, 648, 654, 649, 
                        266, 612, -1, 266, 612, 619, 613, 620, 614, 
                        621, 615, 622, 616, 623, 617, 624, 618, 
                        -1, 612, 605, 613, 606, 614, 607, 615, 608, 
                        616, 609, 617, 610, 618, 611, 645, 640, 
                        646, 641, 647, 642, 648, 643, 649, 644, 
                        612, 605, -1, 605, 598, 606, 599, 607, 600, 
                        608, 601, 609, 602, 610, 603, 611, 604, 
                        640, 635, 641, 636, 642, 637, 643, 638, 
                        644, 639, 605, 598, -1, 604, 597, 635, 630, 
                        636, 631, 637, 632, 638, 633, 639, 634, 
                        598, 591, -1, 597, 590, 630, 625, 631, 626, 
                        632, 627, 633, 628, 634, 629, 591, 584, 
                        -1, 590, 541, 625, 579, 626, 580, 627, 581, 
                        628, 582, 629, 583, 584, 535, 585, 536, 
                        586, 537, 587, 538, 588, 539, 589, 540, 
                        590, 541, -1, 590, 597, 589, 596, 588, 595, 
                        587, 594, 586, 593, 585, 592, 584, 591, 
                        -1, 597, 604, 596, 603, 595, 602, 594, 601, 
                        593, 600, 592, 599, 591, 598, -1, 541, 572, 
                        579, 573, 580, 574, 581, 575, 582, 576, 
                        583, 577, 535, 578, -1, 572, 565, 573, 566, 
                        574, 567, 575, 568, 576, 569, 577, 570, 
                        578, 571, -1, 565, 520, 566, 560, 567, 561, 
                        568, 562, 569, 563, 570, 564, 571, 514, 
                        -1, 520, 553, 560, 554, 561, 555, 562, 556, 
                        563, 557, 564, 558, 514, 559, -1, 553, 505, 
                        554, 542, 555, 544, 556, 546, 557, 548, 
                        558, 550, 559, 552, -1, 505, 506, 542, 543, 
                        544, 545, 546, 547, 548, 549, 550, 551, 
                        552, 494, -1, 535, 528, 536, 529, 537, 530, 
                        538, 531, 539, 532, 540, 533, 541, 534, 
                        -1, 528, 521, 529, 522, 530, 523, 531, 524, 
                        532, 525, 533, 526, 534, 527, -1, 521, 514, 
                        522, 515, 523, 516, 524, 517, 525, 518, 
                        526, 519, 527, 520, -1, 514, 507, 515, 508, 
                        516, 509, 517, 510, 518, 511, 519, 512, 
                        520, 513, -1, 507, 493, 508, 495, 509, 497, 
                        510, 499, 511, 501, 512, 503, 513, 1341, 
                        -1, 493, 494, 495, 496, 497, 498, 499, 500, 
                        501, 502, 503, 504, 1341, 506, -1, 216, 349, 
                        348, 467, 347, 466, 346, 465, 345, 464, 
                        344, 463, 310, 432, 309, 431, 308, 430, 
                        307, 429, 306, 428, 305, 427, 1342, 396, 
                        -1, 349, 356, 467, 472, 466, 471, 465, 470, 
                        464, 469, 463, 468, 432, 438, 431, 437, 
                        430, 436, 429, 435, 428, 434, 427, 433, 
                        396, 402, -1, 356, 363, 472, 477, 471, 476, 
                        470, 475, 469, 474, 468, 473, 438, 444, 
                        437, 443, 436, 442, 435, 441, 434, 440, 
                        433, 439, 402, 408, -1, 363, 370, 477, 482, 
                        476, 481, 475, 480, 474, 479, 473, 478, 
                        444, 450, 443, 449, 442, 448, 441, 447, 
                        440, 446, 439, 445, 408, 414, -1, 370, 377, 
                        482, 487, 481, 486, 480, 485, 479, 484, 
                        478, 483, 450, 456, 449, 455, 448, 454, 
                        447, 453, 446, 452, 445, 451, 414, 420, 
                        -1, 377, 384, 487, 492, 486, 491, 485, 490, 
                        484, 489, 483, 488, 456, 462, 455, 461, 
                        454, 460, 453, 459, 452, 458, 451, 457, 
                        420, 426, -1, 1342, 396, 265, 395, 264, 394, 
                        263, 393, 262, 392, 261, 391, 222, 355, 
                        221, 354, 220, 353, 219, 352, 218, 351, 
                        217, 350, 216, 349, -1, 396, 1343, 395, 401, 
                        394, 400, 393, 399, 392, 398, 391, 397, 
                        355, 362, 354, 361, 353, 360, 352, 359, 
                        351, 358, 350, 357, 349, 1344, -1, 1343, 1345, 
                        401, 407, 400, 406, 399, 405, 398, 404, 
                        397, 403, 362, 369, 361, 368, 360, 367, 
                        359, 366, 358, 365, 357, 364, 1344, 1346, 
                        -1, 1345, 1347, 407, 413, 406, 412, 405, 411, 
                        404, 410, 403, 409, 369, 376, 368, 375, 
                        367, 374, 366, 373, 365, 372, 364, 371, 
                        1346, 1348, -1, 1347, 1349, 413, 419, 412, 418, 
                        411, 417, 410, 416, 409, 415, 376, 383, 
                        375, 382, 374, 381, 373, 380, 372, 379, 
                        371, 378, 1348, 1350, -1, 1349, 426, 419, 425, 
                        418, 424, 417, 423, 416, 422, 415, 421, 
                        383, 390, 382, 389, 381, 388, 380, 387, 
                        379, 386, 378, 385, 1350, 384, -1, 42, 320, 
                        319, 318, 317, 316, 174, 315, 314, 313, 
                        312, 311, 137, 277, 276, 275, 274, 273, 
                        134, 272, 271, 270, 269, 268, 92, 267, 
                        -1, 320, 326, 318, 325, 316, 324, 315, 323, 
                        313, 322, 311, 321, 277, 284, 275, 283, 
                        273, 282, 272, 281, 270, 280, 268, 279, 
                        267, 278, -1, 326, 195, 325, 331, 324, 330, 
                        323, 329, 322, 328, 321, 327, 284, 290, 
                        283, 289, 282, 288, 281, 287, 280, 286, 
                        279, 285, 278, 246, -1, 195, 337, 331, 336, 
                        330, 335, 329, 334, 328, 333, 327, 332, 
                        290, 297, 289, 296, 288, 295, 287, 294, 
                        286, 293, 285, 292, 246, 291, -1, 337, 343, 
                        336, 342, 335, 341, 334, 340, 333, 339, 
                        332, 338, 297, 304, 296, 303, 295, 302, 
                        294, 301, 293, 300, 292, 299, 291, 298, 
                        -1, 343, 216, 342, 348, 341, 347, 340, 346, 
                        339, 345, 338, 344, 304, 310, 303, 309, 
                        302, 308, 301, 307, 300, 306, 299, 305, 
                        298, 1342, -1, 222, 254, 261, 255, 262, 256, 
                        263, 257, 264, 258, 265, 259, 1342, 260, 
                        -1, 254, 247, 255, 248, 256, 249, 257, 250, 
                        258, 251, 259, 252, 260, 253, -1, 247, 201, 
                        248, 241, 249, 242, 250, 243, 251, 244, 
                        252, 245, 253, 246, -1, 201, 234, 241, 235, 
                        242, 236, 243, 237, 244, 238, 245, 239, 
                        246, 240, -1, 234, 223, 235, 224, 236, 226, 
                        237, 228, 238, 229, 239, 231, 240, 233, 
                        -1, 223, 48, 224, 225, 226, 227, 228, 89, 
                        229, 230, 231, 232, 233, 92, -1, 216, 209, 
                        1351, 210, 218, 211, 219, 212, 220, 213, 
                        221, 214, 222, 215, -1, 209, 202, 210, 203, 
                        211, 204, 212, 205, 213, 206, 214, 207, 
                        215, 208, -1, 202, 195, 203, 196, 204, 197, 
                        205, 198, 206, 199, 207, 200, 208, 201, 
                        -1, 195, 188, 196, 189, 197, 190, 198, 191, 
                        199, 192, 200, 193, 201, 194, -1, 188, 177, 
                        189, 178, 190, 180, 191, 182, 192, 183, 
                        193, 185, 194, 187, -1, 177, 42, 178, 179, 
                        180, 181, 182, 45, 183, 184, 185, 186, 
                        187, 48, -1, 1, 148, 147, 146, 145, 144, 
                        143, 142, 141, 140, 139, 138, 105, 104, 
                        103, 102, 101, 100, 99, 98, 97, 96, 
                        95, 94, 60, 93, -1, 148, 154, 146, 153, 
                        144, 152, 142, 151, 140, 150, 138, 149, 
                        104, 112, 102, 111, 100, 110, 98, 109, 
                        96, 108, 94, 107, 93, 106, -1, 154, 21, 
                        153, 159, 152, 158, 151, 157, 150, 156, 
                        149, 155, 112, 118, 111, 117, 110, 116, 
                        109, 115, 108, 114, 107, 113, 106, 72, 
                        -1, 21, 165, 159, 164, 158, 163, 157, 162, 
                        156, 161, 155, 160, 118, 124, 117, 123, 
                        116, 122, 115, 121, 114, 120, 113, 119, 
                        72, 79, -1, 165, 171, 164, 170, 163, 169, 
                        162, 168, 161, 167, 160, 166, 124, 131, 
                        123, 130, 122, 129, 121, 128, 120, 127, 
                        119, 126, 79, 125, -1, 171, 1352, 170, 176, 
                        169, 175, 168, 1353, 167, 173, 166, 172, 
                        131, 1354, 130, 136, 129, 135, 128, 1355, 
                        127, 133, 126, 132, 125, 1356, -1, 1357, 80, 
                        87, 81, 88, 82, 1358, 83, 90, 84, 
                        91, 85, 1356, 86, -1, 80, 73, 81, 74, 
                        82, 75, 83, 76, 84, 77, 85, 78, 
                        86, 1359, -1, 73, 27, 74, 67, 75, 68, 
                        76, 69, 77, 70, 78, 71, 1359, 72, 
                        -1, 27, 20, 67, 61, 68, 62, 69, 63, 
                        70, 64, 71, 65, 72, 66, -1, 20, 12, 
                        61, 49, 62, 51, 63, 53, 64, 55, 
                        65, 57, 66, 59, -1, 12, 13, 49, 50, 
                        51, 52, 53, 54, 55, 56, 57, 58, 
                        59, 60, -1, 1352, 35, 43, 36, 44, 37, 
                        1360, 38, 46, 39, 47, 40, 1357, 41, 
                        -1, 35, 28, 36, 29, 37, 30, 38, 31, 
                        39, 32, 40, 33, 41, 34, -1, 28, 21, 
                        29, 22, 30, 23, 31, 24, 32, 25, 
                        33, 26, 34, 27, -1, 21, 14, 22, 15, 
                        23, 16, 24, 17, 25, 18, 26, 19, 
                        27, 20, -1, 14, 0, 15, 2, 16, 4, 
                        17, 6, 18, 8, 19, 10, 20, 1361, 
                        -1, 0, 1, 2, 3, 4, 5, 6, 7, 
                        8, 9, 10, 11, 1361, 13, -1, 1024, 1055, 
                        1061, 1062, 1068, 1069, 1075, 1076, 1082, 1083, 
                        1089, 1090, -1, 1089, 1088, 1082, 1081, 1075, 1074, 
                        1068, 1067, 1061, 1030, 1024, 1023, -1, 1030, 1067, 
                        1036, 1073, 1042, 1079, 1048, 1085, 1054, -1, 1085, 
                        1079, 1086, 1080, 1087, 1081, 1088, -1, 1081, 1080, 
                        1074, 1073, 1067, -1, 1080, 1079, 1073, -1, 1055, 1056, 
                        1062, 1063, 1069, 1070, 1076, 1077, 1083, 1084, 
                        1090, 1116, -1, 1056, 1057, 1063, 1064, 1070, 1071, 
                        1077, 1078, 1084, 1111, 1116, 1117, -1, 1057, 1058, 
                        1064, 1065, 1071, 1072, 1078, 1106, 1111, 1112, 
                        1117, 1118, -1, 1058, 1059, 1065, 1066, 1072, 1101, 
                        1106, 1107, 1112, 1113, 1118, 1119, -1, 1059, 1060, 
                        1066, 1096, 1101, 1102, 1107, 1108, 1113, 1114, 
                        1119, 1120, -1, 1060, 1091, 1096, 1097, 1102, 1103, 
                        1108, 1109, 1114, 1115, 1120, 1012, -1, 1091, 1092, 
                        1097, 1098, 1103, 1104, 1109, 1110, 1115, 1005, 
                        1012, 1013, -1, 1092, 1093, 1098, 1099, 1104, 1105, 
                        1110, 998, 1005, 1006, 1013, 1014, -1, 998, 1105, 
                        991, 1100, 984, 1095, 977, -1, 1095, 1100, 1094, 
                        1099, 1093, -1, 1100, 1105, 1099, -1, 984, 977, 985, 
                        978, 986, 979, 987, 980, 988, 981, 989, 
                        982, 990, 983, 1025, 1019, 1026, 1020, 1027, 
                        1021, 1028, 1022, 1029, 1023, 1030, -1, 1030, 1362, 
                        1029, 1035, 1028, 1034, 1027, 1033, 1026, 1032, 
                        1025, 1031, 990, 997, 989, 996, 988, 995, 
                        987, 994, 986, 993, 985, 992, 984, 1363, 
                        -1, 1362, 1042, 1035, 1041, 1034, 1040, 1033, 1039, 
                        1032, 1038, 1031, 1037, 997, 1004, 996, 1003, 
                        995, 1002, 994, 1001, 993, 1000, 992, 999, 
                        1363, 998, -1, 998, 999, 1006, 1007, 1014, 1015, 
                        -1, 999, 1000, 1007, 1008, 1015, 1016, -1, 1000, 1001, 
                        1008, 1009, 1016, 1017, -1, 1001, 1002, 1009, 1010, 
                        1017, 1018, -1, 1002, 1003, 1010, 1011, 1018, 1049, 
                        -1, 1003, 1004, 1011, 1043, 1049, 1050, -1, 1004, 1037, 
                        1043, 1044, 1050, 1051, -1, 1037, 1038, 1044, 1045, 
                        1051, 1052, -1, 1038, 1039, 1045, 1046, 1052, 1053, 
                        -1, 1039, 1040, 1046, 1047, 1053, 1054, -1, 1054, 1047, 
                        1048, 1041, 1042, -1, 1041, 1047, 1040, -1,             
    };

// Simpler to draw count/data format of the teapot_indicies array above.
short new_teapot_indicies[] = {
	26, 1122, 1243, 1272, 1242, 1273, 1241, 1274, 1240, 1275, 1239, 1276, 1238, 1277, 1205, 1278, 1204, 1279, 1203, 1280, 1202, 1281, 1201, 1282, 1200, 1283, 1199, 
	26, 1243, 1249, 1242, 1248, 1241, 1247, 1240, 1246, 1239, 1245, 1238, 1244, 1205, 1212, 1204, 1211, 1203, 1210, 1202, 1209, 1201, 1208, 1200, 1207, 1199, 1206, 
	26, 1249, 1136, 1248, 1254, 1247, 1253, 1246, 1252, 1245, 1251, 1244, 1250, 1212, 1218, 1211, 1217, 1210, 1216, 1209, 1215, 1208, 1214, 1207, 1213, 1206, 1180, 
	26, 1136, 1260, 1254, 1259, 1253, 1258, 1252, 1257, 1251, 1256, 1250, 1255, 1218, 1225, 1217, 1224, 1216, 1223, 1215, 1222, 1214, 1221, 1213, 1220, 1180, 1219, 
	26, 1260, 1266, 1259, 1265, 1258, 1264, 1257, 1263, 1256, 1262, 1255, 1261, 1225, 1232, 1224, 1231, 1223, 1230, 1222, 1229, 1221, 1228, 1220, 1227, 1219, 1226, 
	26, 1266, 384, 1265, 1271, 1264, 1270, 1263, 1269, 1262, 1268, 1261, 1267, 1232, 390, 1231, 1237, 1230, 1236, 1229, 1235, 1228, 1234, 1227, 1233, 1226, 426, 
	14, 462, 1188, 1195, 1189, 1196, 1190, 459, 1191, 1197, 1192, 1198, 1193, 426, 1194, 
	14, 1188, 1181, 1189, 1182, 1190, 1183, 1191, 1184, 1192, 1185, 1193, 1186, 1194, 1187, 
	14, 1181, 1142, 1182, 1175, 1183, 1176, 1184, 1177, 1185, 1178, 1186, 1179, 1187, 1284, 
	14, 1142, 1168, 1175, 1169, 1176, 1170, 1177, 1171, 1178, 1172, 1179, 1173, 1284, 1174, 
	14, 1168, 1161, 1169, 1162, 1170, 1163, 1171, 1164, 1172, 1165, 1173, 1166, 1174, 1167, 
	14, 1161, 1285, 1162, 1286, 1163, 1287, 1164, 1288, 1165, 1289, 1166, 1290, 1167, 1291, 
	14, 384, 1150, 1157, 1151, 1158, 1152, 490, 1153, 1159, 1154, 1160, 1155, 462, 1156, 
	14, 1150, 1143, 1151, 1144, 1152, 1145, 1153, 1146, 1154, 1147, 1155, 1148, 1156, 1149, 
	14, 1143, 1292, 1144, 1137, 1145, 1138, 1146, 1139, 1147, 1140, 1148, 1141, 1149, 1142, 
	14, 1292, 1129, 1137, 1130, 1138, 1131, 1139, 1132, 1140, 1133, 1141, 1134, 1142, 1135, 
	14, 1129, 1121, 1130, 1123, 1131, 1124, 1132, 1125, 1133, 1126, 1134, 1127, 1135, 1128, 
	14, 1121, 1293, 1123, 1294, 1124, 1295, 1125, 1296, 1126, 1297, 1127, 1298, 1128, 1285, 
	26, 902, 1024, 901, 1023, 900, 1022, 899, 1021, 898, 1020, 897, 1019, 862, 983, 861, 982, 860, 981, 859, 980, 858, 979, 857, 978, 856, 977, 
	14, 856, 849, 857, 850, 858, 851, 1299, 852, 1300, 853, 1301, 854, 1302, 855, 
	14, 849, 842, 850, 843, 851, 844, 852, 845, 853, 846, 854, 847, 855, 848, 
	14, 842, 835, 843, 836, 844, 837, 845, 838, 846, 839, 847, 840, 848, 841, 
	14, 835, 828, 836, 829, 837, 830, 838, 831, 839, 832, 840, 833, 841, 834, 
	14, 828, 818, 829, 820, 830, 822, 831, 824, 832, 825, 833, 826, 834, 827, 
	14, 818, 819, 820, 821, 822, 823, 824, 1303, 825, 1304, 826, 1305, 827, 1306, 
	26, 1307, 948, 1308, 947, 1309, 946, 1310, 945, 1311, 944, 1312, 943, 1313, 909, 1314, 908, 1315, 907, 1316, 906, 1317, 905, 1318, 904, 1319, 903, 
	26, 948, 954, 947, 953, 946, 952, 945, 951, 944, 950, 943, 949, 909, 916, 908, 915, 907, 914, 906, 913, 905, 912, 904, 911, 903, 910, 
	26, 954, 835, 953, 959, 952, 958, 951, 957, 950, 956, 949, 955, 916, 922, 915, 921, 914, 920, 913, 919, 912, 918, 911, 917, 910, 882, 
	26, 835, 965, 959, 964, 958, 963, 957, 962, 956, 961, 955, 960, 922, 929, 921, 928, 920, 927, 919, 926, 918, 925, 917, 924, 882, 923, 
	26, 965, 971, 964, 970, 963, 969, 962, 968, 961, 967, 960, 966, 929, 936, 928, 935, 927, 934, 926, 933, 925, 932, 924, 931, 923, 930, 
	26, 971, 856, 970, 976, 969, 975, 968, 974, 967, 973, 966, 972, 936, 942, 935, 941, 934, 940, 933, 939, 932, 938, 931, 937, 930, 902, 
	26, 856, 977, 976, 1095, 1320, 1094, 974, 1093, 1321, 1092, 1322, 1091, 1323, 1060, 1324, 1059, 1325, 1058, 939, 1057, 1326, 1056, 937, 1055, 902, 1024, 
	14, 1302, 890, 1327, 891, 1328, 892, 1329, 893, 900, 894, 901, 895, 902, 896, 
	14, 890, 883, 891, 884, 892, 885, 893, 886, 894, 887, 895, 888, 896, 889, 
	14, 883, 841, 884, 877, 885, 878, 886, 879, 887, 880, 888, 881, 889, 882, 
	14, 841, 870, 877, 871, 878, 872, 879, 873, 880, 874, 881, 875, 882, 876, 
	14, 870, 863, 871, 864, 872, 865, 873, 866, 874, 867, 875, 868, 876, 869, 
	14, 863, 1330, 864, 1331, 865, 1332, 866, 1333, 867, 1334, 868, 1335, 869, 1336, 
	26, 787, 780, 813, 808, 814, 809, 815, 810, 816, 811, 817, 812, 781, 774, 782, 775, 783, 776, 784, 777, 785, 778, 786, 779, 787, 780, 
	14, 774, 767, 775, 768, 776, 769, 777, 770, 778, 771, 779, 772, 780, 773, 
	26, 767, 760, 768, 761, 769, 762, 770, 763, 771, 764, 772, 765, 773, 766, 803, 798, 804, 799, 805, 800, 806, 801, 807, 802, 767, 760, 
	14, 767, 774, 807, 812, 806, 811, 805, 810, 804, 809, 803, 808, 773, 780, 
	26, 760, 753, 761, 754, 762, 755, 763, 756, 764, 757, 765, 758, 766, 759, 798, 793, 799, 794, 800, 795, 801, 796, 802, 797, 760, 753, 
	14, 759, 752, 793, 788, 794, 789, 795, 790, 796, 791, 797, 792, 753, 746, 
	26, 752, 703, 788, 741, 789, 742, 790, 743, 791, 744, 792, 745, 746, 697, 747, 698, 748, 699, 749, 700, 750, 701, 751, 702, 752, 703, 
	14, 752, 759, 751, 758, 750, 757, 749, 756, 748, 755, 747, 754, 746, 753, 
	14, 703, 734, 1337, 735, 742, 736, 743, 737, 744, 738, 1338, 739, 1339, 740, 
	14, 734, 727, 735, 728, 736, 729, 737, 730, 738, 731, 739, 732, 740, 733, 
	14, 727, 682, 728, 722, 729, 723, 730, 724, 731, 725, 732, 726, 733, 676, 
	14, 682, 716, 722, 717, 723, 718, 724, 719, 725, 720, 726, 721, 676, 669, 
	14, 716, 704, 717, 705, 718, 707, 719, 709, 720, 711, 721, 713, 669, 715, 
	14, 704, 668, 705, 706, 707, 708, 709, 710, 711, 712, 713, 714, 715, 656, 
	14, 1339, 690, 698, 691, 1340, 692, 700, 693, 701, 694, 702, 695, 703, 696, 
	14, 690, 683, 691, 684, 692, 685, 693, 686, 694, 687, 695, 688, 696, 689, 
	14, 683, 676, 684, 677, 685, 678, 686, 679, 687, 680, 688, 681, 689, 682, 
	14, 676, 669, 677, 670, 678, 671, 679, 672, 680, 673, 681, 674, 682, 675, 
	14, 669, 655, 670, 657, 671, 659, 672, 661, 673, 663, 674, 665, 675, 667, 
	14, 655, 656, 657, 658, 659, 660, 661, 662, 663, 664, 665, 666, 667, 668, 
	14, 624, 618, 650, 645, 651, 646, 652, 647, 653, 648, 654, 649, 266, 612, 
	14, 266, 612, 619, 613, 620, 614, 621, 615, 622, 616, 623, 617, 624, 618, 
	26, 612, 605, 613, 606, 614, 607, 615, 608, 616, 609, 617, 610, 618, 611, 645, 640, 646, 641, 647, 642, 648, 643, 649, 644, 612, 605, 
	26, 605, 598, 606, 599, 607, 600, 608, 601, 609, 602, 610, 603, 611, 604, 640, 635, 641, 636, 642, 637, 643, 638, 644, 639, 605, 598, 
	14, 604, 597, 635, 630, 636, 631, 637, 632, 638, 633, 639, 634, 598, 591, 
	14, 597, 590, 630, 625, 631, 626, 632, 627, 633, 628, 634, 629, 591, 584, 
	26, 590, 541, 625, 579, 626, 580, 627, 581, 628, 582, 629, 583, 584, 535, 585, 536, 586, 537, 587, 538, 588, 539, 589, 540, 590, 541, 
	14, 590, 597, 589, 596, 588, 595, 587, 594, 586, 593, 585, 592, 584, 591, 
	14, 597, 604, 596, 603, 595, 602, 594, 601, 593, 600, 592, 599, 591, 598, 
	14, 541, 572, 579, 573, 580, 574, 581, 575, 582, 576, 583, 577, 535, 578, 
	14, 572, 565, 573, 566, 574, 567, 575, 568, 576, 569, 577, 570, 578, 571, 
	14, 565, 520, 566, 560, 567, 561, 568, 562, 569, 563, 570, 564, 571, 514, 
	14, 520, 553, 560, 554, 561, 555, 562, 556, 563, 557, 564, 558, 514, 559, 
	14, 553, 505, 554, 542, 555, 544, 556, 546, 557, 548, 558, 550, 559, 552, 
	14, 505, 506, 542, 543, 544, 545, 546, 547, 548, 549, 550, 551, 552, 494, 
	14, 535, 528, 536, 529, 537, 530, 538, 531, 539, 532, 540, 533, 541, 534, 
	14, 528, 521, 529, 522, 530, 523, 531, 524, 532, 525, 533, 526, 534, 527, 
	14, 521, 514, 522, 515, 523, 516, 524, 517, 525, 518, 526, 519, 527, 520, 
	14, 514, 507, 515, 508, 516, 509, 517, 510, 518, 511, 519, 512, 520, 513, 
	14, 507, 493, 508, 495, 509, 497, 510, 499, 511, 501, 512, 503, 513, 1341, 
	14, 493, 494, 495, 496, 497, 498, 499, 500, 501, 502, 503, 504, 1341, 506, 
	26, 216, 349, 348, 467, 347, 466, 346, 465, 345, 464, 344, 463, 310, 432, 309, 431, 308, 430, 307, 429, 306, 428, 305, 427, 1342, 396, 
	26, 349, 356, 467, 472, 466, 471, 465, 470, 464, 469, 463, 468, 432, 438, 431, 437, 430, 436, 429, 435, 428, 434, 427, 433, 396, 402, 
	26, 356, 363, 472, 477, 471, 476, 470, 475, 469, 474, 468, 473, 438, 444, 437, 443, 436, 442, 435, 441, 434, 440, 433, 439, 402, 408, 
	26, 363, 370, 477, 482, 476, 481, 475, 480, 474, 479, 473, 478, 444, 450, 443, 449, 442, 448, 441, 447, 440, 446, 439, 445, 408, 414, 
	26, 370, 377, 482, 487, 481, 486, 480, 485, 479, 484, 478, 483, 450, 456, 449, 455, 448, 454, 447, 453, 446, 452, 445, 451, 414, 420, 
	26, 377, 384, 487, 492, 486, 491, 485, 490, 484, 489, 483, 488, 456, 462, 455, 461, 454, 460, 453, 459, 452, 458, 451, 457, 420, 426, 
	26, 1342, 396, 265, 395, 264, 394, 263, 393, 262, 392, 261, 391, 222, 355, 221, 354, 220, 353, 219, 352, 218, 351, 217, 350, 216, 349, 
	26, 396, 1343, 395, 401, 394, 400, 393, 399, 392, 398, 391, 397, 355, 362, 354, 361, 353, 360, 352, 359, 351, 358, 350, 357, 349, 1344, 
	26, 1343, 1345, 401, 407, 400, 406, 399, 405, 398, 404, 397, 403, 362, 369, 361, 368, 360, 367, 359, 366, 358, 365, 357, 364, 1344, 1346, 
	26, 1345, 1347, 407, 413, 406, 412, 405, 411, 404, 410, 403, 409, 369, 376, 368, 375, 367, 374, 366, 373, 365, 372, 364, 371, 1346, 1348, 
	26, 1347, 1349, 413, 419, 412, 418, 411, 417, 410, 416, 409, 415, 376, 383, 375, 382, 374, 381, 373, 380, 372, 379, 371, 378, 1348, 1350, 
	26, 1349, 426, 419, 425, 418, 424, 417, 423, 416, 422, 415, 421, 383, 390, 382, 389, 381, 388, 380, 387, 379, 386, 378, 385, 1350, 384, 
	26, 42, 320, 319, 318, 317, 316, 174, 315, 314, 313, 312, 311, 137, 277, 276, 275, 274, 273, 134, 272, 271, 270, 269, 268, 92, 267, 
	26, 320, 326, 318, 325, 316, 324, 315, 323, 313, 322, 311, 321, 277, 284, 275, 283, 273, 282, 272, 281, 270, 280, 268, 279, 267, 278, 
	26, 326, 195, 325, 331, 324, 330, 323, 329, 322, 328, 321, 327, 284, 290, 283, 289, 282, 288, 281, 287, 280, 286, 279, 285, 278, 246, 
	26, 195, 337, 331, 336, 330, 335, 329, 334, 328, 333, 327, 332, 290, 297, 289, 296, 288, 295, 287, 294, 286, 293, 285, 292, 246, 291, 
	26, 337, 343, 336, 342, 335, 341, 334, 340, 333, 339, 332, 338, 297, 304, 296, 303, 295, 302, 294, 301, 293, 300, 292, 299, 291, 298, 
	26, 343, 216, 342, 348, 341, 347, 340, 346, 339, 345, 338, 344, 304, 310, 303, 309, 302, 308, 301, 307, 300, 306, 299, 305, 298, 1342, 
	14, 222, 254, 261, 255, 262, 256, 263, 257, 264, 258, 265, 259, 1342, 260, 
	14, 254, 247, 255, 248, 256, 249, 257, 250, 258, 251, 259, 252, 260, 253, 
	14, 247, 201, 248, 241, 249, 242, 250, 243, 251, 244, 252, 245, 253, 246, 
	14, 201, 234, 241, 235, 242, 236, 243, 237, 244, 238, 245, 239, 246, 240, 
	14, 234, 223, 235, 224, 236, 226, 237, 228, 238, 229, 239, 231, 240, 233, 
	14, 223, 48, 224, 225, 226, 227, 228, 89, 229, 230, 231, 232, 233, 92, 
	14, 216, 209, 1351, 210, 218, 211, 219, 212, 220, 213, 221, 214, 222, 215, 
	14, 209, 202, 210, 203, 211, 204, 212, 205, 213, 206, 214, 207, 215, 208, 
	14, 202, 195, 203, 196, 204, 197, 205, 198, 206, 199, 207, 200, 208, 201, 
	14, 195, 188, 196, 189, 197, 190, 198, 191, 199, 192, 200, 193, 201, 194, 
	14, 188, 177, 189, 178, 190, 180, 191, 182, 192, 183, 193, 185, 194, 187, 
	14, 177, 42, 178, 179, 180, 181, 182, 45, 183, 184, 185, 186, 187, 48, 
	26, 1, 148, 147, 146, 145, 144, 143, 142, 141, 140, 139, 138, 105, 104, 103, 102, 101, 100, 99, 98, 97, 96, 95, 94, 60, 93, 
	26, 148, 154, 146, 153, 144, 152, 142, 151, 140, 150, 138, 149, 104, 112, 102, 111, 100, 110, 98, 109, 96, 108, 94, 107, 93, 106, 
	26, 154, 21, 153, 159, 152, 158, 151, 157, 150, 156, 149, 155, 112, 118, 111, 117, 110, 116, 109, 115, 108, 114, 107, 113, 106, 72, 
	26, 21, 165, 159, 164, 158, 163, 157, 162, 156, 161, 155, 160, 118, 124, 117, 123, 116, 122, 115, 121, 114, 120, 113, 119, 72, 79, 
	26, 165, 171, 164, 170, 163, 169, 162, 168, 161, 167, 160, 166, 124, 131, 123, 130, 122, 129, 121, 128, 120, 127, 119, 126, 79, 125, 
	26, 171, 1352, 170, 176, 169, 175, 168, 1353, 167, 173, 166, 172, 131, 1354, 130, 136, 129, 135, 128, 1355, 127, 133, 126, 132, 125, 1356, 
	14, 1357, 80, 87, 81, 88, 82, 1358, 83, 90, 84, 91, 85, 1356, 86, 
	14, 80, 73, 81, 74, 82, 75, 83, 76, 84, 77, 85, 78, 86, 1359, 
	14, 73, 27, 74, 67, 75, 68, 76, 69, 77, 70, 78, 71, 1359, 72, 
	14, 27, 20, 67, 61, 68, 62, 69, 63, 70, 64, 71, 65, 72, 66, 
	14, 20, 12, 61, 49, 62, 51, 63, 53, 64, 55, 65, 57, 66, 59, 
	14, 12, 13, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 
	14, 1352, 35, 43, 36, 44, 37, 1360, 38, 46, 39, 47, 40, 1357, 41, 
	14, 35, 28, 36, 29, 37, 30, 38, 31, 39, 32, 40, 33, 41, 34, 
	14, 28, 21, 29, 22, 30, 23, 31, 24, 32, 25, 33, 26, 34, 27, 
	14, 21, 14, 22, 15, 23, 16, 24, 17, 25, 18, 26, 19, 27, 20, 
	14, 14, 0, 15, 2, 16, 4, 17, 6, 18, 8, 19, 10, 20, 1361, 
	14, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 1361, 13, 
	12, 1024, 1055, 1061, 1062, 1068, 1069, 1075, 1076, 1082, 1083, 1089, 1090, 
	12, 1089, 1088, 1082, 1081, 1075, 1074, 1068, 1067, 1061, 1030, 1024, 1023, 
	9, 1030, 1067, 1036, 1073, 1042, 1079, 1048, 1085, 1054, 
	7, 1085, 1079, 1086, 1080, 1087, 1081, 1088, 
	5, 1081, 1080, 1074, 1073, 1067, 
	3, 1080, 1079, 1073, 
	12, 1055, 1056, 1062, 1063, 1069, 1070, 1076, 1077, 1083, 1084, 1090, 1116, 
	12, 1056, 1057, 1063, 1064, 1070, 1071, 1077, 1078, 1084, 1111, 1116, 1117, 
	12, 1057, 1058, 1064, 1065, 1071, 1072, 1078, 1106, 1111, 1112, 1117, 1118, 
	12, 1058, 1059, 1065, 1066, 1072, 1101, 1106, 1107, 1112, 1113, 1118, 1119, 
	12, 1059, 1060, 1066, 1096, 1101, 1102, 1107, 1108, 1113, 1114, 1119, 1120, 
	12, 1060, 1091, 1096, 1097, 1102, 1103, 1108, 1109, 1114, 1115, 1120, 1012, 
	12, 1091, 1092, 1097, 1098, 1103, 1104, 1109, 1110, 1115, 1005, 1012, 1013, 
	12, 1092, 1093, 1098, 1099, 1104, 1105, 1110, 998, 1005, 1006, 1013, 1014, 
	7, 998, 1105, 991, 1100, 984, 1095, 977, 
	5, 1095, 1100, 1094, 1099, 1093, 
	3, 1100, 1105, 1099, 
	25, 984, 977, 985, 978, 986, 979, 987, 980, 988, 981, 989, 982, 990, 983, 1025, 1019, 1026, 1020, 1027, 1021, 1028, 1022, 1029, 1023, 1030, 
	26, 1030, 1362, 1029, 1035, 1028, 1034, 1027, 1033, 1026, 1032, 1025, 1031, 990, 997, 989, 996, 988, 995, 987, 994, 986, 993, 985, 992, 984, 1363, 
	26, 1362, 1042, 1035, 1041, 1034, 1040, 1033, 1039, 1032, 1038, 1031, 1037, 997, 1004, 996, 1003, 995, 1002, 994, 1001, 993, 1000, 992, 999, 1363, 998, 
	6, 998, 999, 1006, 1007, 1014, 1015, 
	6, 999, 1000, 1007, 1008, 1015, 1016, 
	6, 1000, 1001, 1008, 1009, 1016, 1017, 
	6, 1001, 1002, 1009, 1010, 1017, 1018, 
	6, 1002, 1003, 1010, 1011, 1018, 1049, 
	6, 1003, 1004, 1011, 1043, 1049, 1050, 
	6, 1004, 1037, 1043, 1044, 1050, 1051, 
	6, 1037, 1038, 1044, 1045, 1051, 1052, 
	6, 1038, 1039, 1045, 1046, 1052, 1053, 
	6, 1039, 1040, 1046, 1047, 1053, 1054, 
	5, 1054, 1047, 1048, 1041, 1042, 
	3, 1041, 1047, 1040, 
};

short new_teapot_indicies2[] = {
	1122, 1243, 1272, 1242, 1273, 1241, 1274, 1240, 1275, 1239, 1276, 1238, 1277, 1205, 1278, 1204, 1279, 1203, 1280, 1202, 1281, 1201, 1282, 1200, 1283, 1199, 
	1243, 1249, 1242, 1248, 1241, 1247, 1240, 1246, 1239, 1245, 1238, 1244, 1205, 1212, 1204, 1211, 1203, 1210, 1202, 1209, 1201, 1208, 1200, 1207, 1199, 1206, 
	1249, 1136, 1248, 1254, 1247, 1253, 1246, 1252, 1245, 1251, 1244, 1250, 1212, 1218, 1211, 1217, 1210, 1216, 1209, 1215, 1208, 1214, 1207, 1213, 1206, 1180, 
	1136, 1260, 1254, 1259, 1253, 1258, 1252, 1257, 1251, 1256, 1250, 1255, 1218, 1225, 1217, 1224, 1216, 1223, 1215, 1222, 1214, 1221, 1213, 1220, 1180, 1219, 
	1260, 1266, 1259, 1265, 1258, 1264, 1257, 1263, 1256, 1262, 1255, 1261, 1225, 1232, 1224, 1231, 1223, 1230, 1222, 1229, 1221, 1228, 1220, 1227, 1219, 1226, 
	1266, 384, 1265, 1271, 1264, 1270, 1263, 1269, 1262, 1268, 1261, 1267, 1232, 390, 1231, 1237, 1230, 1236, 1229, 1235, 1228, 1234, 1227, 1233, 1226, 426, 
	462, 1188, 1195, 1189, 1196, 1190, 459, 1191, 1197, 1192, 1198, 1193, 426, 1194, 
	1188, 1181, 1189, 1182, 1190, 1183, 1191, 1184, 1192, 1185, 1193, 1186, 1194, 1187, 
	1181, 1142, 1182, 1175, 1183, 1176, 1184, 1177, 1185, 1178, 1186, 1179, 1187, 1284, 
	1142, 1168, 1175, 1169, 1176, 1170, 1177, 1171, 1178, 1172, 1179, 1173, 1284, 1174, 
	1168, 1161, 1169, 1162, 1170, 1163, 1171, 1164, 1172, 1165, 1173, 1166, 1174, 1167, 
	1161, 1285, 1162, 1286, 1163, 1287, 1164, 1288, 1165, 1289, 1166, 1290, 1167, 1291, 
	384, 1150, 1157, 1151, 1158, 1152, 490, 1153, 1159, 1154, 1160, 1155, 462, 1156, 
	1150, 1143, 1151, 1144, 1152, 1145, 1153, 1146, 1154, 1147, 1155, 1148, 1156, 1149, 
	1143, 1292, 1144, 1137, 1145, 1138, 1146, 1139, 1147, 1140, 1148, 1141, 1149, 1142, 
	1292, 1129, 1137, 1130, 1138, 1131, 1139, 1132, 1140, 1133, 1141, 1134, 1142, 1135, 
	1129, 1121, 1130, 1123, 1131, 1124, 1132, 1125, 1133, 1126, 1134, 1127, 1135, 1128, 
	1121, 1293, 1123, 1294, 1124, 1295, 1125, 1296, 1126, 1297, 1127, 1298, 1128, 1285, 
	902, 1024, 901, 1023, 900, 1022, 899, 1021, 898, 1020, 897, 1019, 862, 983, 861, 982, 860, 981, 859, 980, 858, 979, 857, 978, 856, 977, 
	856, 849, 857, 850, 858, 851, 1299, 852, 1300, 853, 1301, 854, 1302, 855, 
	849, 842, 850, 843, 851, 844, 852, 845, 853, 846, 854, 847, 855, 848, 
	842, 835, 843, 836, 844, 837, 845, 838, 846, 839, 847, 840, 848, 841, 
	835, 828, 836, 829, 837, 830, 838, 831, 839, 832, 840, 833, 841, 834, 
	828, 818, 829, 820, 830, 822, 831, 824, 832, 825, 833, 826, 834, 827, 
	818, 819, 820, 821, 822, 823, 824, 1303, 825, 1304, 826, 1305, 827, 1306, 
	1307, 948, 1308, 947, 1309, 946, 1310, 945, 1311, 944, 1312, 943, 1313, 909, 1314, 908, 1315, 907, 1316, 906, 1317, 905, 1318, 904, 1319, 903, 
	948, 954, 947, 953, 946, 952, 945, 951, 944, 950, 943, 949, 909, 916, 908, 915, 907, 914, 906, 913, 905, 912, 904, 911, 903, 910, 
	954, 835, 953, 959, 952, 958, 951, 957, 950, 956, 949, 955, 916, 922, 915, 921, 914, 920, 913, 919, 912, 918, 911, 917, 910, 882, 
	835, 965, 959, 964, 958, 963, 957, 962, 956, 961, 955, 960, 922, 929, 921, 928, 920, 927, 919, 926, 918, 925, 917, 924, 882, 923, 
	965, 971, 964, 970, 963, 969, 962, 968, 961, 967, 960, 966, 929, 936, 928, 935, 927, 934, 926, 933, 925, 932, 924, 931, 923, 930, 
	971, 856, 970, 976, 969, 975, 968, 974, 967, 973, 966, 972, 936, 942, 935, 941, 934, 940, 933, 939, 932, 938, 931, 937, 930, 902, 
	856, 977, 976, 1095, 1320, 1094, 974, 1093, 1321, 1092, 1322, 1091, 1323, 1060, 1324, 1059, 1325, 1058, 939, 1057, 1326, 1056, 937, 1055, 902, 1024, 
	1302, 890, 1327, 891, 1328, 892, 1329, 893, 900, 894, 901, 895, 902, 896, 
	890, 883, 891, 884, 892, 885, 893, 886, 894, 887, 895, 888, 896, 889, 
	883, 841, 884, 877, 885, 878, 886, 879, 887, 880, 888, 881, 889, 882, 
	841, 870, 877, 871, 878, 872, 879, 873, 880, 874, 881, 875, 882, 876, 
	870, 863, 871, 864, 872, 865, 873, 866, 874, 867, 875, 868, 876, 869, 
	863, 1330, 864, 1331, 865, 1332, 866, 1333, 867, 1334, 868, 1335, 869, 1336, 
	787, 780, 813, 808, 814, 809, 815, 810, 816, 811, 817, 812, 781, 774, 782, 775, 783, 776, 784, 777, 785, 778, 786, 779, 787, 780, 
	774, 767, 775, 768, 776, 769, 777, 770, 778, 771, 779, 772, 780, 773, 
	767, 760, 768, 761, 769, 762, 770, 763, 771, 764, 772, 765, 773, 766, 803, 798, 804, 799, 805, 800, 806, 801, 807, 802, 767, 760, 
	767, 774, 807, 812, 806, 811, 805, 810, 804, 809, 803, 808, 773, 780, 
	760, 753, 761, 754, 762, 755, 763, 756, 764, 757, 765, 758, 766, 759, 798, 793, 799, 794, 800, 795, 801, 796, 802, 797, 760, 753, 
	759, 752, 793, 788, 794, 789, 795, 790, 796, 791, 797, 792, 753, 746, 
	752, 703, 788, 741, 789, 742, 790, 743, 791, 744, 792, 745, 746, 697, 747, 698, 748, 699, 749, 700, 750, 701, 751, 702, 752, 703, 
	752, 759, 751, 758, 750, 757, 749, 756, 748, 755, 747, 754, 746, 753, 
	703, 734, 1337, 735, 742, 736, 743, 737, 744, 738, 1338, 739, 1339, 740, 
	734, 727, 735, 728, 736, 729, 737, 730, 738, 731, 739, 732, 740, 733, 
	727, 682, 728, 722, 729, 723, 730, 724, 731, 725, 732, 726, 733, 676, 
	682, 716, 722, 717, 723, 718, 724, 719, 725, 720, 726, 721, 676, 669, 
	716, 704, 717, 705, 718, 707, 719, 709, 720, 711, 721, 713, 669, 715, 
	704, 668, 705, 706, 707, 708, 709, 710, 711, 712, 713, 714, 715, 656, 
	1339, 690, 698, 691, 1340, 692, 700, 693, 701, 694, 702, 695, 703, 696, 
	690, 683, 691, 684, 692, 685, 693, 686, 694, 687, 695, 688, 696, 689, 
	683, 676, 684, 677, 685, 678, 686, 679, 687, 680, 688, 681, 689, 682, 
	676, 669, 677, 670, 678, 671, 679, 672, 680, 673, 681, 674, 682, 675, 
	669, 655, 670, 657, 671, 659, 672, 661, 673, 663, 674, 665, 675, 667, 
	655, 656, 657, 658, 659, 660, 661, 662, 663, 664, 665, 666, 667, 668, 
	624, 618, 650, 645, 651, 646, 652, 647, 653, 648, 654, 649, 266, 612, 
	266, 612, 619, 613, 620, 614, 621, 615, 622, 616, 623, 617, 624, 618, 
	612, 605, 613, 606, 614, 607, 615, 608, 616, 609, 617, 610, 618, 611, 645, 640, 646, 641, 647, 642, 648, 643, 649, 644, 612, 605, 
	605, 598, 606, 599, 607, 600, 608, 601, 609, 602, 610, 603, 611, 604, 640, 635, 641, 636, 642, 637, 643, 638, 644, 639, 605, 598, 
	604, 597, 635, 630, 636, 631, 637, 632, 638, 633, 639, 634, 598, 591, 
	597, 590, 630, 625, 631, 626, 632, 627, 633, 628, 634, 629, 591, 584, 
	590, 541, 625, 579, 626, 580, 627, 581, 628, 582, 629, 583, 584, 535, 585, 536, 586, 537, 587, 538, 588, 539, 589, 540, 590, 541, 
	590, 597, 589, 596, 588, 595, 587, 594, 586, 593, 585, 592, 584, 591, 
	597, 604, 596, 603, 595, 602, 594, 601, 593, 600, 592, 599, 591, 598, 
	541, 572, 579, 573, 580, 574, 581, 575, 582, 576, 583, 577, 535, 578, 
	572, 565, 573, 566, 574, 567, 575, 568, 576, 569, 577, 570, 578, 571, 
	565, 520, 566, 560, 567, 561, 568, 562, 569, 563, 570, 564, 571, 514, 
	520, 553, 560, 554, 561, 555, 562, 556, 563, 557, 564, 558, 514, 559, 
	553, 505, 554, 542, 555, 544, 556, 546, 557, 548, 558, 550, 559, 552, 
	505, 506, 542, 543, 544, 545, 546, 547, 548, 549, 550, 551, 552, 494, 
	535, 528, 536, 529, 537, 530, 538, 531, 539, 532, 540, 533, 541, 534, 
	528, 521, 529, 522, 530, 523, 531, 524, 532, 525, 533, 526, 534, 527, 
	521, 514, 522, 515, 523, 516, 524, 517, 525, 518, 526, 519, 527, 520, 
	514, 507, 515, 508, 516, 509, 517, 510, 518, 511, 519, 512, 520, 513, 
	507, 493, 508, 495, 509, 497, 510, 499, 511, 501, 512, 503, 513, 1341, 
	493, 494, 495, 496, 497, 498, 499, 500, 501, 502, 503, 504, 1341, 506, 
	216, 349, 348, 467, 347, 466, 346, 465, 345, 464, 344, 463, 310, 432, 309, 431, 308, 430, 307, 429, 306, 428, 305, 427, 1342, 396, 
	349, 356, 467, 472, 466, 471, 465, 470, 464, 469, 463, 468, 432, 438, 431, 437, 430, 436, 429, 435, 428, 434, 427, 433, 396, 402, 
	356, 363, 472, 477, 471, 476, 470, 475, 469, 474, 468, 473, 438, 444, 437, 443, 436, 442, 435, 441, 434, 440, 433, 439, 402, 408, 
	363, 370, 477, 482, 476, 481, 475, 480, 474, 479, 473, 478, 444, 450, 443, 449, 442, 448, 441, 447, 440, 446, 439, 445, 408, 414, 
	370, 377, 482, 487, 481, 486, 480, 485, 479, 484, 478, 483, 450, 456, 449, 455, 448, 454, 447, 453, 446, 452, 445, 451, 414, 420, 
	377, 384, 487, 492, 486, 491, 485, 490, 484, 489, 483, 488, 456, 462, 455, 461, 454, 460, 453, 459, 452, 458, 451, 457, 420, 426, 
	1342, 396, 265, 395, 264, 394, 263, 393, 262, 392, 261, 391, 222, 355, 221, 354, 220, 353, 219, 352, 218, 351, 217, 350, 216, 349, 
	396, 1343, 395, 401, 394, 400, 393, 399, 392, 398, 391, 397, 355, 362, 354, 361, 353, 360, 352, 359, 351, 358, 350, 357, 349, 1344, 
	1343, 1345, 401, 407, 400, 406, 399, 405, 398, 404, 397, 403, 362, 369, 361, 368, 360, 367, 359, 366, 358, 365, 357, 364, 1344, 1346, 
	1345, 1347, 407, 413, 406, 412, 405, 411, 404, 410, 403, 409, 369, 376, 368, 375, 367, 374, 366, 373, 365, 372, 364, 371, 1346, 1348, 
	1347, 1349, 413, 419, 412, 418, 411, 417, 410, 416, 409, 415, 376, 383, 375, 382, 374, 381, 373, 380, 372, 379, 371, 378, 1348, 1350, 
	1349, 426, 419, 425, 418, 424, 417, 423, 416, 422, 415, 421, 383, 390, 382, 389, 381, 388, 380, 387, 379, 386, 378, 385, 1350, 384, 
	42, 320, 319, 318, 317, 316, 174, 315, 314, 313, 312, 311, 137, 277, 276, 275, 274, 273, 134, 272, 271, 270, 269, 268, 92, 267, 
	320, 326, 318, 325, 316, 324, 315, 323, 313, 322, 311, 321, 277, 284, 275, 283, 273, 282, 272, 281, 270, 280, 268, 279, 267, 278, 
	326, 195, 325, 331, 324, 330, 323, 329, 322, 328, 321, 327, 284, 290, 283, 289, 282, 288, 281, 287, 280, 286, 279, 285, 278, 246, 
	195, 337, 331, 336, 330, 335, 329, 334, 328, 333, 327, 332, 290, 297, 289, 296, 288, 295, 287, 294, 286, 293, 285, 292, 246, 291, 
	337, 343, 336, 342, 335, 341, 334, 340, 333, 339, 332, 338, 297, 304, 296, 303, 295, 302, 294, 301, 293, 300, 292, 299, 291, 298, 
	343, 216, 342, 348, 341, 347, 340, 346, 339, 345, 338, 344, 304, 310, 303, 309, 302, 308, 301, 307, 300, 306, 299, 305, 298, 1342, 
	222, 254, 261, 255, 262, 256, 263, 257, 264, 258, 265, 259, 1342, 260, 
	254, 247, 255, 248, 256, 249, 257, 250, 258, 251, 259, 252, 260, 253, 
	247, 201, 248, 241, 249, 242, 250, 243, 251, 244, 252, 245, 253, 246, 
	201, 234, 241, 235, 242, 236, 243, 237, 244, 238, 245, 239, 246, 240, 
	234, 223, 235, 224, 236, 226, 237, 228, 238, 229, 239, 231, 240, 233, 
	223, 48, 224, 225, 226, 227, 228, 89, 229, 230, 231, 232, 233, 92, 
	216, 209, 1351, 210, 218, 211, 219, 212, 220, 213, 221, 214, 222, 215, 
	209, 202, 210, 203, 211, 204, 212, 205, 213, 206, 214, 207, 215, 208, 
	202, 195, 203, 196, 204, 197, 205, 198, 206, 199, 207, 200, 208, 201, 
	195, 188, 196, 189, 197, 190, 198, 191, 199, 192, 200, 193, 201, 194, 
	188, 177, 189, 178, 190, 180, 191, 182, 192, 183, 193, 185, 194, 187, 
	177, 42, 178, 179, 180, 181, 182, 45, 183, 184, 185, 186, 187, 48, 
	1, 148, 147, 146, 145, 144, 143, 142, 141, 140, 139, 138, 105, 104, 103, 102, 101, 100, 99, 98, 97, 96, 95, 94, 60, 93, 
	148, 154, 146, 153, 144, 152, 142, 151, 140, 150, 138, 149, 104, 112, 102, 111, 100, 110, 98, 109, 96, 108, 94, 107, 93, 106, 
	154, 21, 153, 159, 152, 158, 151, 157, 150, 156, 149, 155, 112, 118, 111, 117, 110, 116, 109, 115, 108, 114, 107, 113, 106, 72, 
	21, 165, 159, 164, 158, 163, 157, 162, 156, 161, 155, 160, 118, 124, 117, 123, 116, 122, 115, 121, 114, 120, 113, 119, 72, 79, 
	165, 171, 164, 170, 163, 169, 162, 168, 161, 167, 160, 166, 124, 131, 123, 130, 122, 129, 121, 128, 120, 127, 119, 126, 79, 125, 
	171, 1352, 170, 176, 169, 175, 168, 1353, 167, 173, 166, 172, 131, 1354, 130, 136, 129, 135, 128, 1355, 127, 133, 126, 132, 125, 1356, 
	1357, 80, 87, 81, 88, 82, 1358, 83, 90, 84, 91, 85, 1356, 86, 
	80, 73, 81, 74, 82, 75, 83, 76, 84, 77, 85, 78, 86, 1359, 
	73, 27, 74, 67, 75, 68, 76, 69, 77, 70, 78, 71, 1359, 72, 
	27, 20, 67, 61, 68, 62, 69, 63, 70, 64, 71, 65, 72, 66, 
	20, 12, 61, 49, 62, 51, 63, 53, 64, 55, 65, 57, 66, 59, 
	12, 13, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 
	1352, 35, 43, 36, 44, 37, 1360, 38, 46, 39, 47, 40, 1357, 41, 
	35, 28, 36, 29, 37, 30, 38, 31, 39, 32, 40, 33, 41, 34, 
	28, 21, 29, 22, 30, 23, 31, 24, 32, 25, 33, 26, 34, 27, 
	21, 14, 22, 15, 23, 16, 24, 17, 25, 18, 26, 19, 27, 20, 
	14, 0, 15, 2, 16, 4, 17, 6, 18, 8, 19, 10, 20, 1361, 
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 1361, 13, 
	1024, 1055, 1061, 1062, 1068, 1069, 1075, 1076, 1082, 1083, 1089, 1090, 
	1089, 1088, 1082, 1081, 1075, 1074, 1068, 1067, 1061, 1030, 1024, 1023, 
	1030, 1067, 1036, 1073, 1042, 1079, 1048, 1085, 1054, 
	1085, 1079, 1086, 1080, 1087, 1081, 1088, 
	1081, 1080, 1074, 1073, 1067, 
	1080, 1079, 1073, 
	1055, 1056, 1062, 1063, 1069, 1070, 1076, 1077, 1083, 1084, 1090, 1116, 
	1056, 1057, 1063, 1064, 1070, 1071, 1077, 1078, 1084, 1111, 1116, 1117, 
	1057, 1058, 1064, 1065, 1071, 1072, 1078, 1106, 1111, 1112, 1117, 1118, 
	1058, 1059, 1065, 1066, 1072, 1101, 1106, 1107, 1112, 1113, 1118, 1119, 
	1059, 1060, 1066, 1096, 1101, 1102, 1107, 1108, 1113, 1114, 1119, 1120, 
	1060, 1091, 1096, 1097, 1102, 1103, 1108, 1109, 1114, 1115, 1120, 1012, 
	1091, 1092, 1097, 1098, 1103, 1104, 1109, 1110, 1115, 1005, 1012, 1013, 
	1092, 1093, 1098, 1099, 1104, 1105, 1110, 998, 1005, 1006, 1013, 1014, 
	998, 1105, 991, 1100, 984, 1095, 977, 
	1095, 1100, 1094, 1099, 1093, 
	1100, 1105, 1099, 
	984, 977, 985, 978, 986, 979, 987, 980, 988, 981, 989, 982, 990, 983, 1025, 1019, 1026, 1020, 1027, 1021, 1028, 1022, 1029, 1023, 1030, 
	1030, 1362, 1029, 1035, 1028, 1034, 1027, 1033, 1026, 1032, 1025, 1031, 990, 997, 989, 996, 988, 995, 987, 994, 986, 993, 985, 992, 984, 1363, 
	1362, 1042, 1035, 1041, 1034, 1040, 1033, 1039, 1032, 1038, 1031, 1037, 997, 1004, 996, 1003, 995, 1002, 994, 1001, 993, 1000, 992, 999, 1363, 998, 
	998, 999, 1006, 1007, 1014, 1015, 
	999, 1000, 1007, 1008, 1015, 1016, 
	1000, 1001, 1008, 1009, 1016, 1017, 
	1001, 1002, 1009, 1010, 1017, 1018, 
	1002, 1003, 1010, 1011, 1018, 1049, 
	1003, 1004, 1011, 1043, 1049, 1050, 
	1004, 1037, 1043, 1044, 1050, 1051, 
	1037, 1038, 1044, 1045, 1051, 1052, 
	1038, 1039, 1045, 1046, 1052, 1053, 
	1039, 1040, 1046, 1047, 1053, 1054, 
	1054, 1047, 1048, 1041, 1042, 
	1041, 1047, 1040, 
};

short new_teapot_indicies3[] = {
	1122, 1243, 1272, 1242, 1273, 1241, 1274, 1240, 1275, 1239, 1276, 1238, 1277, 1205, 1278, 1204, 1279, 1203, 1280, 1202, 1281, 1201, 1282, 1200, 1283, 1199, 1199,
	1243, 1249, 1242, 1248, 1241, 1247, 1240, 1246, 1239, 1245, 1238, 1244, 1205, 1212, 1204, 1211, 1203, 1210, 1202, 1209, 1201, 1208, 1200, 1207, 1199, 1206, 1206,
	1249, 1136, 1248, 1254, 1247, 1253, 1246, 1252, 1245, 1251, 1244, 1250, 1212, 1218, 1211, 1217, 1210, 1216, 1209, 1215, 1208, 1214, 1207, 1213, 1206, 1180, 1180,
	1136, 1260, 1254, 1259, 1253, 1258, 1252, 1257, 1251, 1256, 1250, 1255, 1218, 1225, 1217, 1224, 1216, 1223, 1215, 1222, 1214, 1221, 1213, 1220, 1180, 1219, 1219,
	1260, 1266, 1259, 1265, 1258, 1264, 1257, 1263, 1256, 1262, 1255, 1261, 1225, 1232, 1224, 1231, 1223, 1230, 1222, 1229, 1221, 1228, 1220, 1227, 1219, 1226, 1226,
	1266, 384, 1265, 1271, 1264, 1270, 1263, 1269, 1262, 1268, 1261, 1267, 1232, 390, 1231, 1237, 1230, 1236, 1229, 1235, 1228, 1234, 1227, 1233, 1226, 426, 426,
	462, 1188, 1195, 1189, 1196, 1190, 459, 1191, 1197, 1192, 1198, 1193, 426, 1194, 1194,
	1188, 1181, 1189, 1182, 1190, 1183, 1191, 1184, 1192, 1185, 1193, 1186, 1194, 1187,  1187,
	1181, 1142, 1182, 1175, 1183, 1176, 1184, 1177, 1185, 1178, 1186, 1179, 1187, 1284, 1284,
	1142, 1168, 1175, 1169, 1176, 1170, 1177, 1171, 1178, 1172, 1179, 1173, 1284, 1174, 1174,
	1168, 1161, 1169, 1162, 1170, 1163, 1171, 1164, 1172, 1165, 1173, 1166, 1174, 1167, 1167,
	1161, 1285, 1162, 1286, 1163, 1287, 1164, 1288, 1165, 1289, 1166, 1290, 1167, 1291, 1291,
	384, 1150, 1157, 1151, 1158, 1152, 490, 1153, 1159, 1154, 1160, 1155, 462, 1156, 1156,
	1150, 1143, 1151, 1144, 1152, 1145, 1153, 1146, 1154, 1147, 1155, 1148, 1156, 1149, 1149,
	1143, 1292, 1144, 1137, 1145, 1138, 1146, 1139, 1147, 1140, 1148, 1141, 1149, 1142, 1142,
	1292, 1129, 1137, 1130, 1138, 1131, 1139, 1132, 1140, 1133, 1141, 1134, 1142, 1135, 1135,
	1129, 1121, 1130, 1123, 1131, 1124, 1132, 1125, 1133, 1126, 1134, 1127, 1135, 1128, 1128,
	1121, 1293, 1123, 1294, 1124, 1295, 1125, 1296, 1126, 1297, 1127, 1298, 1128, 1285, 1285, 
	902, 1024, 901, 1023, 900, 1022, 899, 1021, 898, 1020, 897, 1019, 862, 983, 861, 982, 860, 981, 859, 980, 858, 979, 857, 978, 856, 977, 977,
	856, 849, 857, 850, 858, 851, 1299, 852, 1300, 853, 1301, 854, 1302, 855, 855,
	849, 842, 850, 843, 851, 844, 852, 845, 853, 846, 854, 847, 855, 848, 848,
	842, 835, 843, 836, 844, 837, 845, 838, 846, 839, 847, 840, 848, 841, 841,
	835, 828, 836, 829, 837, 830, 838, 831, 839, 832, 840, 833, 841, 834, 834,
	828, 818, 829, 820, 830, 822, 831, 824, 832, 825, 833, 826, 834, 827, 827,
	818, 819, 820, 821, 822, 823, 824, 1303, 825, 1304, 826, 1305, 827, 1306, 1306,
	1307, 948, 1308, 947, 1309, 946, 1310, 945, 1311, 944, 1312, 943, 1313, 909, 1314, 908, 1315, 907, 1316, 906, 1317, 905, 1318, 904, 1319, 903, 903, 
	948, 954, 947, 953, 946, 952, 945, 951, 944, 950, 943, 949, 909, 916, 908, 915, 907, 914, 906, 913, 905, 912, 904, 911, 903, 910, 910,
	954, 835, 953, 959, 952, 958, 951, 957, 950, 956, 949, 955, 916, 922, 915, 921, 914, 920, 913, 919, 912, 918, 911, 917, 910, 882, 882,
	835, 965, 959, 964, 958, 963, 957, 962, 956, 961, 955, 960, 922, 929, 921, 928, 920, 927, 919, 926, 918, 925, 917, 924, 882, 923, 923,
	965, 971, 964, 970, 963, 969, 962, 968, 961, 967, 960, 966, 929, 936, 928, 935, 927, 934, 926, 933, 925, 932, 924, 931, 923, 930, 930,
	971, 856, 970, 976, 969, 975, 968, 974, 967, 973, 966, 972, 936, 942, 935, 941, 934, 940, 933, 939, 932, 938, 931, 937, 930, 902,902, 
	856, 977, 976, 1095, 1320, 1094, 974, 1093, 1321, 1092, 1322, 1091, 1323, 1060, 1324, 1059, 1325, 1058, 939, 1057, 1326, 1056, 937, 1055, 902, 1024, 1024,
	1302, 890, 1327, 891, 1328, 892, 1329, 893, 900, 894, 901, 895, 902, 896, 896,
	890, 883, 891, 884, 892, 885, 893, 886, 894, 887, 895, 888, 896, 889, 889,
	883, 841, 884, 877, 885, 878, 886, 879, 887, 880, 888, 881, 889, 882, 882,
	841, 870, 877, 871, 878, 872, 879, 873, 880, 874, 881, 875, 882, 876, 876,
	870, 863, 871, 864, 872, 865, 873, 866, 874, 867, 875, 868, 876, 869, 869,
	863, 1330, 864, 1331, 865, 1332, 866, 1333, 867, 1334, 868, 1335, 869, 1336, 1336,
	787, 780, 813, 808, 814, 809, 815, 810, 816, 811, 817, 812, 781, 774, 782, 775, 783, 776, 784, 777, 785, 778, 786, 779, 787, 780, 780,
	774, 767, 775, 768, 776, 769, 777, 770, 778, 771, 779, 772, 780, 773, 773,
	767, 760, 768, 761, 769, 762, 770, 763, 771, 764, 772, 765, 773, 766, 803, 798, 804, 799, 805, 800, 806, 801, 807, 802, 767, 760, 760,
	767, 774, 807, 812, 806, 811, 805, 810, 804, 809, 803, 808, 773, 780, 780,
	760, 753, 761, 754, 762, 755, 763, 756, 764, 757, 765, 758, 766, 759, 798, 793, 799, 794, 800, 795, 801, 796, 802, 797, 760, 753, 753,
	759, 752, 793, 788, 794, 789, 795, 790, 796, 791, 797, 792, 753, 746, 746,
	752, 703, 788, 741, 789, 742, 790, 743, 791, 744, 792, 745, 746, 697, 747, 698, 748, 699, 749, 700, 750, 701, 751, 702, 752, 703, 703,
	752, 759, 751, 758, 750, 757, 749, 756, 748, 755, 747, 754, 746, 753, 753,
	703, 734, 1337, 735, 742, 736, 743, 737, 744, 738, 1338, 739, 1339, 740, 740,
	734, 727, 735, 728, 736, 729, 737, 730, 738, 731, 739, 732, 740, 733, 733,
	727, 682, 728, 722, 729, 723, 730, 724, 731, 725, 732, 726, 733, 676, 676,
	682, 716, 722, 717, 723, 718, 724, 719, 725, 720, 726, 721, 676, 669, 669,
	716, 704, 717, 705, 718, 707, 719, 709, 720, 711, 721, 713, 669, 715, 715,
	704, 668, 705, 706, 707, 708, 709, 710, 711, 712, 713, 714, 715, 656, 656,
	1339, 690, 698, 691, 1340, 692, 700, 693, 701, 694, 702, 695, 703, 696, 696,
	690, 683, 691, 684, 692, 685, 693, 686, 694, 687, 695, 688, 696, 689, 689,
	683, 676, 684, 677, 685, 678, 686, 679, 687, 680, 688, 681, 689, 682, 682,
	676, 669, 677, 670, 678, 671, 679, 672, 680, 673, 681, 674, 682, 675, 675,
	669, 655, 670, 657, 671, 659, 672, 661, 673, 663, 674, 665, 675, 667, 667,
	655, 656, 657, 658, 659, 660, 661, 662, 663, 664, 665, 666, 667, 668, 668,
	624, 618, 650, 645, 651, 646, 652, 647, 653, 648, 654, 649, 266, 612, 612,
	266, 612, 619, 613, 620, 614, 621, 615, 622, 616, 623, 617, 624, 618, 618, 
	612, 605, 613, 606, 614, 607, 615, 608, 616, 609, 617, 610, 618, 611, 645, 640, 646, 641, 647, 642, 648, 643, 649, 644, 612, 605, 605,
	605, 598, 606, 599, 607, 600, 608, 601, 609, 602, 610, 603, 611, 604, 640, 635, 641, 636, 642, 637, 643, 638, 644, 639, 605, 598, 598,
	604, 597, 635, 630, 636, 631, 637, 632, 638, 633, 639, 634, 598, 591, 591,
	597, 590, 630, 625, 631, 626, 632, 627, 633, 628, 634, 629, 591, 584, 584,
	590, 541, 625, 579, 626, 580, 627, 581, 628, 582, 629, 583, 584, 535, 585, 536, 586, 537, 587, 538, 588, 539, 589, 540, 590, 541, 541,
	590, 597, 589, 596, 588, 595, 587, 594, 586, 593, 585, 592, 584, 591,591, 
	597, 604, 596, 603, 595, 602, 594, 601, 593, 600, 592, 599, 591, 598,598, 
	541, 572, 579, 573, 580, 574, 581, 575, 582, 576, 583, 577, 535, 578,578, 
	572, 565, 573, 566, 574, 567, 575, 568, 576, 569, 577, 570, 578, 571,571, 
	565, 520, 566, 560, 567, 561, 568, 562, 569, 563, 570, 564, 571, 514,514, 
	520, 553, 560, 554, 561, 555, 562, 556, 563, 557, 564, 558, 514, 559,559, 
	553, 505, 554, 542, 555, 544, 556, 546, 557, 548, 558, 550, 559, 552,552, 
	505, 506, 542, 543, 544, 545, 546, 547, 548, 549, 550, 551, 552, 494,494, 
	535, 528, 536, 529, 537, 530, 538, 531, 539, 532, 540, 533, 541, 534,534, 
	528, 521, 529, 522, 530, 523, 531, 524, 532, 525, 533, 526, 534, 527,527, 
	521, 514, 522, 515, 523, 516, 524, 517, 525, 518, 526, 519, 527, 520,520, 
	514, 507, 515, 508, 516, 509, 517, 510, 518, 511, 519, 512, 520, 513,513, 	
	507, 493, 508, 495, 509, 497, 510, 499, 511, 501, 512, 503, 513, 1341, 1341,
	493, 494, 495, 496, 497, 498, 499, 500, 501, 502, 503, 504, 1341, 506, 506,
	216, 349, 348, 467, 347, 466, 346, 465, 345, 464, 344, 463, 310, 432, 309, 431, 308, 430, 307, 429, 306, 428, 305, 427, 1342, 396, 396,
	349, 356, 467, 472, 466, 471, 465, 470, 464, 469, 463, 468, 432, 438, 431, 437, 430, 436, 429, 435, 428, 434, 427, 433, 396, 402, 402,
	356, 363, 472, 477, 471, 476, 470, 475, 469, 474, 468, 473, 438, 444, 437, 443, 436, 442, 435, 441, 434, 440, 433, 439, 402, 408, 408,
	363, 370, 477, 482, 476, 481, 475, 480, 474, 479, 473, 478, 444, 450, 443, 449, 442, 448, 441, 447, 440, 446, 439, 445, 408, 414, 414,
	370, 377, 482, 487, 481, 486, 480, 485, 479, 484, 478, 483, 450, 456, 449, 455, 448, 454, 447, 453, 446, 452, 445, 451, 414, 420, 420,
	377, 384, 487, 492, 486, 491, 485, 490, 484, 489, 483, 488, 456, 462, 455, 461, 454, 460, 453, 459, 452, 458, 451, 457, 420, 426, 426,
	1342, 396, 265, 395, 264, 394, 263, 393, 262, 392, 261, 391, 222, 355, 221, 354, 220, 353, 219, 352, 218, 351, 217, 350, 216, 349, 349,
	396, 1343, 395, 401, 394, 400, 393, 399, 392, 398, 391, 397, 355, 362, 354, 361, 353, 360, 352, 359, 351, 358, 350, 357, 349, 1344, 1344,
	1343, 1345, 401, 407, 400, 406, 399, 405, 398, 404, 397, 403, 362, 369, 361, 368, 360, 367, 359, 366, 358, 365, 357, 364, 1344, 1346, 1346,
	1345, 1347, 407, 413, 406, 412, 405, 411, 404, 410, 403, 409, 369, 376, 368, 375, 367, 374, 366, 373, 365, 372, 364, 371, 1346, 1348, 1348,
	1347, 1349, 413, 419, 412, 418, 411, 417, 410, 416, 409, 415, 376, 383, 375, 382, 374, 381, 373, 380, 372, 379, 371, 378, 1348, 1350, 1350,
	1349, 426, 419, 425, 418, 424, 417, 423, 416, 422, 415, 421, 383, 390, 382, 389, 381, 388, 380, 387, 379, 386, 378, 385, 1350, 384, 384,
	42, 320, 319, 318, 317, 316, 174, 315, 314, 313, 312, 311, 137, 277, 276, 275, 274, 273, 134, 272, 271, 270, 269, 268, 92, 267, 267,
	320, 326, 318, 325, 316, 324, 315, 323, 313, 322, 311, 321, 277, 284, 275, 283, 273, 282, 272, 281, 270, 280, 268, 279, 267, 278, 278,
	326, 195, 325, 331, 324, 330, 323, 329, 322, 328, 321, 327, 284, 290, 283, 289, 282, 288, 281, 287, 280, 286, 279, 285, 278, 246, 246,
	195, 337, 331, 336, 330, 335, 329, 334, 328, 333, 327, 332, 290, 297, 289, 296, 288, 295, 287, 294, 286, 293, 285, 292, 246, 291, 291,
	337, 343, 336, 342, 335, 341, 334, 340, 333, 339, 332, 338, 297, 304, 296, 303, 295, 302, 294, 301, 293, 300, 292, 299, 291, 298, 298,
	343, 216, 342, 348, 341, 347, 340, 346, 339, 345, 338, 344, 304, 310, 303, 309, 302, 308, 301, 307, 300, 306, 299, 305, 298, 1342, 1342,
	222, 254, 261, 255, 262, 256, 263, 257, 264, 258, 265, 259, 1342, 260, 260,
	254, 247, 255, 248, 256, 249, 257, 250, 258, 251, 259, 252, 260, 253, 253,
	247, 201, 248, 241, 249, 242, 250, 243, 251, 244, 252, 245, 253, 246, 246,
	201, 234, 241, 235, 242, 236, 243, 237, 244, 238, 245, 239, 246, 240, 240,
	234, 223, 235, 224, 236, 226, 237, 228, 238, 229, 239, 231, 240, 233, 233,
	223, 48, 224, 225, 226, 227, 228, 89, 229, 230, 231, 232, 233, 92, 92,
	216, 209, 1351, 210, 218, 211, 219, 212, 220, 213, 221, 214, 222, 215, 215,
	209, 202, 210, 203, 211, 204, 212, 205, 213, 206, 214, 207, 215, 208, 208,
	202, 195, 203, 196, 204, 197, 205, 198, 206, 199, 207, 200, 208, 201,  201,
	195, 188, 196, 189, 197, 190, 198, 191, 199, 192, 200, 193, 201, 194, 194,
	188, 177, 189, 178, 190, 180, 191, 182, 192, 183, 193, 185, 194, 187, 187,
	177, 42, 178, 179, 180, 181, 182, 45, 183, 184, 185, 186, 187, 48, 48, 
	1, 148, 147, 146, 145, 144, 143, 142, 141, 140, 139, 138, 105, 104, 103, 102, 101, 100, 99, 98, 97, 96, 95, 94, 60, 93, 93,
	148, 154, 146, 153, 144, 152, 142, 151, 140, 150, 138, 149, 104, 112, 102, 111, 100, 110, 98, 109, 96, 108, 94, 107, 93, 106, 106,
	154, 21, 153, 159, 152, 158, 151, 157, 150, 156, 149, 155, 112, 118, 111, 117, 110, 116, 109, 115, 108, 114, 107, 113, 106, 72, 72,
	21, 165, 159, 164, 158, 163, 157, 162, 156, 161, 155, 160, 118, 124, 117, 123, 116, 122, 115, 121, 114, 120, 113, 119, 72, 79, 79,
	165, 171, 164, 170, 163, 169, 162, 168, 161, 167, 160, 166, 124, 131, 123, 130, 122, 129, 121, 128, 120, 127, 119, 126, 79, 125, 125,
	171, 1352, 170, 176, 169, 175, 168, 1353, 167, 173, 166, 172, 131, 1354, 130, 136, 129, 135, 128, 1355, 127, 133, 126, 132, 125, 1356, 1356,
	1357, 80, 87, 81, 88, 82, 1358, 83, 90, 84, 91, 85, 1356, 86, 86,
	80, 73, 81, 74, 82, 75, 83, 76, 84, 77, 85, 78, 86, 1359, 1359, 
	73, 27, 74, 67, 75, 68, 76, 69, 77, 70, 78, 71, 1359, 72, 72,
	27, 20, 67, 61, 68, 62, 69, 63, 70, 64, 71, 65, 72, 66, 66,
	20, 12, 61, 49, 62, 51, 63, 53, 64, 55, 65, 57, 66, 59, 59, 
	12, 13, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 60,
	1352, 35, 43, 36, 44, 37, 1360, 38, 46, 39, 47, 40, 1357, 41, 41,
	35, 28, 36, 29, 37, 30, 38, 31, 39, 32, 40, 33, 41, 34, 34,
	28, 21, 29, 22, 30, 23, 31, 24, 32, 25, 33, 26, 34, 27, 27,
	21, 14, 22, 15, 23, 16, 24, 17, 25, 18, 26, 19, 27, 20, 20,
	14, 0, 15, 2, 16, 4, 17, 6, 18, 8, 19, 10, 20, 1361,1361, 
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 1361, 13, 13,
	1024, 1055, 1061, 1062, 1068, 1069, 1075, 1076, 1082, 1083, 1089, 1090, 1090,
	1089, 1088, 1082, 1081, 1075, 1074, 1068, 1067, 1061, 1030, 1024, 1023,  1023,
	1030, 1067, 1036, 1073, 1042, 1079, 1048, 1085, 1054, 1054,
	1085, 1079, 1086, 1080, 1087, 1081, 1088, 1088,
	1081, 1080, 1074, 1073, 1067, 1067,
	1080, 1079, 1073, 1073,
	1055, 1056, 1062, 1063, 1069, 1070, 1076, 1077, 1083, 1084, 1090, 1116, 1116,
	1056, 1057, 1063, 1064, 1070, 1071, 1077, 1078, 1084, 1111, 1116, 1117, 1117,
	1057, 1058, 1064, 1065, 1071, 1072, 1078, 1106, 1111, 1112, 1117, 1118, 1118,
	1058, 1059, 1065, 1066, 1072, 1101, 1106, 1107, 1112, 1113, 1118, 1119, 1119,
	1059, 1060, 1066, 1096, 1101, 1102, 1107, 1108, 1113, 1114, 1119, 1120, 1120,
	1060, 1091, 1096, 1097, 1102, 1103, 1108, 1109, 1114, 1115, 1120, 1012, 1012,
	1091, 1092, 1097, 1098, 1103, 1104, 1109, 1110, 1115, 1005, 1012, 1013, 1013,
	1092, 1093, 1098, 1099, 1104, 1105, 1110, 998, 1005, 1006, 1013, 1014, 1014,
	998, 1105, 991, 1100, 984, 1095, 977, 977,
	1095, 1100, 1094, 1099, 1093, 1093,
	1100, 1105, 1099, 1099,
	984, 977, 985, 978, 986, 979, 987, 980, 988, 981, 989, 982, 990, 983, 1025, 1019, 1026, 1020, 1027, 1021, 1028, 1022, 1029, 1023, 1030, 1030,
	1030, 1362, 1029, 1035, 1028, 1034, 1027, 1033, 1026, 1032, 1025, 1031, 990, 997, 989, 996, 988, 995, 987, 994, 986, 993, 985, 992, 984, 1363, 1363,
	1362, 1042, 1035, 1041, 1034, 1040, 1033, 1039, 1032, 1038, 1031, 1037, 997, 1004, 996, 1003, 995, 1002, 994, 1001, 993, 1000, 992, 999, 1363, 998, 998,
	998, 999, 1006, 1007, 1014, 1015, 1015, 
	999, 1000, 1007, 1008, 1015, 1016, 1016,
	1000, 1001, 1008, 1009, 1016, 1017, 1017,
	1001, 1002, 1009, 1010, 1017, 1018, 1018,
	1002, 1003, 1010, 1011, 1018, 1049, 1049,
	1003, 1004, 1011, 1043, 1049, 1050, 1050,
	1004, 1037, 1043, 1044, 1050, 1051, 1051,
	1037, 1038, 1044, 1045, 1051, 1052, 1052,
	1038, 1039, 1045, 1046, 1052, 1053, 1053,
	1039, 1040, 1046, 1047, 1053, 1054, 1054,
	1054, 1047, 1048, 1041, 1042, 1042,
	1041, 1047, 1040, 
};


#endif // TEAPOT_H
